/*!
 * 拖动验证码 v1.0.0 (https://www.chinahtz.com)
 * by lifuping
 */
+function (window,document, $) {
    'use strict';
    // var serviceUrl ='https://ipoetestn.szse.cn:10443/iCaptcha/captcha/'
    var HTZValidate = function (elem, options) {
        this.defaultOptions = {
            width : "300px",
            placeholder: "拖动滑块完成上方拼图",
            successMess: "验证通过",
            failMess:"验证失败",
            title:"完成拼图验证",
            refreshText:"刷新",
            loadingText:'加载中...',
            failText:'加载失败',
            //原图宽度 高度 滑块宽度
            imgInfo:{w:590,h:360,ew:93},
            userFontIcon:false,//使用 font-awesome 图标库
            slideSpeed:"normal",//动画参数 毫秒 （比如 1500）"slow" "normal" "fast"
            callback:function (e) { e.preventDefault(); }
        };
        this.warp = $(elem);
        var c = /Mobile/i.test(window.navigator.userAgent),
            h = function() {
                try {
                    return document.createEvent("TouchEvent"), !0
                } catch (e) {
                    return !1
                }
            }();
        this.isMobile=c;
        this.supportTouch=h;
        this.options = $.extend({},this.defaultOptions, this.warp.data(), options);
        this.callback = this.options.callback;
        this.init();
    };
    HTZValidate.prototype = {
        init: function () {
            this.mousePos = [];
            this.disX = 0;
            this.passValidate = false;
            this.token = null;
            this.isDraging = false;
            this.initDom();
            this.getImageData();
            this.bindEvents();
            // this.slideImgWrap.hide();
            this.warp.show();

        },
        initDom: function () {
            var sIcon,rIcon,lIcon;
            if(this.options.userFontIcon){
                sIcon='<i class="fa fa-arrow-right" aria-hidden="true"></i>';
                rIcon='<i class="fa fa-refresh" aria-hidden="true"></i>';
                lIcon='<i class="fa fa-spinner fa-spin fa-3x fa-fw"></i>';
            }else{
                sIcon='<span class="htz-icon htz-icon-arrow"></span>';
                rIcon='<span class="htz-icon htz-icon-refresh"></span>';
                lIcon='<div class="htz-icon-loading"></div>';
            }
            var a='<div class="slide-authcode-wraper">' +
                '<div class="htz-slide" style="width:' + this.options.width + '">' +
                '<div class="htz-img-panel">' +
                '<div class="htz-img-wrap">' +
                '<div class="htz-img-placeholder">' +
                '<div class="htz-bigimg"><img src=""></div>' +
                '<div class="htz-smallimg"><img src=""></div>' +
                '</div>' +
                '<div class="htz-loadbox"><div class="htz-loadbox-inner">'+lIcon+'<span class="htz-loadtext">'+this.options.loadingText+'</span></div></div>'+
                '<div class="htz-refresh" title="'+this.options.refreshText+'">'+rIcon+'</div>'+
                '</div>' +
                '</div>'+
                '<div class="htz-slide-bg">' +
                '<div class="htz-slide-inner htz-slide-text">' +
                '<div class="htz-slide-left"></div>' +
                '<div class="htz-slide-center">' + this.options.placeholder + "</div>" +
                '<div class="htz-slide-right"></div></div>' +
                '<div class="htz-slide-inner htz-slide-bar"><div class="htz-slide-bar-left"></div><div class="htz-slide-bar-center"></div><div class="htz-slide-bar-right"></div></div>' +
                '<div class="htz-slide-inner htz-slide-btn">'+sIcon+'</div></div>' +
                '</div>'+
                '</div>';
            $(a).appendTo(this.warp);
            this.slideWrap = this.warp.find(".htz-slide");
            this.width = this.slideWrap.width();
            this.imgRatio = this.slideWrap.width() ? (this.options.imgInfo.w / this.slideWrap.width()) : 1;
            this.slideBtn = this.warp.find(".htz-slide-btn");
            this.slideGreenBar = this.warp.find(".htz-slide-bar");
            this.slideGreenBarCenter = this.warp.find(".htz-slide-bar-center");
            this.slideSmallImg = this.warp.find(".htz-smallimg");
            this.slideBigImg = this.warp.find(".htz-bigimg");
            this.slideImgWrap = this.warp.find(".htz-img-panel");
            this.refreshBtn = this.slideImgWrap.find(".htz-refresh");
            this.slideText = this.warp.find(".htz-slide-text");
            this.loadingText=this.warp.find(".htz-loadtext");
            this.loadingBox=this.warp.find(".htz-loadbox");
            this.placeholderText=this.warp.find(".htz-slide-center");
            var h=this.options.imgInfo.h / (this.options.imgInfo.w / this.slideWrap.width());
            if(h<150){
                h=150;
            }
            this.slideBigImg.height(h);
            this.loadingBox.height(h);
            this.slideImgWrap.height(h+10);
            //this.slideImgWrap.css({height:(h+10)+"px"});
        },
        bindEvents: function () {
            var $this = this;
            var b_enter=false;
            var b_time=null;
            var mouseenter=function () {
                if(b_enter) return;
                if($this.slideWrap.hasClass("htz-slide-succ")) return;
                b_time=setTimeout(function () {
                    b_enter=true;
                    $this.slideImgWrap.stop().fadeIn($this.options.slideSpeed);
                },200);
            };
            var mouseleave=function () {
                if ($this.passValidate || $this.isDraging) {
                    return
                }
                clearTimeout(b_time);
                b_enter=false;
                $this.slideImgWrap.stop().fadeOut($this.options.slideSpeed);
            };
            $this.slideBtn.on('mousedown',ondown);
            $this.slideBtn.on('touchstart',ondown);
            function ondown(i) {
                if ($this.passValidate) {
                    return 0
                }
                if($this.slideWrap.hasClass("htz-loadfail")){
                    return;
                }
                //支持移动设备和触摸设备
                if($this.isMobile || (!$this.isMobile && $this.supportTouch)){
                    mouseenter();
                }
                $this.slideBtn.addClass("htz-slide-btn-hover");
                $this.isDraging = true;
                var h = i || event;
                if (document.all) {
                    window.event.returnValue = false;
                    window.event.cancelBubble = true
                } else {
                    // 判断默认行为是否可以被禁用
                    if (h.cancelable) {
                        // 判断默认行为是否已经被禁用
                        if (!h.defaultPrevented) {
                            h.preventDefault();
                        }
                    }
                    h.stopPropagation();
                    h.returnValue = false
                }
                if (h.touches) {
                    h = h.touches[0]
                }
                $this.disX = h.clientX;
                $this.slideGreenBar.show();
                $this.mousePos = [];
                $this.mousePos.push([$this.gl($this.slideBtn[0]).toFixed(0), $this.gt($this.slideBtn[0]).toFixed(0), new Date().getTime()]);
                $this.mousePos.push([h.clientX.toFixed(0), h.clientY.toFixed(0), new Date().getTime()]);
                document.onmousemove = onmove;
                document.ontouchmove = onmove;
                document.onmouseup = onup;
                document.ontouchend = onup;
                function onmove(m) {
                    var k = m || event;
                    if (document.all) {
                        window.event.returnValue = false;
                        window.event.cancelBubble = true
                    } else {
                        // 判断默认行为是否可以被禁用
                        if (k.cancelable) {
                            // 判断默认行为是否已经被禁用
                            if (!k.defaultPrevented) {
                                k.preventDefault();
                            }
                        }
                        k.stopPropagation();
                        k.returnValue = false
                    }
                    if (k.touches) {
                        k = k.touches[0]
                    }
                    var l = k.clientX - $this.disX + 40;
                    var n = k.clientX - $this.disX;
                    var j = k.clientX - $this.disX;
                    if (j < 0) {
                        j = 0
                    } else {
                        if (j > $this.width - ($this.options.imgInfo.ew / $this.imgRatio)) {
                            j = $this.width - ($this.options.imgInfo.ew / $this.imgRatio)
                        }
                    }
                    if (n < 0) {
                        n = 0
                    } else {
                        if (n > $this.width - 40) {
                            n = $this.width - 40
                        }
                    }
                    if (l < 44) {
                        l = 44
                    } else {
                        if (l > $this.width) {
                            l = $this.width
                        }
                    }
                    $this.mousePos.push([k.clientX.toFixed(0), k.clientY.toFixed(0), new Date().getTime()]);
                    $this.slideBtn.css({left: n + "px"});
                    $this.slideSmallImg.css({left: j + "px"});
                    $this.slideGreenBar.css({width : l + "px"});
                    return false
                }
                function onup(k) {
                    var j = k || event;
                    if (j.changedTouches) {
                        j = j.changedTouches[0]
                    }

                    $this.isDraging = false;
                    $this.mousePos.push([j.clientX.toFixed(0), j.clientY.toFixed(0), new Date().getTime()]);
                    document.onmousemove = null;
                    document.ontouchmove = null;
                    document.onmouseup = null;
                    document.ontouchend = null;
                    if ($this.mousePos.length <= 3) {
                        $this.slideGreenBar.hide();
                        $this.slideText.removeClass().addClass("htz-slide-inner htz-slide-text");
                        return
                    }
                    $this.slideBtn.removeClass("htz-slide-btn-hover");
                    $this.validImage()
                }
            }
            this.refreshBtn.on('click', function () {
                if ($this.passValidate || $this.isDraging) {
                    return
                }
                $this.getImageData();
            });
            //支持移动设备和触摸设备
            if(this.isMobile || (!$this.isMobile && this.supportTouch)){
                // $(document).on("touchend",function (e) {
                //     // 不在目标区域，隐藏
                //     if (!$this.warp.is(e.target) && $this.warp.has(e.target).length === 0) {
                //         mouseleave();
                //     }
                // });
            }else{
                this.warp.on("mouseenter",mouseenter).on("mouseleave",mouseleave);
            }
            window.onresize = function () {
                $this.resize()
            }
        },
        refresh:function(){
            this.mousePos = [];
            this.disX = 0;
            this.passValidate = false;
            this.isDraging = false;
            this.callbackError();
            this.getImageData();
        },
        getBubblePath : function(e) {
            for (var t = arguments.length > 1 && void 0 !== arguments[1] ? arguments[1] : document, n = [], i = e; i && i !== t;) n.push(i), i = i.parentNode;
            return n
        },
        msie: function r() {
            var e = navigator.userAgent,
                r = parseInt((/msie (\d+)/.exec(e.toLowerCase()) || [])[1]);
            return isNaN(r) && (r = parseInt((/trident\/.*; rv:(\d+)/.exec(e.toLowerCase()) || [])[1])), r
        },
        resize: function () {
            var $this = this;
            if ($this.y) {
                $this.width = $this.slideWrap.width();
                var a = $this.imgRatio,h;
                $this.imgRatio = $this.slideWrap.width() ? ($this.options.imgInfo.w / $this.slideWrap.width()) : 0;
                $this.slideSmallImg.css({top:$this.y / $this.imgRatio + "px",width:$this.options.imgInfo.ew / $this.imgRatio + "px",left:$this.slideSmallImg[0].offsetLeft * a / $this.imgRatio + 15 + "px"});
                h=$this.options.imgInfo.h / ($this.options.imgInfo.w / $this.slideWrap.width());
                $this.slideBigImg.css({height:h+"px"});
                $this.loadingBox.css({height:h+"px"});
                $this.slideImgWrap.css({height:(h+10)+"px"});
            }
        },
        callbackError: function () {
            var $this = this;
            setTimeout(function () {
                $this.slideBtn.removeClass().addClass("htz-slide-inner htz-slide-btn htz-animate-el").css({left:"15px"});
                $this.slideGreenBar.removeClass().addClass("htz-slide-inner htz-slide-bar htz-animate-el").width(0);
                $this.slideText.removeClass().addClass("htz-slide-inner htz-slide-text");
                setTimeout(function () {
                    $this.slideBtn.removeClass().addClass("htz-slide-inner htz-slide-btn");
                    $this.slideGreenBarCenter.html("");
                    $this.slideWrap.removeClass("htz-slide htz-slide-succ htz-slide-err").addClass("htz-slide");
                    $this.slideGreenBar.removeClass().addClass("htz-slide-inner htz-slide-bar");
                }, 200)
            }, 400)
        },
        getImageData: function () {
            var $this = this;
            $.ajax(window.domain.serviceUrl+"generateImage?"+new Date().getTime(), {
                timeout : 5000, //超时时间设置，单位毫秒
                type: 'get',
                data: {},
                beforeSend: function () {
                    $this.loadingText.html($this.options.loadingText);
                    $this.slideWrap.addClass("htz-slide htz-loading");
                },
                success: function (b) {
                    if(typeof  b==="string"){
                        try{
                            b=JSON.parse(b);
                        }catch (e) {
                            b={};
                            b.code=false;
                        }
                    }
                    if(b.code==="600000"){
                        $this.slideBigImg.find('img').attr("src","data:image/png;base64,"+b.data.bg);
                        $this.slideSmallImg.find('img').attr("src","data:image/png;base64,"+b.data.front);
                        $this.slideSmallImg.css({top: b.data.y / $this.imgRatio + "px",width:$this.options.imgInfo.ew / $this.imgRatio + "px",left:0+"px"});
                        $this.y = b.data.y;
                        $this.token = b.data.token;
                        setTimeout(function () {
                            $this.resize();
                        }, 1)
                        $this.slideWrap.removeClass("htz-loadfail");
                    }else{
                        $this.loadingText.html($this.options.failText);
                        $this.slideWrap.removeClass().addClass("htz-slide htz-loadfail");
                    }

                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    $this.loadingText.html($this.options.failText);
                    $this.slideWrap.removeClass().addClass("htz-slide htz-loadfail");
                    checkNetwork();
                },
                complete: function () {
                    $this.slideWrap.removeClass("htz-loading");
                }
            });

        },
        validImage: function () {
            var $this = this;
            var b = $this.mousePos;
            $.ajax(window.domain.serviceUrl+"validImage", {
                type: 'post',
                data: {
                    startXPos:($(".htz-slide-btn")[0].offsetLeft+2).toFixed(0),
                    token: $this.token,
                    width: $this.width ? $this.width.toFixed(0) : 0
                },
                beforeSend: function () {

                },
                success: function (d) {
                    if(typeof  d==="string"){
                        try{
                            d=JSON.parse(d);
                        }catch (e) {
                            d={};
                            d.status=false;
                        }
                    }
                    if (d.code === '600000') {
                        $this.passValidate = true;
                        $this.slideWrap.removeClass().addClass("htz-slide htz-slide-succ");
                        $this.slideGreenBarCenter.html("");
                        $this.placeholderText.html("&nbsp;");

                    } else {
                        $this.slideWrap.addClass("htz-slide-err");
                        $this.slideGreenBarCenter.html($this.options.failMess);
                        setTimeout(function () {
                            $this.getImageData()
                        }, 300);
                        $this.callbackError()
                    }
                    $this.callbackSuccess(d);

                },
                error: function (XMLHttpRequest, textStatus, errorThrown) {
                    $this.slideWrap.removeClass().addClass("htz-slide htz-slide-err");
                    setTimeout(function () {
                        $this.getImageData()
                    }, 300);
                    $this.callbackError()
                    checkNetwork();
                },
                complete: function () {

                }
            });
        },
        callbackSuccess: function (b) {
            var $this=this;
            if (b.code !== '600000') {
                if ($this.options.failCallback) {
                    $this.failCallback(b)
                }
            } else {
                $this.callback(b);
                // setTimeout(function () {
                //     $this.slideImgWrap.stop().slideUp($this.options.slideSpeed);
                // }, 400);
            }
        },

        encode64: function (d) {
            var c = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ-~".split(""),
                b = c.length,
                e = +d,
                a = [],mod;
            do {
                mod = e % b;
                e = (e - mod) / b;
                a.unshift(c[mod])
            } while (e);
            return a.join("")
        },
        pi: function (a, b) {
            return (Array(b).join(0) + a).slice(-b)
        },
        pm: function (d, c, b) {
            var f = this;
            var e = f.encode64(Math.abs(d));
            var a = "";
            if (!b) {
                a += (d > 0 ? "1" : "0")
            }
            a += f.pi(e, c);
            return a
        },
        encodePos: function (c) {
            var g = this;
            var b = [];
            for (var e = 0; e < c.length; e++) {
                if (e === 0) {
                    b.push(g.pm(c[e][0] < 262143 ? c[e][0] : 262143, 3, true));
                    b.push(g.pm(c[e][1] < 16777215 ? c[e][1] : 16777215, 4, true));
                    b.push(g.pm(c[e][2] < 4398046511103 ? c[e][2] : 4398046511103, 7, true))
                } else {
                    var a = c[e][0] - c[e - 1][0];
                    var f = c[e][1] - c[e - 1][1];
                    var d = c[e][2] - c[e - 1][2];
                    b.push(g.pm(a < 4095 ? a : 4095, 2, false));
                    b.push(g.pm(f < 4095 ? f : 4095, 2, false));
                    b.push(g.pm(d < 16777215 ? d : 16777215, 4, true))
                }
            }
            return b.join("")
        },
        gl: function (a) {
            var c = this;
            var b = a.offsetLeft;
            if (a.offsetParent != null) {
                b += c.gl(a.offsetParent)
            }
            return b
        },
        gt: function (a) {
            var c = this;
            var b = a.offsetTop;
            if (a.offsetParent != null) {
                b += c.gt(a.offsetParent)
            }
            return b
        }
    };

    var lastShowErrorTime = 0
    function checkNetwork (msg) {
    if (window.native.net.hasNetWork()) {
        window.native.ui.toast(msg || '服务器繁忙')
    } else {
        var currentTime = new Date().getTime()
        if (currentTime - lastShowErrorTime < 1500) return
        lastShowErrorTime = currentTime
        window.native.ui.toast('当前网络不可用，请检查您的网络设置')
    }
    }

    // HTZValidate PLUGIN DEFINITION
    // ============================

    function Plugin(option) {
        return this.each(function () {
            var $this   = $(this);
            var data    = $this.data('HTZValidate');
            var options = typeof option === 'object' && option;

            if (!data && option === 'destroy') { return; }
            if (!data) {
                $this.data('HTZValidate', (data = new HTZValidate(this, options)));
            }
            if (typeof option === 'string') {
                data[option]();
            }
        });
    }
    var old = $.fn.HTZValidate;

    $.fn.HTZValidate             = Plugin;
    $.fn.HTZValidate.Constructor = HTZValidate;

    // HTZValidate NO CONFLICT
    // ======================

    $.fn.HTZValidate.noConflict = function () {
        $.fn.HTZValidate = old;
        return this;
    };
}(window,document,jQuery);