Jx().package('s.ui.controls', function (J) {
    // 严格模式
    'use strict';

    var _currentPluginId = 0;
    var defaults = {
        color: {
            lineColor: '#e1e1e1',
            closeLineColor: '#f19149',
            fontColor: '#7f7f7f',
            pointerColor: '#db3338',
            toolBgColor: '#fff',
            volUpColor: '#db3338',
            volDownColr: '#319e26',
            newestColor: '#569afe',
            averageColor: '#afd665',
            iopvColor: '#F230E4'
        },
        codeReg: /^399?/, //399开头为指数
        grid: {
            index: [
                ['7%', 10, '10%', 10],
                ['100%', '100%', 0, 10]
            ],
            sec: [
                ['7%', 10, '48%', 10],
                ['65%', 10, '7%', 10]
            ]
        },
        failGrid: {
            index: [
                ['7%', 10, '48%', 10],
                ['65%', 10, '7%', 10]
            ]
        }
    };
    var attributeMap = {};

    this.mLineChart = new J.Class({
        extend: s.ui.BaseControl
    }, {
        defaults: defaults,
        attributeMap: attributeMap,

        // 构造函数
        init: function (element, options) {
            this.element = $(element);

            // 防止多次初始化
            if (this.element.data('initialized')) {
                return;
            }
            this.element.data('initialized', true);
            // 区分一个页面中存在多个控件实例
            _currentPluginId += 1;
            this.element.data('plugin-id', _currentPluginId);

            // 初始化选项
            this.initSettings(options);
            this.settings.isShowVlom = options.grid.index.length > 1 ? true : false;
            // this.settings = $.extend(true, {}, this.defaults, this.attributes, options);
            this.parseData(this.settings.data);
            this.calcuBaseline();
            this.render(this.chartData);

        },
        parseData: function (data) {
            if ($.isEmptyObject(data)) {
                console.warn('mLineChart控件未获取到数据!');
                return;
            }
            var date = data.datetime && data.datetime.split(' ')[0] || ''; //日期格式  YYYY.MM.DD
            var isInit = false; // true 未开盘前初始化 
            var groupId = data.data.groupId;
            var type = true;
            if (data.type && data.type == 'bond') type = false; //债券类型
            data = data.data;

            // close = 11194.91
            // data.picupdata = [
            //     ["09:30", "11266.32", "71.41", "0.64", "0.50", 2988417, 4030191655.49]
            // ];
            // data.picdowndata = [
            //     ["09:30", "2988417", "plus"]
            // ];
            // data.picavgprice = [];
            var decimal = this.calcuDecimal(data.picupdata, isInit) || (data.close && data.close.split('.')[1].length) || 2; //小数位数

            this.chartData = {
                isSec: !this.settings.codeReg.test(data.code), //true 为证券 ； false 为指数
                isInit: isInit, //true 初始化 未开盘  false 已开盘
                code: data.code, //证券代码
                groupId: groupId,
                type: type, //证券类型
                time: date, //日期
                close: +data.close, //昨收 
                open: +data.open, //今开 用于计算最新只有一条数据时的最大最小值
                decimal: decimal, //小数位数
                newest: data.picupdata, //最新价
                average: data.picavgprice, //均价
                volumes: data.picdowndata, //成交量,
                iopv: data.piciopv, //ETF基金,
                isDelisting: data.isDelisting === true, //退市整理期
                isCashBond: +data.groupId === 4, //判断债券现券 xxmeng 20210906
                isABS: +data.groupId === 4, //判断ABS xxmeng 由10改为4 20220426
                isPledgeStyleBond: +data.groupId === 6, //判断质押式债券 xxmeng 20210906
                isDelayIndex: data.isDelayIndex, //判断6只行情延时至15:30的指数 xxmeng 20210906
                isDrCB: data.isDrCB, //定项可转债20220708
                isNonDrCB: data.isNonDrCB, ////不定项可转债20220708
                isNonDrCBIndex: data.isNonDrCBIndex, //不定向可转债指数 20220708
                categoryData: ["09:30", "09:31", "09:32", "09:33", "09:34", "09:35", "09:36", "09:37", "09:38", "09:39", "09:40", "09:41", "09:42", "09:43", "09:44", "09:45", "09:46", "09:47", "09:48", "09:49", "09:50", "09:51", "09:52", "09:53", "09:54", "09:55", "09:56", "09:57", "09:58", "09:59", "10:00", "10:01", "10:02", "10:03", "10:04", "10:05", "10:06", "10:07", "10:08", "10:09", "10:10", "10:11", "10:12", "10:13", "10:14", "10:15", "10:16", "10:17", "10:18", "10:19", "10:20", "10:21", "10:22", "10:23", "10:24", "10:25", "10:26", "10:27", "10:28", "10:29", "10:30", "10:31", "10:32", "10:33", "10:34", "10:35", "10:36", "10:37", "10:38", "10:39", "10:40", "10:41", "10:42", "10:43", "10:44", "10:45", "10:46", "10:47", "10:48", "10:49", "10:50", "10:51", "10:52", "10:53", "10:54", "10:55", "10:56", "10:57", "10:58", "10:59", "11:00", "11:01", "11:02", "11:03", "11:04", "11:05", "11:06", "11:07", "11:08", "11:09", "11:10", "11:11", "11:12", "11:13", "11:14", "11:15", "11:16", "11:17", "11:18", "11:19", "11:20", "11:21", "11:22", "11:23", "11:24", "11:25", "11:26", "11:27", "11:28", "11:29", "11:30", "13:01", "13:02", "13:03", "13:04", "13:05", "13:06", "13:07", "13:08", "13:09", "13:10", "13:11", "13:12", "13:13", "13:14", "13:15", "13:16", "13:17", "13:18", "13:19", "13:20", "13:21", "13:22", "13:23", "13:24", "13:25", "13:26", "13:27", "13:28", "13:29", "13:30", "13:31", "13:32", "13:33", "13:34", "13:35", "13:36", "13:37", "13:38", "13:39", "13:40", "13:41", "13:42", "13:43", "13:44", "13:45", "13:46", "13:47", "13:48", "13:49", "13:50", "13:51", "13:52", "13:53", "13:54", "13:55", "13:56", "13:57", "13:58", "13:59", "14:00", "14:01", "14:02", "14:03", "14:04", "14:05", "14:06", "14:07", "14:08", "14:09", "14:10", "14:11", "14:12", "14:13", "14:14", "14:15", "14:16", "14:17", "14:18", "14:19", "14:20", "14:21", "14:22", "14:23", "14:24", "14:25", "14:26", "14:27", "14:28", "14:29", "14:30", "14:31", "14:32", "14:33", "14:34", "14:35", "14:36", "14:37", "14:38", "14:39", "14:40", "14:41", "14:42", "14:43", "14:44", "14:45", "14:46", "14:47", "14:48", "14:49", "14:50", "14:51", "14:52", "14:53", "14:54", "14:55", "14:56", "14:57", "14:58", "14:59", "15:00"],
                extCategoryData: ["15:06", "15:07", "15:08", "15:09", "15:10", "15:11", "15:12", "15:13", "15:14", "15:15", "15:16", "15:17", "15:18", "15:19", "15:20", "15:21", "15:22", "15:23", "15:24", "15:25", "15:26", "15:27", "15:28", "15:29", "15:30"],
                expCategoryData: ["09:00", "09:01", "09:02", "09:03", "09:04", "09:05", "09:06", "09:07", "09:08", "09:09", "09:10", "09:11", "09:12", "09:13", "09:14", "09:15", "09:16", "09:17", "09:18", "09:19", "09:20", "09:21", "09:22", "09:23", "09:24", "09:25", "09:26", "09:27", "09:28", "09:29"]
            };

            //行情请求数据失败，没有图形数据
            if (data.picupdata === null) {
                data.close = '0.02';
                this.chartData.close = +data.close;
                this.chartData.isFail = true; //行情请求失败
                this.chartData.isInit = true;
                this.initTrend(data);
            } else

                //开盘前初始化
                // data.picupdata = [];
                // data.picavgprice = [];
                // data.picdowndata = [];
                // this.chartData.newest = [];
                // this.chartData.average = [];
                // this.chartData.volumes = [];
                if (data.picupdata.length === 0) {
                    this.chartData.isInit = true;
                    this.initTrend(data);
                }
        },
        initFailTrend: function (data) {

        },
        initTrend: function (data, flag) { //true 不重置成交量数据 false 重置成交量
            var minLen = data.close.split('.')[1].length - 1; //最小报价单位小数零位数
            var minInterval = '0.'; //最小报价单位
            var max, min, quarter, threeQuarter;

            for (var i = 0; i < minLen; i++) {
                minInterval += '0';
            }
            minInterval += '1';
            quarter = window.util.fSubtract(data.close, minInterval);
            min = window.util.fSubtract(quarter, minInterval);
            threeQuarter = window.util.fAdd(data.close, minInterval);
            max = window.util.fAdd(threeQuarter, minInterval);

            this.chartData.initY1Data = [min, quarter, data.close, threeQuarter, max]; //重置最新的数据
            if (!flag) //有一条数据或最大最小值和昨收相等时不重置成交量数据
                this.chartData.initY2Data = ['0', '5', '10']; //重置成交量的数据

            this.chartData.yData = { //初始化的基准线
                min: min,
                max: max,
                interval: +minInterval,
                threeQuarter: threeQuarter,
                quarter: quarter
            };
        },
        calcuDecimal: function (data, isInit) {
            var len = data && data.length;
            var decimal = '';

            if (isInit || !len) //初始化返回
                return;

            data.every(function (item) {
                var value = item[1];

                if (/\./g.test(value)) {
                    decimal = value.split('.')[1].length;
                    return false;
                }
                return true;
            });
            return decimal;
        },
        calcuBaseline: function () {
            if (this.chartData.isInit) //初始化返回
                return;
            var len = this.chartData.newest.length; //最新价数据长度
            var newestData = [];
            var max, min, maxLenStr, minLenStr, maxLen, minLen, halfLen, remainder, interval, quarter, threeQuarter, yTick, m;

            var oneData = false; //只有一条数据且今开不等于昨收
            if (len === 1) { //最新只有一条数据的时候
                oneData = true;
                this.chartData.isOneData = oneData;
                if (this.chartData.open > this.chartData.close) { //今开大于昨收，以今开做为最大值
                    max = this.chartData.open;
                    halfLen = Math.abs(window.util.fSubtract(max, this.chartData.close));
                } else if (this.chartData.open < this.chartData.close) {
                    min = this.chartData.open;
                    halfLen = Math.abs(window.util.fSubtract(min, this.chartData.close));
                } else { //今开等于昨收，跳行情初始化
                    this.initTrend({
                        close: this.chartData.close.toFixed(this.chartData.decimal)
                    }, oneData);
                    return;
                }

            } else {
                this.chartData.newest.map(function (item) { //转小数为整数，解决js浮点型数据计算不精确问题
                    newestData.push(+item[1].replace(/\./g, ''));
                    if (item[7]) //ETF基金 去IOPV值
                        newestData.push(+item[7].replace(/\./g, ''));
                });
                min = this.reDeci(Math.min.apply(null, newestData), this.chartData.decimal); //最新价最小值
                max = this.reDeci(Math.max.apply(null, newestData), this.chartData.decimal); //最新价最大值
                maxLenStr = window.util.fSubtract(max, this.chartData.close);
                minLenStr = window.util.fSubtract(this.chartData.close, min);
                maxLen = Math.abs(window.util.fSubtract(max, this.chartData.close));
                minLen = Math.abs(window.util.fSubtract(this.chartData.close, min));
                if (maxLen >= minLen)
                    halfLen = maxLenStr;
                else
                    halfLen = minLenStr;

                if (+halfLen === 0) { //最大值等于最小值时，计算y轴范围
                    this.initTrend({
                        close: this.chartData.close.toFixed(this.chartData.decimal)
                    });
                    return;
                }
            }

            remainder = +(window.util.fRemainder(halfLen, 2)); //间隔除2的余数
            halfLen = remainder === 0 ? halfLen : (window.util.fAdd(halfLen, remainder));
            max = window.util.fAdd(this.chartData.close, halfLen); //y轴最大值
            min = window.util.fSubtract(this.chartData.close, halfLen); //y轴最小值
            interval = +halfLen / 2; //y轴间隔
            quarter = window.util.fAdd(min, interval); //1/4线
            threeQuarter = window.util.fSubtract(max, interval); //3/4线
            this.chartData.yData = {
                min: min,
                max: max,
                interval: interval,
                threeQuarter: threeQuarter,
                quarter: quarter
            };
            if (oneData) //只有一条数据且今开不等于昨收时
                this.chartData.initY1Data = [min, quarter, this.chartData.close, threeQuarter, max];
        },
        reDeci: function (value, decimal) { //添加小数点
            value = value + '';
            var i = value.length - decimal;
            var zero = '';

            for (var n = i; n < 0; n++) {
                zero += '0';
            }
            return i <= 0 ? ('0' + '.' + zero + value) : (value.slice(0, i) + '.' + value.slice(-decimal));
        },
        render: function (data) {
            this.secLine(data);
            this.buildMATip();
            this.initElements();
            this.bindEvents();
        },
        bindEvents: function () {
            // this.element.on({
            //     'mouseenter': $.proxy(this.showMAWrap, this),
            //     mouseleave: $.proxy(this.hideMAWrap, this)
            // });
        },
        initElements: function () {
            this.elements = {
                MAWrap: $('.MA-wrap', this.element),
                price: $('.MA-wrap .price .value', this.element),
                range: $('.MA-wrap .range .value', this.element),
                limit: $('.MA-wrap .limit .value', this.element),
                turnover: $('.MA-wrap .turnover .value', this.element),
                turnoverUnit: $('.MA-wrap .turnover .unit', this.element),
            };
        },
        showMAWrap: function () {
            this.elements.MAWrap.css('visibility', 'visible');
        },
        hideMAWrap: function () {
            this.elements.MAWrap.css('visibility', 'hidden');
        },
        changeMA: function (obj) {
            var price, range, limit, turnover, iopv,
                priceClass, rangeClass,
                isSecNum = 0;

            priceClass = (obj.newIsDown === true ? 'new-price-down' : 'new-price-up');
            rangeClass = (obj.deltaIsDown === true ? 'new-range-down' : 'new-range-up');

            if (this.chartData.isSec) {
                isSecNum = 1;
            } else {
                isSecNum = 0;
            }

            price = '<span class="' + priceClass + '">' + this.formatToolTipsData(obj.data[1]) + '</span>';
            range = '<span class="' + rangeClass + '">' + Math.abs(parseFloat(this.formatToolTipsData(obj.data[isSecNum + 3]))).toFixed(2) + '%</span>';
            limit = this.calcuUnit(obj.data[isSecNum + 5], this.chartData.groupId === 4 ? 4 : 2, 'amount');
            turnover = this.calcuUnit(obj.data[isSecNum + 4] === null ? obj.data[isSecNum + 4] : obj.data[isSecNum + 4] * ((this.chartData.isCashBond || this.chartData.isABS) ? 100 : (this.chartData.isDelayIndex ? 10000 : 1)), 2, 'volume');

            iopv = (obj.data[isSecNum + 6] ? '<span>' + this.formatToolTipsData(obj.data[isSecNum + 6]) + '元</span>' : '');

            this.elements.price.html(price);
            this.elements.range.html(range);
            this.elements.limit.text(limit);
            this.elements.turnover.text(turnover);
            if (this.chartData.isNonDrCB || this.chartData.isNonDrCBIndex) {
                this.elements.turnoverUnit.text('');
            }

        },
        buildMATip: function () {
            var html = '';
            var isReformBond = this.chartData.isCashBond || this.chartData.isABS || this.chartData.isPledgeStyleBond || this.chartData.isDelayIndex;
            var isNonDrCB = this.chartData.isNonDrCB;
            var isNonDrCBIndex = this.chartData.isNonDrCBIndex;
            var isDrCB = this.chartData.isDrCB;
            if (!this.settings.isShowVlom) {
                html = '<ul class=MA-wrap>' +
                    '   <li>' + this.settings.data.datetime.split(" ")[0] + '</li>' +
                    '   <li class="price">' + (this.chartData.isSec ? "价" : "指") + '：<span class="value">--</span></li>' +
                    // '   <li class="range">幅：<span class="value">--</span></li>' +
                    '   <li class="limit">额：<span class="value blue">--</span><span class="blue">元</span></li>' +
                    '   <li class="turnover">量：<span class="value blue">--</span><span class="blue">' + (this.chartData.type ? "手" : "张") + '</span></li>' +
                    '</ul>';
            } else {
                html = '<ul class=MA-wrap>' +
                    '   <li class="price">' + (this.chartData.isSec ? "价" : "指") + '：<span class="value">--</span></li>' +
                    '   <li class="range">幅：<span class="value">--</span></li>' +
                    '   <li class="limit">' + ((isReformBond || isNonDrCB || isNonDrCBIndex || isDrCB) ? '金额' : '额') + '：<span class="value blue">--</span><span class="blue">元</span></li>';
                if (!this.chartData.isPledgeStyleBond) {
                    if (isNonDrCB || isNonDrCBIndex || isDrCB) {
                        html += '   <li class="turnover">面额' + '：<span class="value blue">--</span><span class="blue unit">' + ((isNonDrCB || isDrCB) ? '百' : '万') + '元</span></li>';
                    } else {
                        html += '   <li class="turnover">' + (isReformBond ? '面额' : '量') + '：<span class="value blue">--</span><span class="blue">' + (this.chartData.type ? (this.chartData.isDelayIndex ? "元" : "手") : (isReformBond ? "元" : "张")) + '</span></li>';
                    }
                }

                html += '</ul>';
            }
            this.element.append($(html));
        },
        calculateMA: function (dayCount, data, flag) {
            var result = [];
            for (var i = 0, len = data.values.length; i < len; i++) {
                if (i < dayCount - 1) {
                    result.push('-');
                    continue;
                }
                var sum = 0;
                for (var j = 0; j < dayCount; j++) {
                    if (flag)
                        sum += +data.volumes[i - j][1];
                    sum += +data.values[i - j][1];
                }
                result.push(+(sum / dayCount).toFixed(this.chartData.decimal));
            }
            return result;
        },
        buildTooltip: function (seriesData) {
            this.changeMA(seriesData);
            var wrap = $('<div>');
            var isReformBond = this.chartData.isCashBond || this.chartData.isABS || this.chartData.isPledgeStyleBond || this.chartData.isDelayIndex;
            var i = 0;
            var html = '<div class="sectooltip-container">';

            html += '<span class="time">' + this.chartData.time + '&nbsp;&nbsp;' + seriesData.data[0] + '</span><br/>';

            if (this.chartData.isSec) {
                html += '<span class="name newest ' + (seriesData.newIsDown === true ? 'new-down' : 'new-up') + '"><i>：</i>最新</span><span class="value newest ' + (seriesData.newIsDown === true ? 'new-down' : 'new-up') + '">' + this.formatToolTipsData(seriesData.data[1]) + '</span><br/>' +
                    '<span class="name"><i>：</i>均价</span><span class="value ' + (seriesData.averageIsDown === true ? 'average-down' : 'average-up') + '">' + this.formatToolTipsData(seriesData.data[2]) + '</span><br/>';
                i = 1;
            } else {
                html += '<span class="name newest ' + (seriesData.newIsDown === true ? 'new-down' : 'new-up') + '"><i>：</i>指数</span><span class="value newest ' + (seriesData.newIsDown === true ? 'new-down' : 'new-up') + '">' + this.formatToolTipsData(seriesData.data[1]) + '</span><br/>';
            }
            html += '<span class="name"><i>：</i>涨跌</span><span class="value ' + (seriesData.deltaIsDown === true ? 'delta-down' : 'delta-up') + '">' + this.formatToolTipsData(seriesData.data[i + 2]) + '</span><br/>' +
                '<span class="name"><i>：</i>涨幅</span><span class="value ' + (seriesData.deltaIsDown === true ? 'delta-down' : 'delta-up') + '">' + this.formatToolTipsData(seriesData.data[i + 3]) + '%</span><br/>' +
                '<span class="name"><i>：</i>成交量</span><span class="value">' + this.calcuUnit(seriesData.data[i + 4], 2) + (this.chartData.type ? "手" : "张") + '</span><br/>' +
                '<span class="name"><i>：</i>成交额</span><span class="value">' + this.calcuUnit(seriesData.data[i + 5], 2) + '元</span><br/>' +
                (seriesData.data[i + 6] ? '<span class="name"><i>：</i>IOPV</span><span class="value">' + this.formatToolTipsData(seriesData.data[i + 6]) + '元</span><br/>' : '') +
                '</div>';
            return wrap.html(html);
        },
        formatToolTipsData: function (value) {
            if (value === null)
                return '--';
            else
                return value;
        },
        parseTooltipsData: function (data) {
            var lastCloseData = this.chartData.close; //前一个交易日收盘价
            var reg = /^\-/;

            if (this.chartData.isSec) {
                data.newIsDown = +data.data[1] < lastCloseData ? true : false; //最新
                data.averageIsDown = +data.data[2] < lastCloseData ? true : false; //均价
                data.deltaIsDown = reg.test(data.data[3]); //false 涨   true 跌  今日的涨跌
            } else {
                data.newIsDown = +data.data[1] < lastCloseData ? true : false;
                data.deltaIsDown = reg.test(data.data[2]); //false 涨   true 跌  今日的涨跌
            }
        },
        calcuUnit: function (num, decimal, type) {
            var hundredMillion = 100000000;
            var tenThousand = 10000;
            var value = '';
            var r = '';
            var unit = '';

            if (num === null) {
                value = '--';
                if (type === 'volume') {
                    if (this.chartData.isNonDrCB || this.chartData.isDrCB)
                        value += '百元';
                    if (this.chartData.isNonDrCBIndex)
                        value += '万元';
                }
            } else if (num / hundredMillion >= 1) {
                r = num / hundredMillion;
                if (type === 'volume') {
                    if (this.chartData.isNonDrCB)
                        unit = '百亿元';
                    if (this.chartData.isNonDrCBIndex)
                        unit = '万亿元';
                };
                unit = unit ? unit : '亿';
                value = r.toString().length < 4 && !this.chartData.isCashBond ? (r + unit) : (r.toFixed(decimal) + unit);
                // value = (num / hundredMillion).toFixed(decimal) + '亿';
            } else if (num / tenThousand >= 1) {
                r = num / tenThousand;
                if (type === 'volume') {
                    if (this.chartData.isNonDrCB)
                        unit = '百万元';
                    if (this.chartData.isNonDrCBIndex)
                        unit = '亿元';
                };
                unit = unit ? unit : '万';
                value = r.toString().length < 4 && !this.chartData.isCashBond ? (r + unit) : (r.toFixed(decimal) + unit);
                // value = (num / tenThousand).toFixed(decimal) + '万';

            } else {
                value = this.chartData.groupId === 4 && type === "amount" ? num.toFixed(decimal) : num;
                if (type === 'volume') {
                    if (this.chartData.isNonDrCB)
                        value += '百元';
                    if (this.chartData.isNonDrCBIndex)
                        value += '万元';
                }
            }
            return value;
        },
        xAxisOption: function () {
            var _this = this;
            var context = this;
            var xAxis = [{
                type: 'category',
                axisLine: {
                    onZero: false,
                    show: false
                },
                axisLabel: {
                    color: '#7f7f7f',
                    formatter: function (value, index) {
                        return context.formatXlabelFormat(value, index);
                    },
                    interval: function (index, value) {
                        return context.formatXLabelInterval(index, value);
                    },
                    rich: context.formatXLabelRich(),
                    fontSize: (function () {
                        if ((_this.chartData.groupId === 17 && _this.chartData.isDelisting !== true) || _this.chartData.groupId === 4) {
                            return 7;
                        } else {
                            return 12;
                        }
                    })()
                },
                axisTick: {
                    show: false
                },
                axisPointer: {
                    show: this.chartData.isInit ? false : true,
                },
                data: this.chartData.categoryData

            }, {
                type: 'category',
                gridIndex: 1,
                boundaryGap: true,
                scale: true,
                splitLine: {
                    show: false,
                    lineStyle: {
                        color: context.settings.color.lineColor
                    }
                },
                axisLine: {
                    onZero: false,
                    lineStyle: {
                        color: context.settings.color.lineColor
                    }
                },
                axisTick: {
                    show: false
                },
                axisLabel: {
                    show: false,
                    color: '#7f7f7f',
                    formatter: function (value, index) {
                        return context.formatXlabelFormat(value, index);
                    },
                    interval: function (index, value) {
                        return context.formatXLabelInterval(index, value);
                    },
                    fontSize: (function () {
                        if ((_this.chartData.groupId === 17 && _this.chartData.isDelisting !== true) || _this.chartData.groupId === 4) {
                            return 7;
                        } else {
                            return 12;
                        }
                    })()
                },
                axisPointer: {
                    // show: this.chartData.isInit ? false : true,
                    show: (function () {
                        if (context.chartData.isInit) {
                            return false;
                        } else {
                            if (context.settings.isShowVlom) {
                                return true;
                            } else {
                                return false;
                            }
                        }
                    })(),
                    label: {
                        show: false
                    }
                },
                data: this.chartData.categoryData
            }];
            return xAxis;
        },
        yAxisOption: function () {
            var flag = this.chartData.isInit || this.chartData.isOneData; //true 初始化或只有一条数据
            var context = this;
            var yAxis = [{
                type: (this.chartData.isInit || this.chartData.isOneData) ? 'category' : 'value',
                scale: true,
                boundaryGap: this.chartData.isInit ? true : false,
                axisTick: {
                    show: false
                },
                axisLine: {
                    show: false
                },
                splitLine: {
                    show: false
                },
                axisLabel: {
                    color: context.settings.color.fontColor,
                    verticalAlign: "bottom",
                    formatter: function (value) {
                        if (context.chartData.isFail) //行情服务器请求失败初始化
                            return '0.00';
                        if (context.chartData.isInit || context.chartData.isOneData)
                            return value;
                        return value.toFixed(context.chartData.decimal);
                    },
                    inside: true
                },
                axisPointer: {
                    lineStyle: {
                        type: 'solid',
                        color: "#5573aa" //坐标指示器的线条颜色
                    },
                    label: {
                        show: context.chartData.isFail ? false : true
                    },
                    zlevel: 50
                },
                min: flag ? null : this.chartData.yData.min,
                max: flag ? null : this.chartData.yData.max,
                interval: flag ? null : this.chartData.yData.interval,
                zlevel: 10
            }, {
                type: (this.chartData.isInit && (!this.chartData.isOneData)) ? 'category' : 'value',
                scale: true,
                boundaryGap: this.chartData.isInit ? true : false,
                gridIndex: 1,
                splitNumber: 3,
                splitLine: {
                    show: true,
                    lineStyle: {
                        color: this.settings.color.lineColor
                    }
                },
                axisTick: {
                    show: false,
                },
                axisLine: {
                    show: false,
                    lineStyle: {
                        color: this.settings.color.lineColor
                    }
                },
                axisLabel: {
                    show: this.chartData.isInit ? false : true,
                    verticalAlign: "bottom",
                    color: this.settings.color.fontColor,
                    formatter: function (value) {
                        if (value == 0)
                            return "0";
                        return context.calcuUnit(value, 0, 'volume');
                    },
                    inside: true
                },
                axisPointer: {
                    show: false
                },
            }];
            return yAxis;
        },
        gridOption: function () {
            // var gridCoor = this.chartData.isSec ? this.settings.grid.sec : this.settings.grid.index;
            var gridCoor;
            var grid = [];

            if (this.settings.isShowVlom) {
                gridCoor = this.settings.grid.sec;
                grid = [{
                    top: this.chartData.isFail ? this.settings.failGrid.index[0][0] : gridCoor[0][0],
                    right: this.chartData.isFail ? this.settings.failGrid.index[0][1] : gridCoor[0][1],
                    bottom: this.chartData.isFail ? this.settings.failGrid.index[0][2] : gridCoor[0][2],
                    left: this.chartData.isFail ? this.settings.failGrid.index[0][3] : gridCoor[0][3]
                }, {
                    top: gridCoor[1][0],
                    right: gridCoor[1][1],
                    bottom: gridCoor[1][2],
                    left: gridCoor[1][3]
                }];
            } else {
                gridCoor = this.settings.grid.index;
                grid = [{
                    top: this.chartData.isFail ? this.settings.failGrid.index[0][0] : gridCoor[0][0],
                    right: this.chartData.isFail ? this.settings.failGrid.index[0][1] : gridCoor[0][1],
                    bottom: this.chartData.isFail ? this.settings.failGrid.index[0][2] : gridCoor[0][2],
                    left: this.chartData.isFail ? this.settings.failGrid.index[0][3] : gridCoor[0][3]
                }, {
                    top: 0,
                    right: 0,
                    bottom: 0,
                    left: 0
                }];
            }
            return grid;
        },
        markLineDataOption: function () {
            // var markLineData = [{
            //     name: '4/4线',
            //     yAxis: this.chartData.yData.max
            // }, {
            //     name: '3/4线',
            //     yAxis: this.chartData.yData.threeQuarter
            // }, {
            //     name: '昨收线',
            //     yAxis: this.chartData.close.toFixed(this.chartData.decimal),
            //     lineStyle: {
            //         normal: {
            //             color: this.settings.color.closeLineColor
            //         }
            //     }
            // }, {
            //     name: '1/4线',
            //     yAxis: this.chartData.yData.quarter
            // }, {
            //     name: '0/4线',
            //     yAxis: this.chartData.yData.min
            // }];
            var markLineData = [{
                name: '4/4线',
                yAxis: this.chartData.yData.max
            }, {
                name: '3/4线',
                yAxis: this.chartData.yData.threeQuarter
            }, {
                name: '昨收线',
                yAxis: this.chartData.close.toFixed(this.chartData.decimal),
                lineStyle: {
                    normal: {
                        color: this.settings.color.closeLineColor
                    }
                }
            }, {
                name: '1/4线',
                yAxis: this.chartData.yData.quarter
            }, {
                name: '0/4线',
                yAxis: this.chartData.yData.min
            }];
            return markLineData;
        },
        secLineOption: function () {
            var context = this;
            var option = {
                animation: false,
                tooltip: {
                    trigger: 'axis',
                    // show:false,
                    formatter: function (params) {
                        var html = '';

                        params.map(function (item) {
                            if (item.seriesIndex === 0) {
                                context.parseTooltipsData(item);
                                html = context.buildTooltip(item);
                            }
                        });
                        return '';
                    },
                    axisPointer: {
                        type: 'cross',
                        label: {
                            precision: 2
                        },
                        lineStyle: {
                            type: 'solid',
                            color: "#5573aa" //坐标指示器的线条颜色
                        },
                        formatter: function (a) {
                            // console.log(a)
                        },
                    },
                    backgroundColor: context.settings.color.toolBgColor,
                    padding: [10, 20, 10, 14],
                    textStyle: {
                        color: context.settings.color.fontColor,
                        fontSize: 12
                    },
                    position: function (point, params, dom, rect, size) {
                        // 鼠标在左侧时 tooltip 显示到右侧，鼠标在右侧时 tooltip 显示到左侧。
                        var obj = {
                            top: '4%'
                        };
                        // obj[['left', 'right'][+(point[0] < size.viewSize[0] / 2)]] = '10%';
                        // console.log(obj);
                        if (point[0] < size.viewSize[0] / 2) {
                            obj.right = 10;
                        } else {
                            obj.left = 30;
                        }
                        return obj;
                    },
                    extraCssText: 'box-shadow: 0 0 6px rgba(0, 0, 0, .075)'
                },
                axisPointer: {
                    link: {
                        xAxisIndex: 'all'
                    },
                    label: {
                        backgroundColor: '#5573aa'
                    }
                },
                visualMap: {
                    show: false,
                    seriesIndex: 2,
                    dimension: 2,
                    pieces: [{
                        value: 'plus',
                        color: context.settings.color.volUpColor
                    }, {
                        value: 'minus',
                        color: context.settings.color.volDownColr
                    }]
                },
                grid: this.gridOption(),
                xAxis: this.xAxisOption(),
                yAxis: this.yAxisOption(),
                series: [{
                    name: '最新',
                    type: 'line',
                    smooth: true,
                    symbol: 'circle',
                    symbolSize: 6,
                    showSymbol: false,
                    connectNulls: true,
                    itemStyle: {
                        normal: {
                            shadowColor: context.settings.color.pointerColor,
                            shadowBlur: 16
                        }
                    },
                    lineStyle: {
                        normal: {
                            width: 1.4,
                            color: context.settings.color.newestColor
                        }
                    },
                    areaStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                                offset: 0,
                                color: '#adcefa'
                            }, {
                                offset: 1,
                                color: '#e5f3fe'
                            }])
                        }
                    },
                    markLine: {
                        id: 'markLine',
                        silent: true,
                        symbol: ['none', 'none'],
                        label: {
                            normal: {
                                color: this.settings.color.fontColor,
                                formatter: function (params) {
                                    if (context.chartData.isFail)
                                        return '0.00%';
                                    var percent = (((+window.util.fSubtract(params.value, context.chartData.close)) / context.chartData.close) * 100).toFixed(context.chartData.decimal);

                                    return percent + '%';
                                }
                            }
                        },
                        lineStyle: {
                            normal: {
                                color: this.settings.color.lineColor
                            }
                        },
                        data: [],
                        animation: false
                    },
                    data: []

                }, {
                    name: '均价',
                    type: 'line',
                    smooth: true,
                    symbolSize: 0,
                    showSymbol: false,
                    symbol: 'circle',
                    connectNulls: true,
                    lineStyle: {
                        normal: {
                            width: 1.4,
                            color: context.settings.color.averageColor
                        }
                    },
                    data: []
                }, {
                    name: 'Volume',
                    type: 'bar',
                    xAxisIndex: 1,
                    yAxisIndex: 1,
                    data: []
                }, {
                    name: 'iopv',
                    type: 'line',
                    smooth: true,
                    symbolSize: 0,
                    showSymbol: false,
                    symbol: 'circle',
                    connectNulls: true,
                    lineStyle: {
                        normal: {
                            width: 1.1,
                            color: context.settings.color.iopvColor
                        }
                    },
                    data: []
                }]
            };
            return option;
        },
        secLine: function (data) {
            var context = this;
            var myChart = echarts.init(this.element[0]);
            var option = this.secLineOption();

            myChart.setOption(option);
            //echarts实例
            this.settings.chart = myChart;
            this.resize();

            if (this.settings.isShowVlom) {
                this.setSecOption(); //证券分时console.log(this.chartData)
            } else {
                this.setIndexOption(); //指数分时
            }
            // if (this.chartData.isSec) {
            //     this.setSecOption(); //证券分时
            // } else {
            //     this.setIndexOption(); //指数分时
            // }
        },
        updateOption: function (data) {
            this.parseData(data.data);
            this.calcuBaseline();
            var yAxisOption = this.yAxisOption();
            var xAxisOption = this.xAxisOption();
            var series = this.resetData();
            var grid = this.gridOption();

            this.settings.chart.setOption({
                grid: grid,
                yAxis: yAxisOption,
                xAxis: xAxisOption,
                series: series
            });
            // this.setSecOption(); //证券分时
            if (this.settings.isShowVlom) {
                this.setSecOption(); //证券分时console.log(this.chartData)
            } else {
                this.setIndexOption(); //指数分时
            }
            // if (this.chartData.isSec) {
            //     this.setSecOption(); //证券分时
            // } else {
            //     this.setIndexOption(); //指数分时
            // }
        },
        resetData: function () {
            var series = [{
                data: [] //最新
            }, {
                data: [] //均价
            }, {
                data: [] //成交量
            }, {
                data: [] //iopv
            }];
            return series;
        },
        setSecOption: function () {
            var categoryData = this.chartData.categoryData;
            //质押式债券
            //创业板
            if ((this.chartData.groupId === 6 || this.chartData.groupId === 17 || this.chartData.groupId === 4 || this.chartData.isDelayIndex) && this.chartData.isDelisting !== true) {
                if (this.chartData.groupId === 4) {
                    categoryData = this.chartData.expCategoryData.concat(this.chartData.categoryData);
                }
                if (this.chartData.groupId === 6 || this.chartData.groupId === 4 || this.chartData.isDelayIndex)
                    categoryData = categoryData.concat(["15:01", "15:02", "15:03", "15:04", "15:05"]);
                categoryData = categoryData.concat(this.chartData.extCategoryData);
            }
            var context = this;
            var option = {
                xAxis: [{
                    axisPointer: {
                        show: this.chartData.isInit ? false : true,
                    },
                    data: categoryData
                }, {
                    axisPointer: {
                        show: this.chartData.isInit ? false : true,
                    },
                    data: categoryData
                }],
                series: [{
                    name: '最新',
                    markLine: {
                        id: 'markLine',
                        label: {
                            normal: {
                                //是否显示标线值
                                show: true,
                                // show: false                                
                                formatter: function (val) {
                                    return " ";
                                }
                            }
                        },
                        data: this.markLineDataOption()
                    },
                    data: this.chartData.newest
                }, {
                    name: '均价',
                    data: this.chartData.average
                }, {
                    name: 'Volume',
                    data: this.resetVolumeData(this.chartData.volumes)
                }, {
                    name: 'iopv',
                    data: this.chartData.iopv
                }]
            };

            if (this.chartData.isInit) //初始化显示
                option.yAxis = [{
                    data: this.chartData.initY1Data
                }, {
                    data: this.chartData.initY2Data
                }];
            if (this.chartData.isOneData) //只有一条数据显示
                option.yAxis = [{
                    data: this.chartData.initY1Data
                }];

            this.settings.chart.setOption(option);
        },
        setIndexOption: function () {
            var categoryData = this.chartData.categoryData;
            //质押式债券
            //创业板
            if ((this.chartData.groupId === 6 || this.chartData.groupId === 17 || this.chartData.groupId === 4 || this.chartData.isDelayIndex) && this.chartData.isDelisting !== true) {
                if (this.chartData.groupId === 4) {
                    categoryData = this.chartData.expCategoryData.concat(this.chartData.categoryData);
                }
                if (this.chartData.groupId === 6 || this.chartData.groupId === 4 || this.chartData.isDelayIndex)
                    categoryData = categoryData.concat(["15:01", "15:02", "15:03", "15:04", "15:05"]);
                categoryData = categoryData.concat(this.chartData.extCategoryData);
            }
            var option = {

                xAxis: {
                    axisPointer: {
                        show: this.chartData.isInit ? false : true
                    },
                    data: categoryData
                },
                series: [{
                    name: '最新',
                    markLine: {
                        id: 'markLine',
                        label: {
                            normal: {
                                show: false
                            }
                        },
                        data: this.markLineDataOption()
                    },
                    data: this.chartData.newest
                }]
            };

            if (this.chartData.isInit || this.chartData.isOneData) { //初始化显示或只有一条数据显示
                option.yAxis = [{
                    data: this.chartData.initY1Data
                }];
            }

            this.settings.chart.setOption(option);
        },
        resize: function () {
            var context = this;

            $(window).on('resize', function () {
                context.settings.chart.resize();
            });
        },
        formatXlabelFormat: function (value, index) {
            if (value === '09:00')
                return "09:00";
            if (this.chartData.groupId != 4 && this.chartData.groupId != 10 && value === '09:30')
                return "{startValue|" + value + "}";
            if (value === '10:00')
                return null;
            if (value === '11:00')
                return null;
            if (value === '11:30')
                return '11:30/13:00';
            if (value === '13:30')
                return null;
            if (value === '14:30')
                return null;
            // if (this.chartData.groupId === 6) {
            //     if (value === '15:30')
            //         return "{endValue|" + value + "}";
            // } else {
            //     if (value === '15:00')
            //         return "{endValue|" + value + "}";
            // }

            if (value === '15:00') {
                if (this.chartData.groupId === 17 && this.chartData.isDelisting !== true) {
                    return '15:00/15:05';
                } else {
                    return "{endValue|" + value + "}";
                }
            }

            if (value === '15:30') {
                return "{endValue|" + value + "}";
            }


        },
        formatXLabelRich: function () {
            var obj = {
                startValue: {
                    width: 70,
                    // backgroundColor: 'yellow',
                    align: "right",
                },
                endValue: {
                    // width: '70',
                    // backgroundColor: 'red',
                    align: "left",
                }
            };
            if ((this.chartData.groupId === 17 && this.chartData.isDelisting !== true) || this.chartData.groupId === 4) {
                obj.startValue.fontSize = 7;
                obj.endValue.fontSize = 7;
                obj.endValue.width = 15;
            } else {
                obj.startValue.fontSize = 12;
                obj.endValue.fontSize = 12;
                obj.endValue.width = 70;
            }
            return obj;
        },
        formatXLabelInterval: function (index, value) {
            if (value === '09:00')
                return value;
            if (value === '09:30')
                return value;
            // if (value === '10:00')
            //     return value;
            // if (value === '10:30')
            //     return value;
            // if (value === '11:00')
            //     return value;
            if (value === '11:30')
                return value;
            // if (value === '13:30')
            //     return value;
            // if (value === '14:00')
            //     return value;
            // if (value === '14:30')
            //     return value;
            // if (this.chartData.groupId === 6) {
            //     if (value === '15:30')
            //         return value;
            // } else {
            //     if (value === '15:00')
            //         return value;
            // }

            if (value === '15:00') {
                if (this.chartData.groupId === 6 || this.chartData.isDelayIndex) {
                    return null;
                }
                return value;

            }

            if (value === '15:30') {
                return value;
            }





        },
        getInstance: function () {
            return this.settings.chart;
        },
        resetVolumeData: function (data) {
            if (this.chartData.isCashBond || this.chartData.isABS) {
                return data.map(function (item) {
                    item[1] *= 100;
                    return item;
                });
            } else if (this.chartData.isDelayIndex) {
                return data.map(function (item) {
                    item[1] *= 10000;
                    return item;
                });
            }
            return data;
        }

    });
});