/*!
 * Native Javascript Library
 * v1.0.2 (2019-11-13)
 * 新增登录和分享接口
 * v1.0.3 (2019-11-14)
 * 新增rsa加密算法
 * v1.0.4 (2019-11-16)
 * 新增打开文件接口
 * v1.0.5 (2019-11-16)
 * 新增退出登录接口
 * v1.0.6 (2019-11-19)
 * 新增打开网页接口
 * v1.0.7 (2019-11-20)
 * 修改判断android手机和iOS手机的逻辑
 * v1.0.8 (2019-12-12)
 * iOS适配WKWebView
 * v1.0.9 (2020-05-06)
 * 默认使用WKWebView
 * v1.0.10 (2020-05-14)
 * 新增记录日志方法
 * v1.0.11 (2020-07-14)
 * 新增打开文件和分享功能
 * v1.0.12（2020-07-15）
 * 新增打开超链接的分享功能
 * v1.0.13（2020-08-19）
 * 新增是否支持生物识别、是否设置生物识别、是否设置手势登录、设置手势开关、设置生物识别开关、修改手势密码、显示或隐藏悬浮按钮、拖动验证码匹配成功回调、版本信息、获取缓存大小、埋点、是否隐藏底部菜单
 */
(function (window) {
    /**
	 * 开发使用的调试数据
	 */
    function Developer() {
        this.toast = function (text) {
            console.log("toast:" + text);
        }
        this.finish = function () {
            window.close();
        }
        this.showInputMethod = function () {
            console.log("showInputMethod");
        }
        this.hiddenInputMethod = function () {
            console.log("hiddenInputMethod");
        }
        this.hasNetWork = function () {
            return navigator.onLine;
        }
        this.href = function(jsonURL, title, tag, htmlURL) {
            console.log("href===" + jsonURL + "===" + title + "===" + tag + "===" + htmlURL);
        }
        this.openDoc = function(url){
            console.log("openDoc===" + url);
        }
        this.lightAppHref = function (tag, path, title) {
           console.log('(lightAppHref) tag:' + tag + ' path:' + path + ' title:' + title)
        }
        
        this.openFull = function (path) {
            window.open('/#/home/specialinfo')
        }
        this.html = function (url, title) {
            window.open(url);
        }
        this.callPhone = function (phone) {
            console.log("callPhone:" + phone);
        }
        this.copy = function (text) {
            console.log("copy:" + text);
        }
        this.setItem = function (key, value) {
            localStorage.setItem(key, value);
        }
        this.getItem = function (key) {
            return localStorage.getItem(key);
        }
        this.removeItem = function (key) {
            localStorage.removeItem(key);
        }
        this.login = function () {
            var res = {
                "userId": "SR0062710300",
                "infor": {
                    "uid": "SR0062710300",
                    "mobile": "18711078492",
                    "sn": "SR0062710300",
                    "email": "SR0062710300@szse.com",
                    "loa": "40"
                },
                "deviceToken": "3daef4ae-5fd3-458f-8561-5b1274bc7fbe",
                "tgtToken": "TGT-40-1996-Yq2Eb4dFcAIHcVMUNsLQjI0OZBpTq0DcTx7m7KNoX6VeHKpG49-cas01.example.org",
                "userInfo": {
                    "userId": "SR0062710300",
                    "enterpriseId": "szsesprweb",
                    "classType": null,
                    "loginName": "SR0062710300",
                    "userType": 0,
                    "displayName": "小A"
                }
            };
            native.storage.setItem('keyLoginData', JSON.stringify(res));
            // window[callback](0, { data: res });
        }
        this.logout = function () {
            native.storage.removeItem('keyLoginData');
        }
        this.returnUserId = function () {
            return '112121'
        }
        this.share = function (url, title, description, picture) {
            console.log("share", url, title, description, picture);
            window.open(url);
        }
        this.clearCache = function (callback) {
            window[callback](true)
        }
        this.getCacheSize = function() {
            return '0.01MB';
        }
        this.rsa = function (text) {
            return text;
        }
        this.aes = function (text) {
            return text;
        }
        this.log = function (text) {
            // console.log(text);
        }

        this.isSupportBiometric = function() {
            return true;
        }
        this.isBiometricEnable = function() {
            return true;
        }
        this.isEnabledGesture = function() {
            return true;
        }
        this.setGestureEnable = function(enable) {
            console.log(enable);
        }
        this.setBiometricEnable = function(enable, callback) {
            console.log(enable +'-'+ callback);
            window[callback](true)
        }
        this.gestureModify = function() {
            console.log('gestureModify');
        }
        this.tdPropertyPoint = function(eventId, eventLabel) {
            console.log(eventId +': '+ eventLabel)
        }
        this.tdEventPoint = function(eventId, eventLabel) {
            console.log(eventId +': '+ eventLabel)
        }
        this.back = function (callback) {
            console.log(callback);
            history.back(-1)
        }
        this.suspensionView = function (isShow) {
            console.log(isShow);
        }
        this.validationSuccess = function (data) {
            console.log(data);
        }
        this.privacyAuthorizationQuery = function (method) {
            console.log(method);
        }
        this.version = function () {
            return JSON.stringify({
                marketingVersion: '0.0.1',
                hasNewVersion: true
            });
        }
        this.hiddenTabBar = function(isHidden) {
            console.log('hiddenTabBar: ' + isHidden);
        }
        this.refresh = function(path, method) {
            console.log('(refresh) path:' + path + ' method:' + method)
        }
        this.getStatusBarHeight = function() {
            return 20;
        }
    }

    /**
     * UI组件
     */
    function UI(wrapper) {

        /**
         * 显示toast
         */
        this.toast = function (text) {
            wrapper.toast(text);
        }

        /**
         * 关闭当前界面
         */
        this.finish = function () {
            wrapper.finish();
        }

        /**
         * 显示输入法，iOS不支持
         */
        this.showInputMethod = function () {
            wrapper.showInputMethod();
        }

        /**
         * 隐藏输入法，iOS不支持
         */
        this.hiddenInputMethod = function () {
            wrapper.hiddenInputMethod();
        }

        /**
         * 返回  关闭view
         */
        this.back = function(callback) {
            wrapper.back(callback);
        }
        /**
         * 版本信息  marketingVersion当前版本 hasNewVersion是否有更新
         */
        this.version = function () {
            return JSON.parse(wrapper.version());
        }
        /**
         * 是否隐藏底部菜单
         */
        this.hiddenTabBar = function(isHidden) {
            wrapper.hiddenTabBar(isHidden);
        }
        /**
         * 获取状态栏高度
         */
        this.getStatusBarHeight = function() {
            return wrapper.getStatusBarHeight();
        }
    }

    /**
     * 网络组件
     */
    function Net(wrapper) {

        /**
         * 是否有网络
         */
        this.hasNetWork = function () {
            return wrapper.hasNetWork();
        }
    }

    /**
     * 文件组件
     */
    function File(wrapper) {

        /**
         * 跳转轻应用指定页面
         */
        this.href = function (jsonURL, title, tag, htmlURL) {
            wrapper.href(jsonURL, title, tag, htmlURL);
        }

        /**
         * 打开附件
         * @param {string}  url  附件下载地址
         */
         this.openDoc = function(url){
            wrapper.openDoc(url);
        }

        /**
         * 跳转轻应用指定页面 任意轻应用之间跳转
         */
         this.lightAppHref = function(tag, path, title) {
            wrapper.lightAppHref(tag, path, title);
        }
        
        this.openFull = function (tagpath) {
            wrapper.openFull(tagpath);
        }


        /**
          * 打开html的网页
          */
        this.html = function (url, title) {
            wrapper.html(url, title);
        }

        /**
          * 调用轻应用指定页面方法
          */
        this.refresh = function(path, method) {
            wrapper.refresh(path, method);
        }
    }

    /**
     * 存储
     */
    function Storage(wrapper) {

        /**
         * 保存数据
         */
        this.setItem = function (key, value) {
            wrapper.setItem(key, value);
        }

        /**
         * 获取数据
         */
        this.getItem = function (key) {
            return wrapper.getItem(key);
        }

        /**
         * 移除数据
         */
        this.removeItem = function (key) {
            wrapper.removeItem(key);
        }

        /**
         * 清除缓存
         */
        this.clearCache = function (callback) {
            window.clearCacheCallback = function(res) {
                window.clearCacheCallback = null;
                callback(res);
            };
            wrapper.clearCache("clearCacheCallback");
        }

        /**
         * 获取缓存大小
         */
        this.getCacheSize = function() {
            return wrapper.getCacheSize();
        }
    }

    /**
     * 其他组件
     */
    function Util(wrapper) {

        /**
         * 拨打电话
         */
        this.callPhone = function (phone) {
            wrapper.callPhone(phone);
        }

        /**
         * 复制文本
         */
        this.copy = function (text) {
            wrapper.copy(text);
        }

        /**
         * 记录日志
         */
        this.log = function (text) {
            wrapper.log(text);
        }

        /**
         * 是否支持生物识别 返回bool类型
         */
        this.isSupportBiometric = function() {
            return wrapper.isSupportBiometric();
        }
        /**
         * 是否设置生物识别 返回bool类型
         */
        this.isBiometricEnable = function() {
            return wrapper.isBiometricEnable();
        }
        /**
         * 是否设置手势登录 返回bool类型
         */
        this.isEnabledGesture = function() {
            return wrapper.isEnabledGesture();
        }
        /**
         * 设置手势开关
         * @param {boolean} enable 是否开启
         */
        this.setGestureEnable = function(enable) {
            wrapper.setGestureEnable(enable);
        }
        /**
         * 设置生物识别开关
         * @param {boolean} enable 是否开启
         */
        this.setBiometricEnable = function(enable, callback) {
            var cbName = 'nativeBiometricCallback'
            window[cbName] = function(flag) {
                window[cbName] = null;
                callback(flag);
            };
            wrapper.setBiometricEnable(enable, cbName);
        }
        /**
         * 修改手势密码
         */
        this.gestureModify = function() {
            wrapper.gestureModify();
        }
        /**
         * 属性埋点
         */
        this.tdPropertyPoint = function(eventId, eventLabel) {
            wrapper.tdPropertyPoint(eventId, eventLabel);
        }
        /**
         * 事件埋点
         */
        this.tdEventPoint = function(eventId, eventLabel) {
            wrapper.tdEventPoint(eventId, eventLabel);
        }
    }

    /**
     * 业务相关功能
     */
    function Business(wrapper) {

        /**
         * 登录
         * 回调的code，0：成功；1：取消
         * json：后台返回的数据，json对象
         */
        this.login = function () {
            // window.nativeLoginCallback = function (code, json) {
            //     window.nativeLoginCallback = null;
            //     callback(code, json);
            // };
            wrapper.login();
        }

        /**
         * 退出登录
         */
        this.logout = function () {
            wrapper.logout();
        }
        
        /**
         * 获取登录状态
         */
        this.returnUserId = function () {
            return wrapper.returnUserId();
        }

        /**
         * 分享
         */
         this.share = function(url, title, description, picture) {
            wrapper.share(url, title, description, picture);
        }

        /**
         * RSA加密
         */
        this.rsa = function (text) {
            return wrapper.rsa(text);
        }

        /**
         * AES加密
         */
        this.aes = function(text) {
            return wrapper.aes(text);
        }

        /**
         * 显示或隐藏悬浮按钮
         */
        this.suspensionView = function (isShow) {
            wrapper.suspensionView(isShow);
        }

        /**
         * 拖动验证码匹配成功回调
         */
        this.validationSuccess = function (data) {
            wrapper.validationSuccess(data);
        }
        this.privacyAuthorizationQuery = function (method) {
            wrapper.privacyAuthorizationQuery(method);
        }
    }

    function Native() {
        var wrapper = new Developer();
        this.ui = new UI(wrapper);
        this.net = new Net(wrapper);
        this.file = new File(wrapper);
        this.util = new Util(wrapper);
        this.storage = new Storage(wrapper);
        this.business = new Business(wrapper);
    }
    window.native = new Native();

})(window);