/*!
 * Native Javascript Library
 * v1.0.2 (2019-11-13)
 * 新增登录和分享接口
 * v1.0.3 (2019-11-14)
 * 新增rsa加密算法
 * v1.0.4 (2019-11-16)
 * 新增打开文件接口
 * v1.0.5 (2019-11-16)
 * 新增退出登录接口
 * v1.0.6 (2019-11-19)
 * 新增打开网页接口
 * v1.0.7 (2019-11-20)
 * 修改判断android手机和iOS手机的逻辑
 * v1.0.8 (2019-12-12)
 * iOS适配WKWebView
 * v1.0.9 (2020-05-06)
 * 默认使用WKWebView
 * v1.0.10 (2020-05-14)
 * 新增记录日志方法
 * v1.0.11 (2020-07-14)
 * 新增打开文件和分享功能
 * v1.0.12（2020-07-15）
 * 新增打开超链接的分享功能
 */
(function (window) {
    /**
	 * 开发使用的调试数据
	 */
    function Developer() {
        this.toast = function (text) {
            console.log("toast:" + text);
        }
        this.finish = function () {
            window.close();
        }
        this.showInputMethod = function () {
            console.log("showInputMethod");
        }
        this.hiddenInputMethod = function () {
            console.log("hiddenInputMethod");
        }
        this.hasNetWork = function () {
            return true;
        }
        this.href = function (tag, path) {
            console.log("href " + tag + " " + path);
        }
        this.open = function (url) {
            window.open(url);
        }
        this.html = function (url, title) {
            window.open(url);
        }
        this.open = function (url, title, shareEnabled) {
            window.open(url);
        }
        this.html = function (url, title, shareEnabled) {
            window.open(url);
        }
        this.callPhone = function (phone) {
            console.log("callPhone:" + phone);
        }
        this.copy = function (text) {
            console.log("copy:" + text);
        }
        this.setItem = function (key, value) {
            localStorage.setItem(key, value);
        }
        this.getItem = function (key) {
            return localStorage.getItem(key);
        }
        this.removeItem = function (key) {
            localStorage.removeItem(key);
        }
        this.login = function (callback) {
            var res = {
                "userId": "SR0062710300",
                "infor": {
                    "uid": "SR0062710300",
                    "mobile": "18711078492",
                    "sn": "SR0062710300",
                    "email": "SR0062710300@szse.com",
                    "loa": "40"
                },
                "deviceToken": "3daef4ae-5fd3-458f-8561-5b1274bc7fbe",
                "tgtToken": "TGT-40-1996-Yq2Eb4dFcAIHcVMUNsLQjI0OZBpTq0DcTx7m7KNoX6VeHKpG49-cas01.example.org",
                "userInfo": {
                    "userId": "SR0062710300",
                    "enterpriseId": "szsesprweb",
                    "classType": null,
                    "loginName": "SR0062710300",
                    "userType": 0,
                    "displayName": "小A"
                }
            };
            native.storage.setItem('keyLoginData', JSON.stringify(res));
            window[callback](0, { data: res });
        }
        this.logout = function () {
            native.storage.removeItem('keyLoginData');
        }
        this.share = function (url, title, description) {
            console.log("share", url, title, description);
            window.open(url);
        }
        this.clearCache = function () {
            console.log("clearCache");
        }
        this.rsa = function (text) {
            return text;
        }
        this.log = function (text) {
            // console.log(text);
        }
        this.version = function () {
            return "dev 1.0.8"
        }
        this.isUsingBackServer = function() {
            return true;
        }
        this.isUsingBackServer = function() {
            return true;
        }
    }

    /**
     * UI组件
     */
    function UI(wrapper) {

        /**
         * 显示toast
         */
        this.toast = function (text) {
            wrapper.toast(text);
        }

        /**
         * 关闭当前界面
         */
        this.finish = function () {
            wrapper.finish();
        }

        /**
         * 显示输入法，iOS不支持
         */
        this.showInputMethod = function () {
            wrapper.showInputMethod();
        }

        /**
         * 隐藏输入法，iOS不支持
         */
        this.hiddenInputMethod = function () {
            wrapper.hiddenInputMethod();
        }
    }

    /**
     * 网络组件
     */
    function Net(wrapper) {

        /**
         * 是否有网络
         */
        this.hasNetWork = function () {
            return wrapper.hasNetWork();
        }
    }

    /**
     * 文件组件
     */
    function File(wrapper) {

        /**
         * 跳转轻应用指定页面
         */
        this.href = function (tag, path) {
            wrapper.href(tag, path);
        }

        /**
         * 打开文件
         * url 文件网络地址
         */
        this.open = function (url, title, shareEnabled) {
            wrapper.open(url, title, shareEnabled);
        }

        /**
          * 打开html的网页
          */
        this.html = function (url, title, shareEnabled) {
            wrapper.html(url, title, shareEnabled);
        }
    }

    /**
     * 存储
     */
    function Storage(wrapper) {

        /**
         * 保存数据
         */
        this.setItem = function (key, value) {
            wrapper.setItem(key, value);
        }

        /**
         * 获取数据
         */
        this.getItem = function (key) {
            return wrapper.getItem(key);
        }

        /**
         * 移除数据
         */
        this.removeItem = function (key) {
            wrapper.removeItem(key);
        }

        /**
         * 清除缓存
         */
        this.clearCache = function () {
            wrapper.clearCache();
        }
    }

    /**
     * 其他组件
     */
    function Util(wrapper) {

        /**
         * 拨打电话
         */
        this.callPhone = function (phone) {
            wrapper.callPhone(phone);
        }

        /**
         * 复制文本
         */
        this.copy = function (text) {
            wrapper.copy(text);
        }

        /**
         * 记录日志
         */
        this.log = function (text) {
            wrapper.log(text);
        }
    }

    /**
     * 业务相关功能
     */
    function Business(wrapper) {

        /**
         * 登录
         * 回调的code，0：成功；1：取消
         * json：后台返回的数据，json对象
         */
        this.login = function (callback) {
            window.nativeLoginCallback = function (code, json) {
                window.nativeLoginCallback = null;
                callback(code, json);
            };
            wrapper.login("nativeLoginCallback");
        }

        /**
         * 退出登录
         */
        this.logout = function () {
            wrapper.logout();
        }

        /**
         * 分享
         */
        this.share = function (url, title, description) {
            wrapper.share(url, title, description);
        }

        /**
         * RSA加密
         */
        this.rsa = function (text) {
            return wrapper.rsa(text);
        }

        /**
         * 获取APP的版本号
         */
        this.version = function () {
            return wrapper.version();
        }
         /**
         * 是否使用备份服务
         */
         this.isUsingBackServer = function() {
            return wrapper.isUsingBackServer();
        }
    }

    function Native() {
        var wrapper = new Developer();
        this.ui = new UI(wrapper);
        this.net = new Net(wrapper);
        this.file = new File(wrapper);
        this.util = new Util(wrapper);
        this.storage = new Storage(wrapper);
        this.business = new Business(wrapper);
    }
    window.native = new Native();

})(window);