//扩展工具类方法
window.util = {
    fAdd: function(arg1, arg2) {
        var r1, r2, decimal, result, i;
        var zero = '';

        try {
            r1 = arg1.toString().split('.')[1].length;
        } catch (e) {
            r1 = 0;
        };
        try {
            r2 = arg2.toString().split('.')[1].length;
        } catch (e) {
            r2 = 0;
        }
        decimal = Math.max(r1, r2);
        arg1 = +(+arg1).toFixed(decimal).replace(/\./g, '');
        arg2 = +(+arg2).toFixed(decimal).replace(/\./g, '');
        result = (arg1 + arg2) + '';
        i = result.length - decimal;
        for (var n = i; n < 0; n++) {
            zero += '0';
        }
        return decimal === 0 ? result : (i <= 0 ? ('0' + '.' + zero + result) : (result.slice(0, i) + '.' + result.slice(-decimal)));
    },
    fSubtract: function(arg1, arg2) {
        var r1, r2, decimal, result, i;
        var zero = '';

        try {
            r1 = arg1.toString().split('.')[1].length;
        } catch (e) {
            r1 = 0;
        };
        try {
            r2 = arg2.toString().split('.')[1].length;
        } catch (e) {
            r2 = 0;
        }
        decimal = Math.max(r1, r2);
        arg1 = +(+arg1).toFixed(decimal).replace(/\./g, '');
        arg2 = +(+arg2).toFixed(decimal).replace(/\./g, '');
        result = (arg1 - arg2) + '';
        i = result.length - decimal;
        if (+result < 0)
            i--;
        for (var n = i; n < 0; n++) {
            zero += '0';
        }

        if (decimal === 0) {
            return result;
        } else if (i <= 0 && +result < 0) {
            return '-0.' + zero + result.replace(/\-/g, '');
        } else if (i <= 0 && +result >= 0) {
            return '0.' + zero + result;
        } else if (i > 0 && +result < 0) {
            result = result.replace(/\-/, '');
            return '-' + result.slice(0, i) + '.' + result.slice(-decimal);
        } else if (i > 0 && +result >= 0) {
            return result.slice(0, i) + '.' + result.slice(-decimal);
        }
    },
    fRemainder: function(arg1, arg2) {
        arg1 = arg1 + '';
        var r, result, i;
        var reg = /\./;
        var zero = '';

        r = reg.test(arg1) ? arg1.split('.')[1].length : 0; //小数位数
        result = (+arg1.replace(reg, '') % arg2) + '';
        i = result.length - r;
        for (var n = i; n < 0; n++) {
            zero += '0';
        }
        return r === 0 ? result : (i <= 0 ? ('0' + '.' + zero + result) : (result.slice(0, i) + '.' + result.slice(-r)));
    },
    fDiv: function(arg1, arg2, decimal) {
        decimal = decimal || 2;
        var r1, r2, result;
        var reg = /\./;

        try {
            r1 = arg1.toString().split('.')[1].length;
        } catch (e) {
            r1 = 0;
        };
        try {
            r2 = arg2.toString().split('.')[1].length;
        } catch (e) {
            r2 = 0;
        }
        arg1 = +(+arg1).toFixed(decimal).replace(/\./g, '');
        arg2 = +(+arg2).toFixed(decimal).replace(/\./g, '');
        result = (arg1 / arg2) + '';

        return reg.test(result) ? result.toFixed(decimal) : result;
    },
    getQueryString: function(name) { //获取url参数keyword
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)');
        var r = window.location.search.substr(1).match(reg);

        if (r != null)
            return $.trim(decodeURI(r[2]).toString().replace(/<[^>]+>/g, ''));
        return null;
    },
    getHashString: function(name) { //获取url参数Hash
        var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)');
        var r = window.location.hash.substr(1).match(reg);

        if (r != null)
            return $.trim(decodeURI(r[2]).toString().replace(/<[^>]+>/g, ''));
        return null;
    }
};
