/* szsewebui AnuglarJS 胶水代码(szsewebui保留关键字) */

s.ui.ngControls = angular.module('s.ui.ngControls', []);
s.ui.ngComponents = angular.module('s.ui.ngComponents', []);
s.ui.ngLayouts = angular.module('s.ui.ngLayouts', []);
s.ui.ngExtendControls = angular.module('s.ui.ngExtendControls', ['s.ui.ngExtend.modal', 's.ui.ngExtend.validation','s.ui.ngExtend.tab']);
s.ui.ngModules = angular.module('s.ui.ngModules', [])
	.factory('cModalService', ['$compile',function ($compile){

        //console.log('app cModalService');

        // 动态加载的内容compiled以后，从dom中移除还不够，还需要销毁$scope
        var modalScope= {};

        var defaults= {
            modalId: '',
            //modalClass:'',                // (必选参数)窗口div的id，指定id以后不会重新往modalContainer里面加内容
            remote: '',                 // 远程内容 /demo/components/paginator/remoteEditor.html',
            content: '',                // 本地内容
            parseData: function(data){  // 解析数据。 angularjs编译页面等
                // var scopeIdentity= this.settings.modalId.substring(1);
                // if(modalScope.scopeIdentity){
                //     modalScope.scopeIdentity.$destroy();
                // }
                // modalScope.scopeIdentity= this.settings.scope.$new();
                modalScope.scopeIdentity= this.settings.scope;
                return $compile(data)(modalScope.scopeIdentity);
            },       
            onInitialized: function(){  // 初始化完成
                // modal.show();
                this.show();
            },
            buttons: undefined,         // 扩展按钮

            // 非公开options
            show: false,                // 创建后直接显示
            bindTarget: false,          // 绑定element元素(button等)的click事件
        };

      return s.utilities.Modal(defaults);
    }])

/* dtpicker javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('calendar', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs){

            var onSelected = function(e,date){
                s.utilities.safeApply(scope,function(){
                    scope.onSelected({date:date});
                    scope.model = date;
                });
            };

            var render;
            if(element.attr('data-s-on-render')){
                render = function(date){
                    return scope.render({date:date});
                };
            }
            var defaultOptions = {
                onSelected: onSelected,
                render: render,
                disabledDates:scope.disabledDates,
            };

            var plugin= new s.ui.controls.Calendar(element, defaultOptions);

            scope.$watch("model",function(){
                plugin.setDate(scope.model);
            });

            scope.calendarApi = plugin.getApi();
        }

        return {
            scope: {
                model: '=sModel',
                calendarApi: '=sCalendarApi',
                disabledDates:'=sDisabledDates',
                onSelected:'&sOnSelected',
                render:'&sOnRender'
            },
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* cascade javascript AngularJS */
s.ui.ngControls
    .directive('cascade', ['$rootScope', '$compile', function($rootScope, $compile){
        function link($scope, $element, $attrs, ngModel, link){
            var onChanged = function(e,value){
                s.utilities.safeApply($scope,function(){
                    if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                    }
                });
            };
            var defaultOptions = {
                data: $scope.data,
                onChanged: onChanged
            };
            var plugin= new s.ui.controls.Cascade($element, defaultOptions);

            if(ngModel){
                ngModel.$parsers.push(function(){
                    return plugin.getValue();
                });
                ngModel.$formatters.push(function(value){
                    return plugin.setValue(value);
                });
            }

            $scope.$watch("data",function(data){
                plugin.updateDate(data);
            });

            if(typeof $element.attr('ng-disabled') !== 'undefined'){
                $scope.$watch("ngDisabled",function(newValue,oldValue){
                    if (!newValue && newValue !== false) {
                        return;
                    }
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }
        }

        return {
            scope: {
                ngDisabled: '=ngDisabled',
                data:'=sData',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* collapse javascript AngularJS */

s.ui.ngControls
    .directive('collapse', ['$rootScope', '$compile','$timeout', function($rootScope, $compile,$timeout){
        function getTargetFromTrigger($trigger) {
            var href;
            var target = $trigger.attr('data-s-target')
            || (href = $trigger.attr('href')) && href.replace(/.*(?=#[^\s]+$)/, ''); // strip for ie7

            return $(target);
        }

        function link(scope, element, attrs, undefined, link){
            //$element.collapse({});
               scope.plugin=null;
               $timeout(function(){
                    scope.plugin= new s.ui.controls.Collapse(element, {});
                    //scope.show='iapweb' 
               },1000) 

               scope.$watch("show+plugin",function(){
                        var target = getTargetFromTrigger(element);
                        if(scope.plugin)
                        if(scope.show){
                            scope.plugin.show(target);
                        }else{
                            scope.plugin.hide(target);
                        }
                });
        }

        return {
            scope: {
                show: '=sShow'
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'

            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* typeahead javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('combobox', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var onSelected = function(e,value,obj){
                  s.utilities.safeApply(scope,function(){
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                    scope.onSelected({value:obj});
                });
               
            };

            var onChanged = function(e,value){
                  s.utilities.safeApply(scope,function(){
                     scope.model = value;
                });
            };
            //删除ng-model值
             var clear = function(e,value){
                  s.utilities.safeApply(scope,function(){
                    if(ngModel){
                        ngModel.$setViewValue(null);
                        ngModel.$render();
                     }
                });
            };
            var matcher;
            if(element.attr('data-s-on-matcher')){
                matcher = function(item,query){
                    return scope.matcher({item:item,query:query});
                };
            }

            var sorter;
            if(element.attr('data-s-on-sorter')){
                sorter = function(items){
                    return scope.sorter({items:items});
                };
            }

             var template;
            if(element.attr('data-s-on-template')){
                template = function(html,node){
                    return scope.template({html:html,node:node});
                };
            }
            var mouseover;
            if(element.attr('data-s-on-mouseover')){
                mouseover = function(e,node){
                    return scope.mouseover({e:e,node:node});
                };
            }
            var mouseout;
            if(element.attr('data-s-on-mouseout')){
                mouseout = function(e,node){
                    return scope.mouseout({e:e,node:node});
                };
            }

            var defaultOptions = {
                onSelected: onSelected,
                onChanged: onChanged,
                matcher: matcher,
                sorter: sorter,
                template:template,
                mouseover:mouseover,
                mouseout:mouseout,
                clear:clear
            };

            var plugin= new s.ui.controls.Combobox(element, defaultOptions);
            scope.$watch("data",function(){
                plugin.setSource(scope.data);
            });

            // scope.$watch("model",function(){
            //     plugin.setValue(scope.model);
            // });

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    // if (!value) {
                    //   return null;
                    // }
                    // plugin.setValue(value);
                    // plugin.refresh();
                    value = plugin.getValue(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    // if (!value && value!=='') {
                    //   return null;
                    // }
                    if(typeof value == 'undefined'){
                        return value;
                    }
                    plugin.setValue(value);
                    if(typeof value == 'object')
                        value  = plugin.displayText(value);
                    return value;
                });
            }

        }

        return {
            scope: {
                data: '=sData',
                // model:'=sModel',
                onSelected:'&sOnSelected',
                matcher:'&sOnMatcher',
                sorter:'&sOnSorter',
                template:'&sOnTemplate',
                mouseover:'&sOnMouseover',
                mouseout:'&sOnMouseout',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* cutpannel javascript AngularJS */

s.ui.ngControls
    .directive('cutpannel', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, undefined, link){
            //element.cutpannel({});
            var plugin = new s.ui.controls.Cutpannel(element, {});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* dtpicker javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('datepicker', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var change = function(e,value){
                s.utilities.safeApply(scope,function(){
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                });
            };
            var render;
            if(element.attr('data-s-on-render')){
                render = function(date){
                    return scope.render({date:date});
                };
            }
            var defaultOptions = {
                change: change,
                render: render,
                ngMinDate:scope.ngMinDate,
                ngMaxDate:scope.ngMaxDate,
                dateFrom:scope.dateFrom,
            };
            var plugin= new s.ui.controls.Datepicker(element, defaultOptions);

            if(ngModel){
                ngModel.$parsers.push(function(value){
                     if (!value) {
                      return null;
                    }
                    plugin.updateCalendarForValue(value);
                    value = plugin.getMomentDate(value);
                    if(plugin.getNumResult()){
                        value = moment(value).toDate();
                        value = value.getTime();
                    }
                    return value;
                });
                ngModel.$formatters.push(function(value){
                     if (!value) {
                      return null;
                    }
                    if(typeof value === 'number'){
                        value = new Date(value);
                        plugin.setNumResult(true);
                    }else{
                        value = moment(value);
                        plugin.setNumResult(false);
                    }
                    plugin.updateCalendarForValue(value);
                    return plugin.getMomentDate(value);
                });
            }
            if(typeof element.attr('ng-disabled') !== 'undefined') {
                scope.$watch("ngDisabled", function (newValue, oldValue) {
                    if (!newValue && newValue !== false) {
                        return;
                    }
                    if (newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }
            if(typeof element.attr('data-s-ng-min-date') !== 'undefined') {
                scope.$watch("ngMinDate", function (newValue, oldValue) {
                    plugin.setMinDate(newValue);
                    var d = plugin.getInputValue();
                    plugin.setValue(d);
                    plugin.renderCalendar();
                });
            }
            if(typeof element.attr('data-s-ng-max-date') !== 'undefined') {
                scope.$watch("ngMaxDate", function (newValue, oldValue) {
                    plugin.setMaxDate(newValue);
                    var d = plugin.getInputValue();
                    plugin.setValue(d);
                    plugin.renderCalendar();
                });
            }
        }

        return {
            scope: {
                ngDisabled: '=ngDisabled',
                dateFrom:'=sDateFrom',
                render:'&sOnRender',
                ngMinDate:'=sNgMinDate',
                ngMaxDate:'=sNgMaxDate'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* dtpicker javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('daterangepicker', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var change = function(e,value){
                s.utilities.safeApply(scope,function(){
                     // scope.model = value;
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                });
            };
            var defaultOptions = {
                change: change
            };
            if(element.attr('data-s-options')){
                defaultOptions.options = scope.options;
            }

            var plugin= new s.ui.controls.Daterangepicker(element, defaultOptions);

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    //value = JSON.parse(value);
                    //console.log(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    plugin.setValue(value);
                    return value;
                });
            }

            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(!newValue && newValue !== false){
                        return;
                    }
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

        }

        return {
            scope: {
                // model: '=sModel',
                options: '=sOptions',
                ngDisabled: '=ngDisabled'
                // totalSize: '=sTotalSize',
                // pageSize: '=sPageSize',
                // onSelectPage:'&sOnSelectPage'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* level javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('dropdown', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.dropdown({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* template javascript AngularJS */

s.ui.ngControls
    .directive('inputmask', ['$rootScope', '$compile', function($rootScope, $compile){
        return {
            scope: {
                rule: '=sRule',
                translation: '=sTranslation',
                maskExtend: '&sMaskExtend',
                sEvent: '=sEvent',
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: function ($scope, $element, $attrs, undefined, link){

                var maskExtend;
                if($element.attr('data-s-mask-extend')){
                    maskExtend=function(value){
                        return $scope.maskExtend({val:value});
                    }  
                }
                var plugin = new s.ui.controls.Inputmask($element, {
                    rule: $scope.rule,
                    translation: $scope.translation,
                    maskExtend: maskExtend,
                    event: $scope.sEvent,
                    email: $scope.sEmail
                });
            }
        };

    }]);
/* InputMultiSelect javascript AngularJS */

//angular.module('inputMultiSelect.controls', [])
s.ui.ngControls
    .directive('inputMultiSelect', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){

            var onSelected = function(e,value,obj){
                s.utilities.safeApply(scope,function(){
                    if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                    }
                    scope.onSelected({value:obj});
                });

            };

            var onChanged = function(e,value){
                s.utilities.safeApply(scope,function(){
                    scope.model = value;
                });
            };

            var matcher;
            if(element.attr('data-s-on-matcher')){
                matcher = function(item,query){
                    return scope.matcher({item:item,query:query});
                };
            }

            var sorter;
            if(element.attr('data-s-on-sorter')){
                sorter = function(items){
                    return scope.sorter({items:items});
                };
            }

            var template;
            if(element.attr('data-s-on-template')){
                template = function(html,node){
                    return scope.template({html:html,node:node});
                };
            }
            var mouseover;
            if(element.attr('data-s-on-mouseover')){
                mouseover = function(e,node){
                    return scope.mouseover({e:e,node:node});
                };
            }
            var mouseout;
            if(element.attr('data-s-on-mouseout')){
                mouseout = function(e,node){
                    return scope.mouseout({e:e,node:node});
                };
            }

            var defaultOptions = {
                onSelected: onSelected,
                onChanged: onChanged,
                matcher: matcher,
                sorter: sorter,
                template:template,
                mouseover:mouseover,
                mouseout:mouseout,
            };

            var plugin= new s.ui.controls.InputMultiSelect(element, defaultOptions);

            scope.$watch("data",function(){
                plugin.setSourceEx(scope.data);
            });

            // scope.$watch("model",function(){
            //     plugin.setValue(scope.model);
            // });

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    value = plugin.getValue(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    if(typeof value == 'undefined'){
                        return value;
                    }
                    plugin.setValue(value);
                    return value;
                });
            }

        }

        return {
            scope: {
                data: '=sData',
                // model:'=sModel',
                onSelected:'&sOnSelected',
                matcher:'&sOnMatcher',
                sorter:'&sOnSorter',
                template:'&sOnTemplate',
                mouseover:'&sOnMouseover',
                mouseout:'&sOnMouseout',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* likeit javascript AngularJS */

s.ui.ngControls
    .directive('likeit', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.likeit({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* template javascript AngularJS */

s.ui.ngControls
    .directive('loading', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs){
            
            var plugin= new s.ui.controls.Loading(element, {});

            scope.$watch("show",function(){
                if(scope.show){
                    plugin.start();
                }else{
                    plugin.stop();
                }
            });
        }

        return {
            scope: {
                show: '=sShow'
            },
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);

/* modal javascript AngularJS */

s.ui.ngControls
    .directive('modal', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            var options={isdrag:$scope.isdrag};
            $element.modal(options);
           
        }

        return {
            scope: {
                 isdrag: '@sIsdrag',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);

s.ui.ngControls
    .directive('monthpicker', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var change = function(e,value){
                s.utilities.safeApply(scope,function(){
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                });
            };

            var defaultOptions = {
                change: change
            };

            var plugin= new s.ui.controls.Monthpicker(element, defaultOptions);

            if(ngModel){
                ngModel.$parsers.push(function(value){                   
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    plugin.setValue(value);
                    return value;
                });
            }

           if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

             scope.monthpickerApi = plugin.getApi();
        }

        return {
            scope: {
                ngDisabled: '=ngDisabled',
                monthpickerApi: '=sMonthpickerApi',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* multiselect javascript AngularJS */

s.ui.ngControls
    .directive('multiselect', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var formatToValue = function(value){
                var values = [];
                for (var i = 0; i < value.length; i++) {
                    values.push(value[i].value);
                }
                return values.join(',');
            };
            var change = function(e,value){
                  s.utilities.safeApply(scope,function(){
                     value = JSON.parse(value);
                     scope.model = value;
                     scope.modelValue = formatToValue(value);
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                });
            };
            var sorter;
            if(element.attr('data-s-on-sorter')){
                sorter = function(items){
                    return scope.sorter({items:items});
                };
            }
            var defaultOptions = {
                change: change,
                sorter: sorter
            };

            var plugin= new s.ui.controls.Multiselect(element, defaultOptions);

            scope.$watch("data+modelValue",function(){
                plugin.updateData(scope.data);
                plugin.render();
                if(scope.modelValue){
                    plugin.setValue(scope.modelValue);
                }
            });
            /*scope.$watch(function(){
                        if(!ngModel) return ;
                        return ngModel.$modelValue;
                    },function(newValue,oldValue){
                        plugin.updateData(scope.data);
                        plugin.render();
                        if(scope.modelValue){
                            if(newValue){
                                 plugin.setValue(formatToValue(newValue));
                             }else{
                                 plugin.setValue(scope.modelValue);
                             }
                            
                        }else if(scope.model&&scope.model.length>0){
                            plugin.updateData(scope.data);
                            plugin.setValue(formatToValue(scope.model));
                        }else{
                            plugin.updateData(scope.data);
                            scope.modelValue='';
                            scope.model=[];
                            plugin.setValue('');
                        }               
            },true);*/
            scope.$watch("model",function(){
                plugin.updateData(scope.data);
                plugin.render();
                if(scope.modelValue){
                    plugin.setValue(scope.modelValue);
                }else if(scope.model&&scope.model.length>0){
                    plugin.setValue(formatToValue(scope.model));
                }else{
                    scope.modelValue='';
                    scope.model=[];
                    plugin.setValue('');
                }
            },true);

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    if (!value||value.length<=0) {
                        scope.modelValue='';
                        scope.model=[];
                        return null;
                    }
                    plugin.updateData(scope.data);
                    plugin.render();
                    plugin.setValue(formatToValue(value));
                    scope.modelValue = formatToValue(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    if (!value||value.length<=0) {
                        scope.modelValue='';
                        scope.model=[];
                        return null;
                    }
                    plugin.updateData(scope.data);
                    plugin.render();
                    plugin.setValue(formatToValue(value));
                    scope.modelValue = formatToValue(value);
                    return value;
                });
            }

            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if (!newValue && newValue!== false) {
                              return;
                            }
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

        }

        return {
            scope: {
                data: '=sData',
                model: '=sModel',
                modelValue: '=sModelValue',
                ngDisabled: '=ngDisabled',
                sorter:'&sOnSorter'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* combobox javascript AngularJS */

s.ui.ngControls
    .directive('radio', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            // $element.combobox({});
            
				$element.Radio({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* rightselect javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('rightselect', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.rightselect({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* beautyselect javascript AngularJS */

s.ui.ngControls
    .directive('selectex', ['$rootScope', '$compile', function($rootScope, $compile){
        
        function link(scope, element, attrs, ngModel){
            // var onSelected = function(e,value){
            //     scope.$apply(function(){
            //          scope.model = value;
            //          scope.modelValue = value.value;
            //          if(ngModel){
            //             ngModel.$setViewValue(value);
            //             ngModel.$render();
            //          }
            //     });
            //     scope.onSelected({value:value});
            // };

            var onSelected = function(e,value){
                s.utilities.safeApply(scope,function(){
                    if(element.attr('data-s-model')){
                        scope.model = value;
                    }
                    if(element.attr('data-s-model-value')){
                        scope.modelValue = value.value;
                    }
                    // if(ngModel){
                    //     ngModel.$setViewValue(value.value);
                    //     ngModel.$render();
                    // }
                    scope.onSelected({value:value});
                });
                
            };

            var defaultOptions = {
                onSelected: onSelected
            };

            var plugin= new s.ui.controls.Selectex(element, defaultOptions);

             scope.$watch("data",function(){
                plugin.updateData(scope.data);
                if(scope.modelValue){
                    plugin.setModelValue(scope.modelValue);
                }else if(scope.model){
                    plugin.setModelValue(scope.model.value);
                }
                
                plugin.render();
                var flag = true;
                if(scope.modelValue && scope.data && scope.data.length){
                    for(var i = 0, len = scope.data.length; i<len; i++){
                        if(scope.modelValue == scope.data[i].value){
                            flag = false;
                        }
                    }
                    
                    if(flag){
                        scope.modelValue = null;
                        if(ngModel){
                            ngModel.$setViewValue(null);
                            ngModel.$render();
                        }
                        return;
                    } 
                }
            },true);

            // var ngModel= element.attr('ng-model');
            // if(ngModel){
            //     scope.$parent.$watch(ngModel, function(newValue, oldValue){
            //         plugin.setValue(newValue); 
            //         plugin.refresh();
            //     });
            // }
            scope.$watch("model",function(newValue,oldValue){
                // console.log(ngModel.$modelValue);
                // console.log(ngModel.$viewValue);
                if (!newValue && newValue !== 0) {
                  return;
                }
                plugin.setModelValue(newValue.value);
                plugin.render();
                // if (newValue === oldValue) {
                //   return;
                // }
            });

             scope.$watch("modelValue",function(newValue,oldValue){
               
                if(newValue===undefined) return ;
                
                plugin.setModelValue(newValue);
                plugin.render();
                
            });
           
            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }
        }

        return {
            scope: {
                data: '=sData',
                model: '=sModel',
                modelValue: '=sModelValue',
                ngDisabled: '=ngDisabled',
                onSelected:'&sOnSelected'
            },
            require:'?^ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* selectlist javascript AngularJS */

s.ui.ngControls
    .directive('selectlist', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var clicked;
                 if(element.attr('data-s-on-click')){
                        clicked = function(e,node){
                        return scope.clicked({e:e,node:node});
                    };
                 }
             var mouseovered;
                 if(element.attr('data-s-on-mouseover')){
                        mouseovered = function(e,node){
                        return scope.mouseovered({e:e,node:node});
                    };
                 }

             var defaultOptions = {
                        dataSource:scope.data,
                        click:clicked,
                        mouseover:mouseovered,
                    };
             var plugin= new s.ui.controls.Selectlist(element, defaultOptions);
                 scope.api=plugin.getApi();
                 
        }

        return {
            scope: {
                data: '=sData',
                api:'=sApi',
                clicked: '&sOnClick',
                mouseovered: '&sOnMouseover',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* sidebar javascript AngularJS */

s.ui.ngControls
    .directive('sidebar', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.sidebar({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* spinner javascript AngularJS */

s.ui.ngControls
    .directive('spinner', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.spinner({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* template javascript AngularJS */

s.ui.ngControls
    .directive('switchex', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
                var plugin= new s.ui.controls.Switchex($element, {});
        }

        return {
            scope: {
               
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* tab javascript AngularJS */

s.ui.ngControls
    .directive('tabs', ['$rootScope', '$compile', function($rootScope, $compile){
        function link(scope, element, attrs){
            
            var onSelected = function(e, index){
                // scope.page.index = index;
                scope.onSelected({index:index});
            };

            var defaultOptions = {
                onSelected: onSelected
            };

            var plugin= new s.ui.controls.Tabs(element, defaultOptions);

            // scope.$watch("page",function(){
            //     if(!scope.page)
            //         return;
            //     //if(newValue === oldValue)
            //     //    return;
            //     plugin.setActive(scope.page.index);
            // });

            scope.tabApi = plugin.getApi();
        }

        return {
            scope: {
                tabApi: '=sTabApi',
                // page: '=sIndex',
                onSelected: '&sOnSelected'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

        // function link($scope, $element, $attrs, undefined, link){
        //     $element.tabs({});
        // }

        // return {
        //     scope: {
        //         // instance: '=controller',
        //         // templateUrl: '@',
        //         // unload: '&'
        //     },
        //     restric: 'A',
        //     transclude: false,
        //     link: link
        // };

    }]);
/* textlimit javascript AngularJS */

s.ui.ngControls
    .directive('textlimit', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            var updateModel = function(e,data){
                    //ngModel.$setViewValue(data);
                //     s.utilities.safeApply(scope,function(){
                //      //scope.model = data;
                //      if(ngModel){
                //         ngModel.$setViewValue(data);
                //         ngModel.$render();
                //      }
                // });
            };

            var defaultOptions = {
                update: updateModel
            };

            var plugin= new s.ui.controls.Textlimit(element, defaultOptions);

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    // if (!value) {
                    //   return null;
                    // }
                    // plugin.setValue(value);
                    plugin.refresh();
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    // if (!value && value!=='') {
                    //   return null;
                    // }
                    if(typeof value == 'undefined'){
                        return value;
                    }
                    plugin.setValue(value);
                    plugin.refresh();
                    return value;
                });
            }

            // scope.$watch("model",function(newValue, oldValue){                
            //     //plugin.setValue(newValue);
            //     plugin.refresh();
            // });
        }

        // function link($scope, $element, $attrs, undefined, link){
        //     // $element.textlimit({});
        //     var plugin= new s.ui.controls.Textlimit($element, {});

        //     var ngModel= $element.attr('ng-model');
        //     if(ngModel){
        //         $scope.$parent.$watch(ngModel, function(newValue, oldValue){
        //             plugin.setValue(newValue);
        //              plugin.refresh();
        //         });
        //     }
        // }

        return {
            scope:{
                //model:'=sModel'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* timepicker javascript AngularJS */
s.ui.ngControls
    .directive('timepicker', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel) {
            var change = function (e, value) {
                s.utilities.safeApply(scope, function () {
                    if (ngModel) {
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                    }
                });
            };

            var defaultOptions = {
                change: change,
                minDate:scope.minDate,
                maxDate:scope.maxDate
            };

            var plugin = new s.ui.controls.Timepicker(element, defaultOptions);
            plugin.updateView();

            if (ngModel) {
                ngModel.$parsers.push(function (value) {
                    if (!value) {
                        plugin.setValue(null);
                        return null;
                    }else{
                        plugin.setValue(value);
                        return value;
                    }
                });
                ngModel.$formatters.push(function (value) {
                    if (!value) {
                        plugin.setValue(null);
                        return null;
                    }else{
                        plugin.setValue(value);
                        return value;
                    }
                });
            }

            if (typeof element.attr('data-s-min-date') !== 'undefined') {
                scope.$watch("minDate", function (newValue, oldValue) {
                    plugin.getApi().setMinDate(newValue);
                    plugin.getApi().render();
                });
            }
            if (typeof element.attr('data-s-max-date') !== 'undefined') {
                scope.$watch("maxDate", function (newValue, oldValue) {
                    plugin.getApi().setMaxDate(newValue);
                    plugin.getApi().render();
                });
            }
            if (typeof element.attr('ng-disabled') !== 'undefined') {
                scope.$watch("ngDisabled", function (newValue, oldValue) {
                    if (!newValue && newValue !== false) {
                        return;
                    }
                    if (newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }
        }

        return {
            scope: {
                // model: '=sModel',
                ngDisabled: '=ngDisabled',
                minDate:'=sMinDate',
                maxDate:'=sMaxDate'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* typeahead javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('typeahead', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, ngModel){
            
            var onSelected = function(e,value,obj){
                  s.utilities.safeApply(scope,function(){
                     if(ngModel){
                        ngModel.$setViewValue(value);
                        ngModel.$render();
                     }
                    scope.onSelected({value:obj});
                });
               
            };

            var onChanged = function(e,value){
                  s.utilities.safeApply(scope,function(){
                     scope.model = value;
                });
            };

            var matcher;
            if(element.attr('data-s-on-matcher')){
                matcher = function(item,query){
                    return scope.matcher({item:item,query:query});
                };
            }

            var sorter;
            if(element.attr('data-s-on-sorter')){
                sorter = function(items){
                    return scope.sorter({items:items});
                };
            }

             var template;
            if(element.attr('data-s-on-template')){
                template = function(html,node){
                    return scope.template({html:html,node:node});
                };
            }
            var mouseover;
            if(element.attr('data-s-on-mouseover')){
                mouseover = function(e,node){
                    return scope.mouseover({e:e,node:node});
                };
            }
            var mouseout;
            if(element.attr('data-s-on-mouseout')){
                mouseout = function(e,node){
                    return scope.mouseout({e:e,node:node});
                };
            }

            var defaultOptions = {
                onSelected: onSelected,
                onChanged: onChanged,
                matcher: matcher,
                sorter: sorter,
                template:template,
                mouseover:mouseover,
                mouseout:mouseout,
            };

            var plugin= new s.ui.controls.Typeahead(element, defaultOptions);

            scope.$watch("data",function(){
                plugin.setSource(scope.data);
            });

            // scope.$watch("model",function(){
            //     plugin.setValue(scope.model);
            // });

            if(ngModel){
                ngModel.$parsers.push(function(value){
                    // if (!value) {
                    //   return null;
                    // }
                    // plugin.setValue(value);
                    // plugin.refresh();
                    value = plugin.getValue(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    // if (!value && value!=='') {
                    //   return null;
                    // }
                    if(typeof value == 'undefined'){
                        return value;
                    }
                    plugin.setValue(value);
                    if(typeof value == 'object')
                        value  = plugin.displayText(value);
                    return value;
                });
            }

        }

        return {
            scope: {
                data: '=sData',
                // model:'=sModel',
                onSelected:'&sOnSelected',
                matcher:'&sOnMatcher',
                sorter:'&sOnSorter',
                template:'&sOnTemplate',
                mouseover:'&sOnMouseover',
                mouseout:'&sOnMouseout',
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };
    }]);
/* template javascript AngularJS */

s.ui.ngControls
    .directive('userselect', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs, undefined, link){
        	/*var datas=[{id:'1',name:'张三(12314143)',text:'张三(12314143)'},{id:'2',name:'张三三三(12314143)',text:'张三三(12314143)'},{id:'2',name:'李四三(12314143)',text:'李四三(12314143)'},{id:'3',name:'王五',text:'王五'},{id:'4',name:'陈六',text:'陈六'},{id:'5',name:'王九',text:'王九'},
                       {id:'6',name:'陈十三',text:'陈十三'},{id:'7',name:'陈七三',text:'陈七三'},{id:'8',name:'陈八三',text:'陈八三'}];*/
            var data=scope.data||[];
            var defaultOptions = {data:data};
            var plugin= new s.ui.controls.UserSelect(element, defaultOptions);

                scope.api=plugin.getApi();

                scope.$watch("data",function(data){
                    if(!data) return; 
                        plugin.updateData(scope.data);
                });
        }

        return {
            scope: {
               api:'=sApi',
               data:'=sData'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* template javascript AngularJS */

s.ui.ngControls
    .directive('template', ['$rootScope', '$compile', function($rootScope, $compile){

        function link($scope, $element, $attrs, undefined, link){
            $element.template({});
        }

        return {
            scope: {
                // instance: '=controller',
                // templateUrl: '@',
                // unload: '&'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* combobox javascript AngularJS */

s.ui.ngControls
    .directive('carousel', ['$rootScope', '$compile', function($rootScope, $compile){
        
        function link(scope, element, attrs){
            var plugin= new s.ui.controls.Carousel(element, {});

            scope.$watch("data",function(){
                plugin.updateData(scope.data);
            });
        }

        return {
            scope: {
                data: '=sData'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* orgselect javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('departselect', ['$rootScope', '$compile', function($rootScope, $compile){
        
        function link(scope, element, attrs, ngModel){

            var updateModel = function(data){
                 s.utilities.safeApply(scope,function(){
                    // ngModel.$setViewValue(data);
                     // data = JSON.parse(data);
                     scope.model = data;
                     if(element.attr('data-s-confirm')){
                            scope.confirm({data:data});
                     }
                     if(ngModel){
                        ngModel.$setViewValue(data);
                        ngModel.$render();
                     }
                });
            };
            var renderTreeNode;
            if(element.attr('data-s-render-tree-node')){
                renderTreeNode = function(node){
                    return scope.renderTreeNode({node:node});
                };
            }


            var defaultOptions = {
                onConfirm: updateModel,
                renderTreeNode:renderTreeNode
            };

            var plugin= new s.ui.controls.Departselect(element, defaultOptions);
            scope.api=plugin.getApi();
            scope.$watch("orgData+disabledNodeIds",function() {
                if (!scope.orgData)
                    return;
                if (scope.orgData) {
                    plugin.updateDataOrgs(scope.orgData,scope.disabledNodeIds);
                }
                if (typeof element.attr('data-s-disabled-node-ids') !== 'undefined') {
                    plugin.disableNodeByIds(scope.disabledNodeIds);
                }
            });

             //attrs.$observe('ngModel',function(){
            scope.$watch("model",function(newValue,oldValue){
                // console.log(ngModel.$modelValue);
                // console.log(ngModel.$viewValue);
                if(newValue)
                    plugin.setValue(newValue);
            });
            if(ngModel){
                ngModel.$parsers.push(function(value){
                    if(!value)
                        return null;
                    // value = JSON.parse(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    if(!value)
                        return null;
                    plugin.setValue(value);
                    return value;
                });
            }

            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

        }

        return {
            scope: {
                orgData: '=sDataOrg',
                ngDisabled: '=ngDisabled',
                model: '=sModel',
                confirm:'&sConfirm',
                api:'=sApi',
                renderTreeNode:'&sRenderTreeNode',
                disabledNodeIds:'=sDisabledNodeIds'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* cascade javascript AngularJS */

s.ui.ngControls
    .directive('combotree', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs){
            // $element.cascade({});
            var onNodeDbclick = function(e,node){
                scope.onNodeDbclick({e:e,node:node});
            };

            var onNodeChecked = function(e, node){
                scope.onNodeChecked({e:e,node:node});
            };

            var onNodeUnchecked = function(e, node){
                scope.onNodeUnchecked({e:e,node:node});
            };

            var onNodeCollapsed = function(e, node){
                scope.onNodeCollapsed({e:e,node:node});
            };

            var onNodeExpanded = function(e, node){
                scope.onNodeExpanded({e:e,node:node});
            };

            var onNodeEnabled = function(e, node){
                scope.onNodeEnabled({e:e,node:node});
            };

            var onNodeDisabled = function(e, node){
                scope.onNodeDisabled({e:e,node:node});
            };

            var onNodeSelected = function(e, node){
                scope.onNodeSelected({e:e,node:node});
            };

            var onNodeUnselected = function(e, node){
                scope.onNodeUnselected({e:e,node:node});
            };

            var defaultOptions = {
                data: [],
                selectedNodeIds:'',
                checkedNodeIds:'',
                onNodeDbclick: onNodeDbclick,
                onNodeChecked: onNodeChecked,
                onNodeUnchecked: onNodeUnchecked,
                onNodeCollapsed: onNodeCollapsed,
                onNodeExpanded: onNodeExpanded,
                onNodeEnabled: onNodeEnabled,
                onNodeDisabled: onNodeDisabled,
                onNodeSelected: onNodeSelected,
                onNodeUnselected: onNodeUnselected
            };

            var plugin= new s.ui.controls.Combotree(element, defaultOptions);

            scope.$watch("data+selectedNodeIds+checkedNodeIds",function(){
                if(!scope.data)
                    return;
                plugin.updateData(scope.data);
                if(typeof element.attr('data-s-selected-node-ids') !== 'undefined')
                    plugin.selectNodeByIds(scope.selectedNodeIds);
                if(typeof element.attr('data-s-checked-node-ids') !== 'undefined')
                    plugin.checkNodeByIds(scope.checkedNodeIds);
                if(typeof element.attr('data-s-disabled-node-ids') !== 'undefined')
                    plugin.disableNodeByIds(scope.disabledNodeIds);

            });

            scope.combotreeApi = plugin.getApi();


            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if (!newValue && newValue!== false) {
                              return;
                            }
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }


        }

        return {
            scope: {
                data: '=sData',
                combotreeApi: '=sCombotreeApi',
                selectedNodeIds:'=sSelectedNodeIds',
                checkedNodeIds:'=sCheckedNodeIds',
                ngDisabled: '=ngDisabled',
                onNodeDbclick: '&sOnNodeDbclick',
                onNodeChecked: '&sOnNodeChecked',
                onNodeUnchecked: '&sOnNodeUnchecked',
                onNodeCollapsed: '&sOnNodeCollapsed',
                onNodeExpanded: '&sOnNodeExpanded',
                onNodeDisabled: '&sOnNodeDisabled',
                onNodeEnabled: '&sOnNodeEnabled',
                onNodeSelected: '&sOnNodeSelected',
                onNodeUnselected: '&sOnNodeUnselected',
                disabledNodeIds:'=sDisabledNodeIds'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* orgselect javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('orgselect', ['$rootScope', '$compile', function($rootScope, $compile){
        
        function link(scope, element, attrs, ngModel){
            // if(!ngModel)
            //     return;

            var updateModel = function(data){
                 s.utilities.safeApply(scope,function(){
                    // ngModel.$setViewValue(data);
                     // data = JSON.parse(data);
                     scope.model = data;
                     if(element.attr('data-s-confirm')){
                            scope.confirm({data:data});
                     }
                     
                     if(ngModel){
                        ngModel.$setViewValue(data);
                        ngModel.$render();
                     }
                });
            };
            var renderTreeNode;
            if(element.attr('data-s-render-tree-node')){
                renderTreeNode = function(node){
                    return scope.renderTreeNode({node:node});
                };
            }
            var typeaheadTemplate;
            if(element.attr('data-s-typeahead-template')){
                typeaheadTemplate = function(html,node){
                    return scope.typeaheadTemplate({html:html,node:node});
                };
            }
            // var toView = function(data){
            //     if(!data)
            //         return;
            //     data = JSON.stringify(data);
            //     return data;
            // };

            // var valid = function(value){
            //     if((ngModel.$invalid && ngModel.isUnderfined(value)) || value === ''){
            //         return null;
            //     }else{
            //         return value;
            //     }
            // };

            // var toModel = function(data){
            //     if(!data)
            //         return;
            //     data = JSON.parse(data);
            //     return data;
            // };

            // ngModel.$parsers.push(valid);
            // ngModel.$parsers.push(toModel);
            // ngModel.$formatters.push(toView);

            var defaultOptions = {
                onConfirm: updateModel,
                inputHide:scope.inputHide,
                multiSelect:scope.multiSelect,
                renderTreeNode:renderTreeNode,
                typeaheadMethod:scope.typeaheadMethod

            };

            var plugin= new s.ui.controls.Orgselect(element, defaultOptions);
            scope.api=plugin.getApi();
            scope.$watch("userData+orgData",function(){
                if(scope.userData && scope.orgData){
                    plugin.updateDataOrgs(scope.orgData);
                    plugin.updateDataUsers(scope.userData);
                    
                    if(typeof element.attr('data-s-disabled-node-ids') !== 'undefined') {
                         plugin.disableNodeByIds(scope.disabledNodeIds);
                    }
                }
                
            });

            if(typeof element.attr('data-s-has-contact') !== 'undefined' && element.attr('data-s-has-contact')){
                scope.$watch("userData+contactData",function(){
                    if(scope.userData && scope.orgData){
                        plugin.updateDataOrgs(scope.orgData);
                        plugin.updateDataUsers(scope.userData);
                        plugin.updateDataContacts(scope.contactData);
                        
                        if (typeof element.attr('data-s-disabled-node-ids') !== 'undefined') {
                            plugin.disableNodeByIds(scope.disabledNodeIds);
                        }
                    }
                });
            }

            

             //attrs.$observe('ngModel',function(){
            // scope.$watch("model",function(newValue,oldValue){
            //     // console.log(ngModel.$modelValue);
            //     // console.log(ngModel.$viewValue);
            //     if(newValue)
            //         plugin.setValue(newValue);
            // });
               
            if(ngModel){
                ngModel.$parsers.push(function(value){
                    if(!value)
                        return null;
                    // value = JSON.parse(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    if(!value)
                        return null;
                    plugin.setValue(value);
                    return value;
                });
            }

            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

        }

        return {
            scope: {
                userData: '=sDataUser',
                orgData: '=sDataOrg',
                contactData:'=sDataContact',
                ngDisabled: '=ngDisabled',
                api:'=sApi',
                confirm:'&sConfirm',
                renderTreeNode:'&sRenderTreeNode',
                typeaheadMethod:'=sTypeaheadMethod',
                disabledNodeIds:'=sDisabledNodeIds'
                // model: '=sModel'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* tree javascript AngularJS */

s.ui.ngControls
    .directive('slowtree', ['$rootScope', '$compile', function($rootScope, $compile){
        var defaultArgs= {
            options: 'treeOptions',
            ref: 'treeRef',
            data: 'treeData'
        };

        function link(scope, element, attrs){
            var onNodeDbclick = function(e,node){
                scope.onNodeDbclick({e:e,node:node});
            };

            var onNodeChecked = function(e, node){
                scope.onNodeChecked({e:e,node:node});
            };

            var onNodeUnchecked = function(e, node){
                scope.onNodeUnchecked({e:e,node:node});
            };

            var onNodeCollapsed = function(e, node){
                scope.onNodeCollapsed({e:e,node:node});
            };

            var onNodeExpanded = function(e, node){
                scope.onNodeExpanded({e:e,node:node});
            };

            var onNodeEnabled = function(e, node){
                scope.onNodeEnabled({e:e,node:node});
            };

            var onNodeDisabled = function(e, node){
                scope.onNodeDisabled({e:e,node:node});
            };

            var onNodeSelected = function(e, node){
                scope.onNodeSelected({e:e,node:node});
            };

            var onNodeUnselected = function(e, node){
                scope.onNodeUnselected({e:e,node:node});
            };

            var onSearchComplete = function(e, node){
                scope.onSearchComplete({e:e,node:node});
            };

            var onSearchCleared = function(e, node){
                scope.onSearchCleared({e:e,node:node});
            };

            var parseAppendHtml = function(html){ 
                return $compile(html)(scope);
            };

            var defaultOptions = {
                data: [],
                selectedNodeIds:'',
                checkedNodeIds:'',
                onNodeDbclick: onNodeDbclick,
                onNodeChecked: onNodeChecked,
                onNodeUnchecked: onNodeUnchecked,
                onNodeCollapsed: onNodeCollapsed,
                onNodeExpanded: onNodeExpanded,
                onNodeEnabled: onNodeEnabled,
                onNodeDisabled: onNodeDisabled,
                onNodeSelected: onNodeSelected,
                onNodeUnselected: onNodeUnselected,
                onSearchComplete: onSearchComplete,
                onSearchCleared: onSearchCleared,
                parseAppendHtml: parseAppendHtml
            };

            var plugin= new s.ui.controls.Slowtree(element, defaultOptions);

            var refreshTree = function(){
                if(!scope.data)
                    return;
                plugin.updateData(scope.data);
                plugin.refresh(); 
                if(scope.selectedNodeIds)  
                    plugin.selectNodeByIds(scope.selectedNodeIds);
                if(scope.checkedNodeIds)  
                    plugin.checkNodeByIds(scope.checkedNodeIds);
            };

            scope.$watch("data+selectedNodeIds+checkedNodeIds",function(){
                refreshTree();
            });

            // scope.$watch("selectedNodeIds",function(){
            //     refreshTree();
            // });

            // scope.$watch("checkedNodeIds",function(){
            //     refreshTree();
            // });

            scope.treeApi = plugin.getApi();
        }

        return {
            scope: {
                data: '=sData',
                treeApi: '=sTreeApi',
                selectedNodeIds:'=sSelectedNodeIds',
                checkedNodeIds:'=sCheckedNodeIds',
                onNodeDbclick: '&sOnNodeDbclick',
                onNodeChecked: '&sOnNodeChecked',
                onNodeUnchecked: '&sOnNodeUnchecked',
                onNodeCollapsed: '&sOnNodeCollapsed',
                onNodeExpanded: '&sOnNodeExpanded',
                onNodeDisabled: '&sOnNodeDisabled',
                onNodeEnabled: '&sOnNodeEnabled',
                onNodeSelected: '&sOnNodeSelected',
                onNodeUnselected: '&sOnNodeUnselected',
                onSearchComplete: '&sOnSearchComplete',
                onSearchCleared: '&sOnSearchCleared'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* paginator javascript AngularJS */

s.ui.ngControls
    .directive('paginator', ['$rootScope', '$compile', function($rootScope, $compile){
        function link(scope, element, attrs){
            
            /*var onSelected = function(e,value,obj){
                  s.utilities.safeApply(scope,function(){
                   
                    scope.onSelected({value:obj});
                });
               
            };*/


            var onSelectPage = function(e, pageIndex){
                 s.utilities.safeApply(scope,function(){
                        scope.onSelectPage({page:pageIndex});
                  });
            };

            var defaultOptions = {
                totalSize: 0,       // 记录数
                pageSize: 10,       // 每页记录数
                pageIndex: 0,       // 当前页
                onPageIndexChange: onSelectPage
            };

            var plugin= new s.ui.controls.Paginator(element, defaultOptions);

            scope.$watch("pageSize",function(){
                plugin.updateOptions({pageSize: scope.pageSize});
            });

            scope.$watch("totalSize",function(){
                plugin.updateOptions({pageIndex: scope.page, totalSize: scope.totalSize});
            });

            scope.$watch("page",function(){
                plugin.updateOptions({pageIndex: scope.page, totalSize: scope.totalSize});
            });
        }

        return {
            scope: {
                page: '=sPage',
                totalSize: '=sTotalSize',
                pageSize: '=sPageSize',
                onSelectPage:'&sOnSelectPage'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* tree javascript AngularJS */

s.ui.ngControls
    .directive('tree', ['$rootScope', '$compile', function($rootScope, $compile){

        function link(scope, element, attrs){
            var onNodeDbclick = function(e,node){
                scope.onNodeDbclick({e:e,node:node});
            };
            var onNodeRightclick = function(e,node){
                scope.onNodeRightclick({e:e,node:node});
            };

            var onNodeChecked = function(e, node){
                scope.onNodeChecked({e:e,node:node});
            };

            var onNodeUnchecked = function(e, node){
                scope.onNodeUnchecked({e:e,node:node});
            };

            var onNodeCollapsed = function(e, node){
                scope.onNodeCollapsed({e:e,node:node});
            };

            var onNodeExpanded = function(e, node){
                scope.onNodeExpanded({e:e,node:node});
            };

            var onNodeEnabled = function(e, node){
                scope.onNodeEnabled({e:e,node:node});
            };

            var onNodeDisabled = function(e, node){
                scope.onNodeDisabled({e:e,node:node});
            };

            var onNodeSelected = function(e, node){
                scope.onNodeSelected({e:e,node:node});
            };

            var onNodeUnselected = function(e, node){
                scope.onNodeUnselected({e:e,node:node});
            };

            var onSearchComplete = function(e, node){
                scope.onSearchComplete({e:e,node:node});
            };

            var onSearchCleared = function(e, node){
                scope.onSearchCleared({e:e,node:node});
            };

            var parseAppendHtml = function(html){
                return $compile(html)(scope);
            };
            //拖动开始
            var onNodeDragStart;
            if(element.attr('data-s-on-node-drag-start')){
                onNodeDragStart = function(event,ui){
                    return scope.onNodeDragStart({event:event,ui:ui});
                }
            }
            //拖动
            var onNodeDrag = null;
            if(element.attr('data-s-on-node-drag')){
                onNodeDrag = function(event,ui){
                    scope.onNodeDrag({event:event,ui:ui});
                }
            }
            //拖动结束
            var onNodeDragStop = null;
            if(element.attr('data-s-on-node-drag-stop')){
                onNodeDragStop = function(event,ui){
                    scope.onNodeDragStop({event:event,ui:ui});
                }
            }
            //拖动可接收容器上
            var onNodeDropStart = null;
            if(element.attr('data-s-on-node-drop-start')){
                onNodeDropStart = function(event,ui){
                    return scope.onNodeDropStart({event:event,ui:ui});
                }
            }
            //放下
            var onNodeDrop = null;
            if(element.attr('data-s-on-node-drop')){
                onNodeDrop = function(event,ui){
                    scope.onNodeDrop({event:event,ui:ui});
                };
            }
            //追加的内容
            var render;
            if(element.attr('data-s-on-render')){
                render = function(node){
                    return scope.render({node:node});
                };
            }
            //渲染节点text
            var renderNode;
            if(element.attr('data-s-on-render-node')){
                renderNode = function(node){
                    return scope.renderNode({node:node});
                };
            }

            var defaultOptions = {
                data: [],
                selectedNodeIds:'',
                //禁用
                disabledNodeIds:'',
                checkedNodeIds:'',
                onNodeDbclick: onNodeDbclick,
                onNodeRightclick: onNodeRightclick,
                onNodeChecked: onNodeChecked,
                onNodeUnchecked: onNodeUnchecked,
                onNodeCollapsed: onNodeCollapsed,
                onNodeExpanded: onNodeExpanded,
                onNodeEnabled: onNodeEnabled,
                onNodeDisabled: onNodeDisabled,
                onNodeSelected: onNodeSelected,
                onNodeUnselected: onNodeUnselected,
                onSearchComplete: onSearchComplete,
                onSearchCleared: onSearchCleared,
                parseAppendHtml: parseAppendHtml,
                render: render,
                renderNode:renderNode,
                onNodeDragStart: onNodeDragStart,
                onNodeDrag: onNodeDrag,
                onNodeDragStop: onNodeDragStop,
                onNodeDropStart: onNodeDropStart,
                onNodeDrop: onNodeDrop,
                draggable:scope.draggable||{},
                droppable:scope.droppable||{}

                //onNodeDropStop: onNodeDropStop
            };

            var plugin= new s.ui.controls.Tree(element, defaultOptions);

            var refreshTree = function(){
                if(!scope.data)
                    return;
                // var start = new Date().getTime();
                plugin.setValue(scope.data);
                // var end = new Date().getTime();
                // console.log('target:'+(end - start)+'ms');
                if(scope.selectedNodeIds)
                    plugin.selectNodeByIds(scope.selectedNodeIds);
                if(scope.checkedNodeIds)
                    plugin.checkNodeByIds(scope.checkedNodeIds);
                if(scope.disabledNodeIds)
                    plugin.disableNodeByIds(scope.disabledNodeIds);
                if(scope.enabledNodeIds)
                    plugin.enableNodeByIds(scope.enabledNodeIds);
            };

            scope.$watch("data+selectedNodeIds+checkedNodeIds+disabledNodeIds+enabledNodeIds",function(){
                //console.log(data);
                refreshTree();
            });

            // scope.$watch("selectedNodeIds",function(){
            //     refreshTree();
            // });

            // scope.$watch("checkedNodeIds",function(){
            //     refreshTree();
            // });

            scope.treeApi = plugin.getApi();
        }

        return {
            scope: {
                data: '=sData',
                treeApi: '=sTreeApi',
                disabledNodeIds:'=sDisabledNodeIds',
                selectedNodeIds:'=sSelectedNodeIds',
                checkedNodeIds:'=sCheckedNodeIds',
                onNodeDbclick: '&sOnNodeDbclick',
                onNodeRightclick: '&sOnNodeRightclick',
                onNodeChecked: '&sOnNodeChecked',
                onNodeUnchecked: '&sOnNodeUnchecked',
                onNodeCollapsed: '&sOnNodeCollapsed',
                onNodeExpanded: '&sOnNodeExpanded',
                onNodeDisabled: '&sOnNodeDisabled',
                onNodeEnabled: '&sOnNodeEnabled',
                onNodeSelected: '&sOnNodeSelected',
                onNodeUnselected: '&sOnNodeUnselected',
                onSearchComplete: '&sOnSearchComplete',
                onSearchCleared: '&sOnSearchCleared',
                render:'&sOnRender',
                renderNode:'&sOnRenderNode',
                onNodeDragStart: '&sOnNodeDragStart',
                onNodeDrag: '&sOnNodeDrag',
                onNodeDragStop: '&sOnNodeDragStop',
                onNodeDropStart: '&sOnNodeDropStart',
                onNodeDrop: '&sOnNodeDrop',
                draggable:'=sDraggable',
                droppable:'=sDroppable'

            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* tree javascript AngularJS */

s.ui.ngControls
    .directive('treeasyc', ['$rootScope', '$compile', function($rootScope, $compile){
        var defaultArgs= {
            options: 'treeOptions',
            ref: 'treeRef',
            data: 'treeData'
        };

        function link(scope, element, attrs){
            var onNodeChecked = function(e, node){
                scope.onNodeChecked({e:e,node:node});
            };

            var onNodeUnchecked = function(e, node){
                scope.onNodeUnchecked({e:e,node:node});
            };

            var onNodeCollapsed = function(e, node){
                scope.onNodeCollapsed({e:e,node:node});
            };

            var onNodeExpanded = function(e, node){
                scope.onNodeExpanded({e:e,node:node});
            };

            var onNodeEnabled = function(e, node){
                scope.onNodeEnabled({e:e,node:node});
            };

            var onNodeDisabled = function(e, node){
                scope.onNodeDisabled({e:e,node:node});
            };

            var onNodeSelected = function(e, node){
                scope.onNodeSelected({e:e,node:node});
            };

            var onNodeUnselected = function(e, node){
                scope.onNodeUnselected({e:e,node:node});
            };

            var onSearchComplete = function(e, node){
                scope.onSearchComplete({e:e,node:node});
            };

            var onSearchCleared = function(e, node){
                scope.onSearchCleared({e:e,node:node});
            };

            var parseAppendHtml = function(html){ 
                return $compile(html)(scope);
            };

            var getAsycData = function(node){
                return scope.getAsycData(node);
            };

            var defaultOptions = {
                data: [],
                selectedNodeIds:'',
                checkedNodeIds:'',
                onNodeChecked: onNodeChecked,
                onNodeUnchecked: onNodeUnchecked,
                onNodeCollapsed: onNodeCollapsed,
                onNodeExpanded: onNodeExpanded,
                onNodeEnabled: onNodeEnabled,
                onNodeDisabled: onNodeDisabled,
                onNodeSelected: onNodeSelected,
                onNodeUnselected: onNodeUnselected,
                onSearchComplete: onSearchComplete,
                onSearchCleared: onSearchCleared,
                parseAppendHtml: parseAppendHtml,
                getAsycData: getAsycData
            };

            var plugin= new s.ui.controls.Treeasyc(element, defaultOptions);

            var refreshTree = function(){
                if(!scope.data)
                    return;
                plugin.updateData(scope.data);
                plugin.refresh(); 
                if(scope.selectedNodeIds)  
                    plugin.selectNodeByIds(scope.selectedNodeIds);
                if(scope.checkedNodeIds)  
                    plugin.checkNodeByIds(scope.checkedNodeIds);
            };

            scope.$watch("data+selectedNodeIds+checkedNodeIds",function(){
                refreshTree();
            });

            // scope.$watch("selectedNodeIds",function(){
            //     refreshTree();
            // });

            // scope.$watch("checkedNodeIds",function(){
            //     refreshTree();
            // });

            scope.treeApi = plugin.getApi();
        }

        return {
            scope: {
                data: '=sData',
                treeApi: '=sTreeApi',
                selectedNodeIds:'=sSelectedNodeIds',
                checkedNodeIds:'=sCheckedNodeIds',
                onNodeChecked: '&sOnNodeChecked',
                onNodeUnchecked: '&sOnNodeUnchecked',
                onNodeCollapsed: '&sOnNodeCollapsed',
                onNodeExpanded: '&sOnNodeExpanded',
                onNodeDisabled: '&sOnNodeDisabled',
                onNodeEnabled: '&sOnNodeEnabled',
                onNodeSelected: '&sOnNodeSelected',
                onNodeUnselected: '&sOnNodeUnselected',
                onSearchComplete: '&sOnSearchComplete',
                onSearchCleared: '&sOnSearchCleared',
                getAsycData: '&sOnGetAsycData'
            },
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/* orgselect javascript AngularJS */

//angular.module('triangle.controls', [])
s.ui.ngControls
    .directive('treeselect', ['$rootScope', '$compile', function($rootScope, $compile){
        
        function link(scope, element, attrs, ngModel){

            var updateModel = function(data){
                 s.utilities.safeApply(scope,function(){
                    // ngModel.$setViewValue(data);
                     // data = JSON.parse(data);
                     scope.model = data;
                     if(element.attr('data-s-confirm')){
                            scope.confirm({data:data});
                     }
                     if(ngModel){
                        ngModel.$setViewValue(data);
                        ngModel.$render();
                     }
                });
            };

    

            var defaultOptions = {
                onConfirm: updateModel
            };

            var plugin= new s.ui.controls.Treeselect(element, defaultOptions);

            scope.$watch("orgData",function(){
                if( scope.orgData){
                    plugin.updateDataOrgs(scope.orgData);
                }
            });

             //attrs.$observe('ngModel',function(){
            scope.$watch("model",function(newValue,oldValue){
                // console.log(ngModel.$modelValue);
                // console.log(ngModel.$viewValue);
                if(newValue)
                    plugin.setValue(newValue);
            });
               
            if(ngModel){
                ngModel.$parsers.push(function(value){
                    if(!value)
                        return null;
                    // value = JSON.parse(value);
                    return value;
                });
                ngModel.$formatters.push(function(value){
                    if(!value)
                        return null;
                    plugin.setValue(value);
                    return value;
                });
            }

            if(typeof element.attr('ng-disabled') !== 'undefined'){
                scope.$watch("ngDisabled",function(newValue,oldValue){
                    if(newValue)
                        plugin.disable();
                    else
                        plugin.enable();
                });
            }

        }

        return {
            scope: {
                orgData: '=sDataOrg',
                ngDisabled: '=ngDisabled',
                model: '=sModel',
                confirm:'&sConfirm'
            },
            require: '?ngModel',
            restric: 'A',
            transclude: false,
            link: link
        };

    }]);
/*弹窗、消息提示*/ 
'use strict';
angular.module("s.ui.ngExtend.modal", ["ui.bootstrap.tpls", "ui.bootstrap.modal"]);
angular.module('ui.bootstrap.tpls', ['uiTemplate/modal/backdrop.html', 'uiTemplate/modal/window.html', 'uiTemplate/modal/message.html', 'uiTemplate/modal/confirmation.html', 'uiTemplate/modal/dialog.html'])
angular.module('ui.bootstrap.stackedMap', [])
/**
 * A helper, internal data structure that acts as a map but also allows getting / removing
 * elements in the LIFO order
 */
  .factory('$$stackedMap', function() {
    return {
      createNew: function() {
        var stack = [];

        return {
          add: function(key, value) {
            stack.push({
              key: key,
              value: value
            });
          },
          get: function(key) {
            for (var i = 0; i < stack.length; i++) {
              if (key == stack[i].key) {
                return stack[i];
              }
            }
          },
          keys: function() {
            var keys = [];
            for (var i = 0; i < stack.length; i++) {
              keys.push(stack[i].key);
            }
            return keys;
          },
          top: function() {
            return stack[stack.length - 1];
          },
          remove: function(key) {
            var idx = -1;
            for (var i = 0; i < stack.length; i++) {
              if (key == stack[i].key) {
                idx = i;
                break;
              }
            }
            return stack.splice(idx, 1)[0];
          },
          removeTop: function() {
            return stack.splice(stack.length - 1, 1)[0];
          },
          length: function() {
            return stack.length;
          }
        };
      }
    };
  });
angular.module('ui.bootstrap.modal', ['ui.bootstrap.stackedMap'])
  /**
 * A helper, internal data structure that stores all references attached to key
 */
  .factory('$$multiMap', function() {
    return {
      createNew: function() {
        var map = {};

        return {
          entries: function() {
            return Object.keys(map).map(function(key) {
              return {
                key: key,
                value: map[key]
              };
            });
          },
          get: function(key) {
            return map[key];
          },
          hasKey: function(key) {
            return !!map[key];
          },
          keys: function() {
            return Object.keys(map);
          },
          put: function(key, value) {
            if (!map[key]) {
              map[key] = [];
            }

            map[key].push(value);
          },
          remove: function(key, value) {
            var values = map[key];

            if (!values) {
              return;
            }

            var idx = values.indexOf(value);

            if (idx !== -1) {
              values.splice(idx, 1);
            }

            if (!values.length) {
              delete map[key];
            }
          }
        };
      }
    };
  })

  /**
 * A helper directive for the $modal service. It creates a backdrop element.
 */
  .directive('uibModalBackdrop', [
           '$animate', '$injector', '$uibModalStack',
  function($animate ,  $injector,   $modalStack) {
    var $animateCss = null;

    if ($injector.has('$animateCss')) {
      $animateCss = $injector.get('$animateCss');
    }

    return {
      replace: true,
      templateUrl: 'uiTemplate/modal/backdrop.html',
      compile: function(tElement, tAttrs) {
        tElement.addClass(tAttrs.backdropClass);
        return linkFn;
      }
    };

    function linkFn(scope, element, attrs) {
      // Temporary fix for prefixing
      element.addClass('modal-backdrop');

      if (attrs.modalInClass) {
        element.hide();
        // if ($animateCss) {
        //   $animateCss(element, {
        //     addClass: attrs.modalInClass
        //   }).start();
        // } else {
          // $animate.addClass(element, attrs.modalInClass);
        // }
        element.addClass(attrs.modalInClass)
        element.show();
        scope.$on($modalStack.NOW_CLOSING_EVENT, function(e, setIsAsync) {
          var done = setIsAsync();
          element.hide()
          if ($animateCss) {
            $animateCss(element, {
              removeClass: attrs.modalInClass
            }).start().then(done);
          } else {
            $animate.removeClass(element, attrs.modalInClass).then(done);
          }
            // element.hide().removeClass(attrs.modalInClass)
            // done();
        });
      }
    }
  }])

  .directive('uibModalWindow', [
           '$uibModalStack', '$q', '$animate', '$injector',
  function($modalStack ,  $q ,  $animate,   $injector) {
    var $animateCss = null;

    if ($injector.has('$animateCss')) {
      $animateCss = $injector.get('$animateCss');
    }

    return {
      scope: {
        index: '@'
      },
      replace: true,
      transclude: true,
      templateUrl: function(tElement, tAttrs) {
        return tAttrs.templateUrl || 'uiTemplate/modal/window.html';
      },
      link: function(scope, element, attrs) {
        element.addClass(attrs.windowClass || '');
        element.addClass(attrs.windowTopClass || '');
        /*bugfix：jquery 加 样式，ng-class渲染太慢*/ 
        if(attrs.size){
          element.find('.modal-dialog').addClass('modal-'+attrs.size);
        }
        scope.size = attrs.size;

        scope.close = function(evt) {
          var modal = $modalStack.getTop();
          if (modal && modal.value.backdrop && modal.value.backdrop !== 'static' && (evt.target === evt.currentTarget)) {
            evt.preventDefault();
            evt.stopPropagation();
            $modalStack.dismiss(modal.key, 'backdrop click');
          }
        };

        // moved from template to fix issue #2280
        element.on('click', scope.close);

        // This property is only added to the scope for the purpose of detecting when this directive is rendered.
        // We can detect that by using this property in the template associated with this directive and then use
        // {@link Attribute#$observe} on it. For more details please see {@link TableColumnResize}.
        scope.$isRendered = true;

        // Deferred object that will be resolved when this modal is render.
        var modalRenderDeferObj = $q.defer();
        // Observe function will be called on next digest cycle after compilation, ensuring that the DOM is ready.
        // In order to use this way of finding whether DOM is ready, we need to observe a scope property used in modal's template.
        attrs.$observe('modalRender', function(value) {
          if (value == 'true') {
            modalRenderDeferObj.resolve();
          }
        });

        modalRenderDeferObj.promise.then(function() {
          var animationPromise = null;

          if (attrs.modalInClass) {
            if ($animateCss) {
              animationPromise = $animateCss(element, {
                addClass: attrs.modalInClass
              }).start();
            } else {
              animationPromise = $animate.addClass(element, attrs.modalInClass);
            }

            scope.$on($modalStack.NOW_CLOSING_EVENT, function(e, setIsAsync) {
              var done = setIsAsync();
              element.hide();
              if ($animateCss) {
                $animateCss(element, {
                  removeClass: attrs.modalInClass
                }).start().then(done);
              } else {
                $animate.removeClass(element, attrs.modalInClass).then(done);
              }
            });
          }


          $q.when(animationPromise).then(function() {
            var inputWithAutofocus = element[0].querySelector('[autofocus]');
            /**
             * Auto-focusing of a freshly-opened modal element causes any child elements
             * with the autofocus attribute to lose focus. This is an issue on touch
             * based devices which will show and then hide the onscreen keyboard.
             * Attempts to refocus the autofocus element via JavaScript will not reopen
             * the onscreen keyboard. Fixed by updated the focusing logic to only autofocus
             * the modal element if the modal does not contain an autofocus element.
             */
            if (inputWithAutofocus) {
              inputWithAutofocus.focus();
            } else {
              element[0].focus();
            }
          });

          // Notify {@link $modalStack} that modal is rendered.
          var modal = $modalStack.getTop();
          if (modal) {
            $modalStack.modalRendered(modal.key);
          }
        });
      }
    };
  }])

  .directive('uibModalAnimationClass', function() {
    return {
      compile: function(tElement, tAttrs) {
        if (tAttrs.modalAnimation) {
          tElement.addClass(tAttrs.uibModalAnimationClass);
        }
      }
    };
  })

  .directive('uibModalTransclude', function() {
    return {
      link: function($scope, $element, $attrs, controller, $transclude) {
        $transclude($scope.$parent, function(clone) {
          $element.empty();
          $element.append(clone);
        });
      }
    };
  })

  .factory('$uibModalStack', [
             '$animate', '$timeout', '$document', '$compile', '$rootScope',
             '$q',
             '$injector',
             '$$multiMap',
             '$$stackedMap',
    function($animate ,  $timeout ,  $document ,  $compile ,  $rootScope ,
              $q,
              $injector,
              $$multiMap,
              $$stackedMap) {
      var $animateCss = null;

      if ($injector.has('$animateCss')) {
        $animateCss = $injector.get('$animateCss');
      }

      var OPENED_MODAL_CLASS = 'modal-open';

      var backdropDomEl, backdropScope;
      var openedWindows = $$stackedMap.createNew();
      var openedClasses = $$multiMap.createNew();
      var $modalStack = {
        NOW_CLOSING_EVENT: 'modal.stack.now-closing'
      };

      //Modal focus behavior
      var focusableElementList;
      var focusIndex = 0;
      var tababbleSelector = 'a[href], area[href], input:not([disabled]), ' +
        'button:not([disabled]),select:not([disabled]), textarea:not([disabled]), ' +
        'iframe, object, embed, *[tabindex], *[contenteditable=true]';

      function backdropIndex() {
        var topBackdropIndex = -1;
        var opened = openedWindows.keys();
        for (var i = 0; i < opened.length; i++) {
          if (openedWindows.get(opened[i]).value.backdrop) {
            topBackdropIndex = i;
          }
        }
        return topBackdropIndex;
      }

      $rootScope.$watch(backdropIndex, function(newBackdropIndex) {
        if (backdropScope) {
          backdropScope.index = newBackdropIndex;
        }
      });

      function removeModalWindow(modalInstance, elementToReceiveFocus) {
        var body = $document.find('body').eq(0);
        var modalWindow = openedWindows.get(modalInstance).value;

        //clean up the stack
        openedWindows.remove(modalInstance);

        removeAfterAnimate(modalWindow.modalDomEl, modalWindow.modalScope, function() {
          var modalBodyClass = modalWindow.openedClass || OPENED_MODAL_CLASS;
          openedClasses.remove(modalBodyClass, modalInstance);
          body.toggleClass(modalBodyClass, openedClasses.hasKey(modalBodyClass));
          toggleTopWindowClass(true);
        });
        checkRemoveBackdrop();

        //move focus to specified element if available, or else to body
        // bugfix 防止ie9下页面跳动 lwu.oth 2016-5-16
        // if (elementToReceiveFocus && elementToReceiveFocus.focus) {
        //   elementToReceiveFocus.focus();
        // } else {
        //   body.focus();
        // }
      }

      // Add or remove "windowTopClass" from the top window in the stack
      function toggleTopWindowClass(toggleSwitch) {
        var modalWindow;

        if (openedWindows.length() > 0) {
          modalWindow = openedWindows.top().value;
          modalWindow.modalDomEl.toggleClass(modalWindow.windowTopClass || '', toggleSwitch);
        }
      }

      function checkRemoveBackdrop() {
        //remove backdrop if no longer needed
        if (backdropDomEl && backdropIndex() == -1) {
          var backdropScopeRef = backdropScope;
          removeAfterAnimate(backdropDomEl, backdropScope, function() {
            backdropScopeRef = null;
          });
          backdropDomEl = undefined;
          backdropScope = undefined;
        }
      }

      function removeAfterAnimate(domEl, scope, done) {
        var asyncDeferred;
        var asyncPromise = null;
        var setIsAsync = function() {
          if (!asyncDeferred) {
            asyncDeferred = $q.defer();
            asyncPromise = asyncDeferred.promise;
          }

          return function asyncDone() {
            asyncDeferred.resolve();
          };
        };
        scope.$broadcast($modalStack.NOW_CLOSING_EVENT, setIsAsync);

        // Note that it's intentional that asyncPromise might be null.
        // That's when setIsAsync has not been called during the
        // NOW_CLOSING_EVENT broadcast.
        return $q.when(asyncPromise).then(afterAnimating);

        function afterAnimating() {
          if (afterAnimating.done) {
            return;
          }
          afterAnimating.done = true;

          if ($animateCss) {
            $animateCss(domEl, {
              event: 'leave'
            }).start().then(function() {
              domEl.remove();
            });
          } else {
            $animate.leave(domEl);
          }
          scope.$destroy();
          if (done) {
            done();
          }
        }
      }

      $document.bind('keydown', function(evt) {
        if (evt.isDefaultPrevented()) {
          return evt;
        }

        var modal = openedWindows.top();
        if (modal && modal.value.keyboard) {
          switch (evt.which) {
            case 27: {
              evt.preventDefault();
              $rootScope.$apply(function() {
                $modalStack.dismiss(modal.key, 'escape key press');
              });
              break;
            }
            case 9: {
              $modalStack.loadFocusElementList(modal);
              var focusChanged = false;
              if (evt.shiftKey) {
                if ($modalStack.isFocusInFirstItem(evt)) {
                  focusChanged = $modalStack.focusLastFocusableElement();
                }
              } else {
                if ($modalStack.isFocusInLastItem(evt)) {
                  focusChanged = $modalStack.focusFirstFocusableElement();
                }
              }

              if (focusChanged) {
                evt.preventDefault();
                evt.stopPropagation();
              }
              break;
            }
          }
        }
      });

      $modalStack.open = function(modalInstance, modal) {
        var modalOpener = $document[0].activeElement,
          modalBodyClass = modal.openedClass || OPENED_MODAL_CLASS;

        toggleTopWindowClass(false);

        openedWindows.add(modalInstance, {
          deferred: modal.deferred,
          renderDeferred: modal.renderDeferred,
          modalScope: modal.scope,
          backdrop: modal.backdrop,
          keyboard: modal.keyboard,
          openedClass: modal.openedClass,
          windowTopClass: modal.windowTopClass
        });

        openedClasses.put(modalBodyClass, modalInstance);

        var body = $document.find('body').eq(0),
            currBackdropIndex = backdropIndex();

        if (currBackdropIndex >= 0 && !backdropDomEl) {
          backdropScope = $rootScope.$new(true);
          backdropScope.index = currBackdropIndex;
          var angularBackgroundDomEl = angular.element('<div uib-modal-backdrop="modal-backdrop"></div>');
          angularBackgroundDomEl.attr('backdrop-class', modal.backdropClass);
          if (modal.animation) {
            angularBackgroundDomEl.attr('modal-animation', 'true');
          }
          backdropDomEl = $compile(angularBackgroundDomEl)(backdropScope);
          body.append(backdropDomEl);
        }

        var angularDomEl = angular.element('<div uib-modal-window="modal-window"></div>');
        angularDomEl.attr({
          'template-url': modal.windowTemplateUrl,
          'window-class': modal.windowClass,
          'window-top-class': modal.windowTopClass,
          'size': modal.size,
          'index': openedWindows.length() - 1,
          'animate': 'animate'
        }).html(modal.content);
        if (modal.animation) {
          angularDomEl.attr('modal-animation', 'true');
        }

        var modalDomEl = $compile(angularDomEl)(modal.scope);
        openedWindows.top().value.modalDomEl = modalDomEl;
        openedWindows.top().value.modalOpener = modalOpener;
        body.append(modalDomEl);
        body.addClass(modalBodyClass);

        $modalStack.clearFocusListCache();

        /*lwu.oth 2016-7-8 修改弹窗为自适应居中 */ 
        $timeout(function(){
          var clientHeight = document.documentElement.clientHeight,
              clientWidth = document.documentElement.clientWidth,
              dialogElm = modalDomEl.find('.modal-dialog'),
              elmHeight = dialogElm.height(),
              elmWidth = dialogElm.width();
          if(clientHeight>elmHeight){
            dialogElm.css({"position":"absolute",'left':(clientWidth/2) - (elmWidth/2),'top':(clientHeight/2) - (elmHeight/2),'margin':0});
          }
          dialogElm.css('visibility', 'visible');
        })
      };

      function broadcastClosing(modalWindow, resultOrReason, closing) {
        return !modalWindow.value.modalScope.$broadcast('modal.closing', resultOrReason, closing).defaultPrevented;
      }

      $modalStack.close = function(modalInstance, result) {
        var modalWindow = openedWindows.get(modalInstance);
        if (modalWindow && broadcastClosing(modalWindow, result, true)) {
          modalWindow.value.modalScope.$$uibDestructionScheduled = true;
          modalWindow.value.deferred.resolve(result);
          removeModalWindow(modalInstance, modalWindow.value.modalOpener);
          return true;
        }
        return !modalWindow;
      };

      $modalStack.dismiss = function(modalInstance, reason) {
        var modalWindow = openedWindows.get(modalInstance);
        if (modalWindow && broadcastClosing(modalWindow, reason, false)) {
          modalWindow.value.modalScope.$$uibDestructionScheduled = true;
          modalWindow.value.deferred.reject(reason);
          removeModalWindow(modalInstance, modalWindow.value.modalOpener);
          return true;
        }
        return !modalWindow;
      };

      $modalStack.dismissAll = function(reason) {
        var topModal = this.getTop();
        while (topModal && this.dismiss(topModal.key, reason)) {
          topModal = this.getTop();
        }
      };

      $modalStack.getTop = function() {
        return openedWindows.top();
      };

      $modalStack.modalRendered = function(modalInstance) {
        var modalWindow = openedWindows.get(modalInstance);
        if (modalWindow) {
          modalWindow.value.renderDeferred.resolve();
        }
      };

      $modalStack.focusFirstFocusableElement = function() {
        if (focusableElementList.length > 0) {
          focusableElementList[0].focus();
          return true;
        }
        return false;
      };
      $modalStack.focusLastFocusableElement = function() {
        if (focusableElementList.length > 0) {
          focusableElementList[focusableElementList.length - 1].focus();
          return true;
        }
        return false;
      };

      $modalStack.isFocusInFirstItem = function(evt) {
        if (focusableElementList.length > 0) {
          return (evt.target || evt.srcElement) == focusableElementList[0];
        }
        return false;
      };

      $modalStack.isFocusInLastItem = function(evt) {
        if (focusableElementList.length > 0) {
          return (evt.target || evt.srcElement) == focusableElementList[focusableElementList.length - 1];
        }
        return false;
      };

      $modalStack.clearFocusListCache = function() {
        focusableElementList = [];
        focusIndex = 0;
      };

      $modalStack.loadFocusElementList = function(modalWindow) {
        if (focusableElementList === undefined || !focusableElementList.length) {
          if (modalWindow) {
            var modalDomE1 = modalWindow.value.modalDomEl;
            if (modalDomE1 && modalDomE1.length) {
              focusableElementList = modalDomE1[0].querySelectorAll(tababbleSelector);
            }
          }
        }
      };

      return $modalStack;
    }])

  .provider('$uibModal', function() {
    var $modalProvider = {
      options: {
        animation: true,
        backdrop: 'static', //can also be false or 'static'
        keyboard: true
      },
      $get: ['$injector', '$rootScope', '$q', '$templateRequest', '$controller', '$uibModalStack', '$modalSuppressWarning', '$log',
        function ($injector, $rootScope, $q, $templateRequest, $controller, $modalStack, $modalSuppressWarning, $log) {
          var $modal = {};

          function getTemplatePromise(options) {
            return options.template ? $q.when(options.template) :
              $templateRequest(angular.isFunction(options.templateUrl) ? (options.templateUrl)() : options.templateUrl);
          }

          function getResolvePromises(resolves) {
            var promisesArr = [];
            angular.forEach(resolves, function(value) {
              if (angular.isFunction(value) || angular.isArray(value)) {
                promisesArr.push($q.when($injector.invoke(value)));
              } else if (angular.isString(value)) {
                promisesArr.push($q.when($injector.get(value)));
              } else {
                promisesArr.push($q.when(value));
              }
            });
            return promisesArr;
          }

          var promiseChain = null;
          $modal.getPromiseChain = function() {
            return promiseChain;
          };

          $modal.open = function(modalOptions) {
            var modalResultDeferred = $q.defer();
            var modalOpenedDeferred = $q.defer();
            var modalRenderDeferred = $q.defer();

            //prepare an instance of a modal to be injected into controllers and returned to a caller
            var modalInstance = {
              result: modalResultDeferred.promise,
              opened: modalOpenedDeferred.promise,
              rendered: modalRenderDeferred.promise,
              close: function (result) {
                        result&&result.close&&result.close.apply(null,[]);
                return $modalStack.close(modalInstance, result);
              },
              dismiss: function (reason) {
                return $modalStack.dismiss(modalInstance, reason);
              }
            };

            //merge and clean up options
            modalOptions = angular.extend({}, $modalProvider.options, modalOptions);
            modalOptions.resolve = modalOptions.resolve || {};

            //verify options
            if (!modalOptions.template && !modalOptions.templateUrl) {
              throw new Error('One of template or templateUrl options is required.');
            }

            var templateAndResolvePromise =
              $q.all([getTemplatePromise(modalOptions)].concat(getResolvePromises(modalOptions.resolve)));

            function resolveWithTemplate() {
              return templateAndResolvePromise;
            }

            // Wait for the resolution of the existing promise chain.
            // Then switch to our own combined promise dependency (regardless of how the previous modal fared).
            // Then add to $modalStack and resolve opened.
            // Finally clean up the chain variable if no subsequent modal has overwritten it.
            var samePromise;
            samePromise = promiseChain = $q.all([promiseChain])
              .then(resolveWithTemplate, resolveWithTemplate)
              .then(function resolveSuccess(tplAndVars) {

                var modalScope = (modalOptions.scope || $rootScope).$new();
                modalScope.$close = modalInstance.close;
                modalScope.$dismiss = modalInstance.dismiss;

                modalScope.$on('$destroy', function() {
                  if (!modalScope.$$uibDestructionScheduled) {
                    modalScope.$dismiss('$uibUnscheduledDestruction');
                  }
                });

                var ctrlInstance, ctrlLocals = {};
                var resolveIter = 1;

                //controllers
                if (modalOptions.controller) {
                  ctrlLocals.$scope = modalScope;
                  ctrlLocals.$uibModalInstance = modalInstance;
                  Object.defineProperty(ctrlLocals, '$modalInstance', {
                    get: function() {
                      if (!$modalSuppressWarning) {
                        $log.warn('$modalInstance is now deprecated. Use $uibModalInstance instead.');
                      }

                      return modalInstance;
                    }
                  });
                  angular.forEach(modalOptions.resolve, function(value, key) {
                    ctrlLocals[key] = tplAndVars[resolveIter++];
                  });

                  ctrlInstance = $controller(modalOptions.controller, ctrlLocals);
                  if (modalOptions.controllerAs) {
                    if (modalOptions.bindToController) {
                      angular.extend(ctrlInstance, modalScope);
                    }

                    modalScope[modalOptions.controllerAs] = ctrlInstance;
                  }
                }

                $modalStack.open(modalInstance, {
                  scope: modalScope,
                  deferred: modalResultDeferred,
                  renderDeferred: modalRenderDeferred,
                  content: tplAndVars[0],
                  animation: false,
                  backdrop: modalOptions.backdrop,
                  keyboard: modalOptions.keyboard,
                  backdropClass: modalOptions.backdropClass,
                  windowTopClass: modalOptions.windowTopClass,
                  windowClass: modalOptions.windowClass,
                  windowTemplateUrl: modalOptions.windowTemplateUrl,
                  size: modalOptions.size,
                  openedClass: modalOptions.openedClass
                });
                modalOpenedDeferred.resolve(true);

            }, function resolveError(reason) {
              modalOpenedDeferred.reject(reason);
              modalResultDeferred.reject(reason);
            })
            ["finally"](function() {
              if (promiseChain === samePromise) {
                promiseChain = null;
              }
            });

            return modalInstance;
          };

          $modal.message = function(config){
            //  var tempUrl = window.$getSzseUiTemplateUrl$(config||{},config||{},'modal','message');
              var getMessagePromise = function () {
                  return config.message ? $q.when(config.message) :
                      $http.get(config.messageUrl, {cache: $templateCache}).then(function (result) {
                          return result.data;
                      });
              };
              getMessagePromise().then(function(message){
                  var modalInstance = $modal.open({
                    templateUrl: function(tElement, tAttrs) {
                      return (tAttrs && tAttrs.templateUrl) || 'uiTemplate/modal/message.html';
                    },
                    size:  !config.size ? 'message' : ('message modal-'+config.size),
                    backdrop: 'static',
                    controller: ['$scope', '$modalInstance',function ($scope, $modalInstance) {
                        var autocloseTimeout = null ,
                            close = function(){
                                if( autocloseTimeout != null){
                                    clearTimeout(autocloseTimeout);
                                    autocloseTimeout = null;
                                }
                                $modalInstance.close();
                            };
                        $scope.title= config.title || '提示';
                        $scope.message = message;
                        $scope.type = config.type||"info";//error縲《uccess縲（nfo縲『arn
                        $scope.close = function () {
                            //$modalInstance.close();
                            if( autocloseTimeout != null){
                                clearTimeout(autocloseTimeout);
                                autocloseTimeout = null;
                            }
                            $modalInstance.close(config);

                        };
                        if(config.autoclose === true){
                            var autocloseTime=config.autocloseTime||3*1000;
                            autocloseTimeout = setTimeout(close,autocloseTime);
                        }
                    }]
                });
              });
          };

          $modal.confirmation = function (config) {
              //var tempUrl = window.$getSzseUiTemplateUrl$(config||{}, config||{}, 'modal', 'confirmation');
              var getMessagePromise = function () {
                  return config.message ? $q.when(config.message) :
                      $http.get(config.messageUrl, {cache: $templateCache}).then(function (result) {
                          return result.data;
                      });
              };
              getMessagePromise().then(function (message) {
                  var modalInstance = $modal.open({
                      templateUrl: function(tElement, tAttrs) {
                        return (tAttrs && tAttrs.templateUrl) || 'uiTemplate/modal/confirmation.html';
                      },
                      size: !config.size ? 'message' : ('message modal-'+config.size),
                      backdrop: 'static',
                      controller: ['$scope', '$modalInstance', function ($scope, $modalInstance) {
                          $scope.title = config.title || '确认';
                          $scope.closeButton = config.closeButton == null ? true : config.closeButton ;
                          $scope.message = message;
                          $scope.cancelName = config.cancelName;
                          $scope.type = config.type || 'confirm';
                          $scope.okName = config.okName;
                          $scope.close = function () {
                              $modalInstance.close();
                          };
                          $scope.cancel = function () {
                              $modalInstance.dismiss();
                          };
                      }]
                  });
                  modalInstance.result.then(function () {
                      if(config.ok){
                          config.ok();
                      }
                  }, function () {
                      if(config.cancel){
                          config.cancel();
                      }
                  });
              });
          };

          $modal.dialog = function (config) {
              //var tempUrl = window.$getSzseUiTemplateUrl$(config||{}, config||{}, 'modal', 'confirmation');
              var getMessagePromise = function () {
                  return config.message ? $q.when(config.message) :
                      $http.get(config.messageUrl, {cache: $templateCache}).then(function (result) {
                          return result.data;
                      });
              };
              var modalInstance;
              //getMessagePromise().then(function (message) {
                  modalInstance = $modal.open({
                      templateUrl: function(tElement, tAttrs) {
                        return (tAttrs && tAttrs.templateUrl) || 'uiTemplate/modal/dialog.html';
                      },
                      size: 'message',
                      backdrop: 'static',
                      controller: ['$scope', '$modalInstance', function ($scope, $modalInstance) {
                          $scope.showHeader = config.showHeader == null ? true : config.showHeader;
                          $scope.modalTitle = config.modalTitle || '提示';
                          $scope.showCloseButton = config.closeButton == null ? true : config.closeButton ;
                          $scope.title = config.title || '';
                          $scope.type = config.type || 'info';
                          $scope.message = config.message || '';
                          $scope.buttons = config.buttons;
                          $scope.close = function () {
                              $modalInstance.close();
                          };
                          $scope.cancel = function () {
                              $modalInstance.dismiss();
                          };
                      }]
                  });
                  modalInstance.result.then(function () {
                      if(config.ok){
                          config.ok();
                      }
                  }, function () {
                      if(config.cancel){
                          config.cancel();
                      }
                  });
                  
             // });
              return modalInstance;
          };

          return $modal;
        }
      ]
    };

    return $modalProvider;
  });

/* deprecated modal below */

angular.module('ui.bootstrap.modal')

  .value('$modalSuppressWarning', false)

  /**
   * A helper directive for the $modal service. It creates a backdrop element.
   */
  .directive('modalBackdrop', [
    '$animate', '$injector', '$modalStack', '$log', '$modalSuppressWarning',
    function($animate ,  $injector,   $modalStack, $log, $modalSuppressWarning) {
      var $animateCss = null;

      if ($injector.has('$animateCss')) {
        $animateCss = $injector.get('$animateCss');
      }

      return {
        replace: true,
        templateUrl: 'uiTemplate/modal/backdrop.html',
        compile: function(tElement, tAttrs) {
          tElement.addClass(tAttrs.backdropClass);
          return linkFn;
        }
      };

      function linkFn(scope, element, attrs) {
        if (!$modalSuppressWarning) {
          $log.warn('modal-backdrop is now deprecated. Use uib-modal-backdrop instead.');
        }
        element.addClass('modal-backdrop');

        if (attrs.modalInClass) {
          element.hide();
          if ($animateCss) {
            $animateCss(element, {
              addClass: attrs.modalInClass
            }).start();
          } else {
            $animate.addClass(element, attrs.modalInClass);
          }
          element.show();

          scope.$on($modalStack.NOW_CLOSING_EVENT, function(e, setIsAsync) {
            var done = setIsAsync();
            if ($animateCss) {
              $animateCss(element, {
                removeClass: attrs.modalInClass
              }).start().then(done);
            } else {
              $animate.removeClass(element, attrs.modalInClass).then(done);
            }
          });
        }
      }
    }])

  .directive('modalWindow', [
    '$modalStack', '$q', '$animate', '$injector', '$log', '$modalSuppressWarning',
    function($modalStack ,  $q ,  $animate,   $injector, $log, $modalSuppressWarning) {
      var $animateCss = null;

      if ($injector.has('$animateCss')) {
        $animateCss = $injector.get('$animateCss');
      }

      return {
        scope: {
          index: '@'
        },
        replace: true,
        transclude: true,
        templateUrl: function(tElement, tAttrs) {
          return tAttrs.templateUrl || 'uiTemplate/modal/window.html';
        },
        link: function(scope, element, attrs) {
          if (!$modalSuppressWarning) {
            $log.warn('modal-window is now deprecated. Use uib-modal-window instead.');
          }
          scope.size = attrs.size;
          element.addClass(attrs.windowClass || '');
          element.addClass(attrs.windowTopClass || '');
          if(attrs.size){
            element.find('.modal-dialog').addClass('modal-'+attrs.size);
          }

          scope.close = function(evt) {
            var modal = $modalStack.getTop();
            if (modal && modal.value.backdrop && modal.value.backdrop !== 'static' && (evt.target === evt.currentTarget)) {
              evt.preventDefault();
              evt.stopPropagation();
              $modalStack.dismiss(modal.key, 'backdrop click');
            }
          };

          // moved from template to fix issue #2280
          element.on('click', scope.close);

          // This property is only added to the scope for the purpose of detecting when this directive is rendered.
          // We can detect that by using this property in the template associated with this directive and then use
          // {@link Attribute#$observe} on it. For more details please see {@link TableColumnResize}.
          scope.$isRendered = true;

          // Deferred object that will be resolved when this modal is render.
          var modalRenderDeferObj = $q.defer();
          // Observe function will be called on next digest cycle after compilation, ensuring that the DOM is ready.
          // In order to use this way of finding whether DOM is ready, we need to observe a scope property used in modal's template.
          attrs.$observe('modalRender', function(value) {
            if (value == 'true') {
              modalRenderDeferObj.resolve();
            }
          });

          modalRenderDeferObj.promise.then(function() {
            var animationPromise = null;

            if (attrs.modalInClass) {
              if ($animateCss) {
                animationPromise = $animateCss(element, {
                  addClass: attrs.modalInClass
                }).start();
              } else {
                animationPromise = $animate.addClass(element, attrs.modalInClass);
              }

              scope.$on($modalStack.NOW_CLOSING_EVENT, function(e, setIsAsync) {
                var done = setIsAsync();
                if ($animateCss) {
                  $animateCss(element, {
                    removeClass: attrs.modalInClass
                  }).start().then(done);
                } else {
                  $animate.removeClass(element, attrs.modalInClass).then(done);
                }
              });
            }


            $q.when(animationPromise).then(function() {
              var inputWithAutofocus = element[0].querySelector('[autofocus]');
              /**
               * Auto-focusing of a freshly-opened modal element causes any child elements
               * with the autofocus attribute to lose focus. This is an issue on touch
               * based devices which will show and then hide the onscreen keyboard.
               * Attempts to refocus the autofocus element via JavaScript will not reopen
               * the onscreen keyboard. Fixed by updated the focusing logic to only autofocus
               * the modal element if the modal does not contain an autofocus element.
               */
              if (inputWithAutofocus) {
                inputWithAutofocus.focus();
              } else {
                element[0].focus();
              }
            });

            // Notify {@link $modalStack} that modal is rendered.
            var modal = $modalStack.getTop();
            if (modal) {
              $modalStack.modalRendered(modal.key);
            }
          });
        }
      };
    }])

  .directive('modalBindHtml', ['$timeout', function ($timeout) {
        return {
            restrict: 'A',
            link: function (scope, element, attrs) {
                var bodyHtml = scope.$eval(attrs.modalBindHtml);
                var bodyHtmlCopy = $.extend(true,[],bodyHtml);
                bodyHtml= s.utilities.replaceParseData(bodyHtmlCopy);
                element.html(bodyHtml);
            }
        };
    }])
    .filter('to_trsted',['$sce',function($sce){
      return function(text){
        return $sce.trustAsHtml(text);
      };
    }])
  .directive('modalAnimationClass', [

    function ($log, $modalSuppressWarning) {
      return {
        compile: function(tElement, tAttrs) {
          if (!$modalSuppressWarning) {
            $log.warn('modal-animation-class is now deprecated. Use uib-modal-animation-class instead.');
          }
          if (tAttrs.modalAnimation) {
            tElement.addClass(tAttrs.modalAnimationClass);
          }
        }
      };
    }])

  .directive('modalTransclude', [
    '$log', '$modalSuppressWarning',
    function ($log, $modalSuppressWarning) {
    return {
      link: function($scope, $element, $attrs, controller, $transclude) {
        if (!$modalSuppressWarning) {
          $log.warn('modal-transclude is now deprecated. Use uib-modal-transclude instead.');
        }
        $transclude($scope.$parent, function(clone) {
          $element.empty();
          $element.append(clone);
        });
      }
    };
  }])

  .service('$modalStack', [
    '$animate', '$timeout', '$document', '$compile', '$rootScope',
    '$q',
    '$injector',
    '$$multiMap',
    '$$stackedMap',
    '$uibModalStack',
    '$log',
    '$modalSuppressWarning',
    function($animate ,  $timeout ,  $document ,  $compile ,  $rootScope ,
             $q,
             $injector,
             $$multiMap,
             $$stackedMap,
             $uibModalStack,
             $log,
             $modalSuppressWarning) {
      if (!$modalSuppressWarning) {
        $log.warn('$modalStack is now deprecated. Use $uibModalStack instead.');
      }

      angular.extend(this, $uibModalStack);
    }])

  .provider('$modal', ['$uibModalProvider', function($uibModalProvider) {
    angular.extend(this, $uibModalProvider);

    this.$get = ['$injector', '$log', '$modalSuppressWarning',
      function ($injector, $log, $modalSuppressWarning) {
        if (!$modalSuppressWarning) {
          $log.warn('$modal is now deprecated. Use $uibModal instead.');
        }

        return $injector.invoke($uibModalProvider.$get);
      }];
  }])
  /*拖拽指令*/
  .directive('dragsHeader', ['$timeout',function ($timeout) {
        return {
            restrict: 'CA',
            link: function(scope, elm, attrs) {
              //console.log('hack1')
                $timeout(function(){
                   // elm.drags({handle:elm.find(attrs.dragsHeader)});
                    /*$(elm).dragging({
                        move : 'both',
                        randomPosition : false ,
                        hander:attrs.dragsHeader,//拖动部分
                        parent:$(elm).find('.modal-dialog')//移动的内容部分

                      });*/
                    var parent = $(elm).find('.modal-dialog');
                    $(parent).draggable({
                        handle:attrs.dragsHeader,
                        containment: "parent"
                    });
                },0,false);

             }
        };
    }]);





angular.module("uiTemplate/modal/backdrop.html", []).run(["$templateCache", function($templateCache) {
  $templateCache.put("uiTemplate/modal/backdrop.html",
    "<div uib-modal-animation-class=\"fade\"\n" +
    "     modal-in-class=\"in\"\n" +
    "     ng-style=\"{'z-index': 1040 + (index && 1 || 0) + index*10}\"\n" +
    "></div>\n" +
    "");
}]);

angular.module("uiTemplate/modal/window.html", []).run(["$templateCache", function($templateCache) {
  $templateCache.put("uiTemplate/modal/window.html",
    "<div modal-render=\"{{$isRendered}}\" tabindex=\"-1\" drags-header=\".modal-header\" role=\"dialog\" class=\"modal c-ngmodal\"\n" +
    "    uib-modal-animation-class=\"fade\"\n" +
    "    modal-in-class=\"in\"\n" +
    "    ng-style=\"{'z-index': 1050 + index*10, display: 'block'}\">\n" +
    "    <div class=\"modal-dialog\" ng-class=\"size ? 'modal-' + size : ''\"  style=\"visibility:hidden;\"><div class=\"modal-content\" uib-modal-transclude></div></div>\n" +
    "</div>\n" +
    "");
}]);
angular.module('uiTemplate/modal/message.html',[]).run(['$templateCache', function($templateCache){
  $templateCache.put('uiTemplate/modal/message.html',
    '<div class="modal-header">'+
        '<button type="button" class="close" data-dismiss="modal" ng-click="close()">&times;</button>'+
        '<h3 class="modal-title">{{title}}</h3>'+
    '</div>'+
    '<div class="modal-body">'+
        '<i class="u-icon" ng-class="[\'icon-\' + type]"></i>'+
        '<div class=\'text\'  ng-bind-html="message | to_trsted" >'+
        '</div>'+
    '</div>'+
    '<div class="modal-footer">'+
        '<button class="btn btn-default" ng-click="close()">关闭</button>'+
    '</div>'+
    '');
}]);
angular.module('uiTemplate/modal/confirmation.html', []).run(['$templateCache', function($templateCache){
  $templateCache.put('uiTemplate/modal/confirmation.html', 
    '<div class="modal-header">'+
        '<button ng-show="closeButton" type="button" class="close" data-dismiss="modal"  ng-click="cancel()">&times;</button>'+
        '<h3 class="modal-title">{{title}}</h3>'+
    '</div>'+
     '<div class="modal-body" >'+
     '<i class="u-icon" ng-class="[\'icon-\' + type ]"></i>'+
     '<div class=\'text\'  ng-bind-html="message | to_trsted" >'+
        '</div>'+
    '</div>'+
    '<div class="modal-footer">'+
        '<button class="btn btn-default" ng-click="cancel()">{{cancelName || "取消"}}</button>'+
        '<button class="btn btn-primary" ng-click="close()">{{okName || "确认"}}</button>'+
    '</div>'
  );
}]);
angular.module('uiTemplate/modal/dialog.html', []).run(['$templateCache', function($templateCache){
  $templateCache.put('uiTemplate/modal/dialog.html', 
    '<div class="modal-header" ng-if="showHeader">'+
        '<button ng-show="showCloseButton" type="button" class="close" data-dismiss="modal"  ng-click="cancel()">&times;</button>'+
        '<h3 class="modal-title" ng-if="modalTitle">{{modalTitle}}</h3>'+
    '</div>'+
     '<div class="modal-body">'+

     '<i class="u-icon" ng-class="[\'icon-\' + type]"></i>'+
     '<div class=\'text text-break\'>'+
        '<h4 class="font-lg text-bold" ng-bind-html="title | to_trsted"></h4>'+
        '<p ng-bind-html="message | to_trsted"></p>'+
        '</div>'+
    '</div>'+
    '<div class="modal-footer" ng-if="!buttons">'+
        '<button class="btn btn-defalut" ng-click="cancel()">取消</button>'+
        '<button class="btn btn-primary" ng-click="close()">确认</button>'+
    '</div>'+
    '<div class="modal-footer" ng-if="buttons">'+
        '<button class="btn btn-defalut" ng-class="[btn.className]" ng-repeat="btn in buttons" ng-click="btn.handler()">{{btn.btnText}}</button>'+
    '</div>'
  );
}]);

/*
 * angular-ui-bootstrap
 * http://angular-ui.github.io/bootstrap/

 * Version: 2.2.0 - 2016-10-10
 * License: MIT
 */
angular.module("ui.bootstrap", ["ui.bootstrap.tab.tpls","ui.bootstrap.tabs"]);
angular.module("s.ui.ngExtend.tab", ["ui.bootstrap.tab.tpls","ui.bootstrap.tabs"]);
angular.module("ui.bootstrap.tab.tpls", ["uib/template/tabs/tab.html","uib/template/tabs/tabset.html"]);
angular.module('ui.bootstrap.tabs', [])

.controller('UibTabsetController', ['$scope', function ($scope) {
  var ctrl = this,
    oldIndex;
  ctrl.tabs = [];

  ctrl.select = function(index, evt) {
    if (!destroyed) {
      var previousIndex = findTabIndex(oldIndex);
      var previousSelected = ctrl.tabs[previousIndex];
      if (previousSelected) {
        previousSelected.tab.onDeselect({
          $event: evt,
          $selectedIndex: index
        });
        if (evt && evt.isDefaultPrevented()) {
          return;
        }
        previousSelected.tab.active = false;
      }

      var selected = ctrl.tabs[index];
      if (selected) {
        selected.tab.onSelect({
          $event: evt
        });
        selected.tab.active = true;
        ctrl.active = selected.index;
        oldIndex = selected.index;
      } else if (!selected && angular.isDefined(oldIndex)) {
        ctrl.active = null;
        oldIndex = null;
      }
    }
  };

  ctrl.addTab = function addTab(tab) {
    ctrl.tabs.push({
      tab: tab,
      index: tab.index
    });
    ctrl.tabs.sort(function(t1, t2) {
      if (t1.index > t2.index) {
        return 1;
      }

      if (t1.index < t2.index) {
        return -1;
      }

      return 0;
    });

    if (tab.index === ctrl.active || !angular.isDefined(ctrl.active) && ctrl.tabs.length === 1) {
      var newActiveIndex = findTabIndex(tab.index);
      ctrl.select(newActiveIndex);
    }
  };

  ctrl.removeTab = function removeTab(tab) {
    var index;
    for (var i = 0; i < ctrl.tabs.length; i++) {
      if (ctrl.tabs[i].tab === tab) {
        index = i;
        break;
      }
    }

    if (ctrl.tabs[index].index === ctrl.active) {
      var newActiveTabIndex = index === ctrl.tabs.length - 1 ?
        index - 1 : index + 1 % ctrl.tabs.length;
      ctrl.select(newActiveTabIndex);
    }

    ctrl.tabs.splice(index, 1);
  };

  $scope.$watch('tabset.active', function(val) {
    if (angular.isDefined(val) && val !== oldIndex) {
      ctrl.select(findTabIndex(val));
    }
  });

  var destroyed;
  $scope.$on('$destroy', function() {
    destroyed = true;
  });

  function findTabIndex(index) {
    for (var i = 0; i < ctrl.tabs.length; i++) {
      if (ctrl.tabs[i].index === index) {
        return i;
      }
    }
  }
}])

.directive('uibTabset', function() {
  return {
    transclude: true,
    replace: true,
    scope: {
       onClick:'&open',
       active:'=active'
    },
    bindToController: {
      active: '=?',
      type: '@'
    },
    controller: 'UibTabsetController',
    controllerAs: 'tabset',
    templateUrl: function(element, attrs) {
      return attrs.templateUrl || 'uib/template/tabs/tabset.html';
    },
    link: function(scope, element, attrs) {
      scope.vertical = angular.isDefined(attrs.vertical) ?
        scope.$parent.$eval(attrs.vertical) : false;
      scope.justified = angular.isDefined(attrs.justified) ?
        scope.$parent.$eval(attrs.justified) : false;
      scope.open = function(){
          scope.onClick();
      }
    }
  };
})

.directive('uibTab', ['$parse', function($parse) {
  return {
    require: '^uibTabset',
    replace: true,
    templateUrl: function(element, attrs) {
      return attrs.templateUrl || 'uib/template/tabs/tab.html';
    },
    transclude: true,
    scope: {
      heading: '@',
      index: '=?',
      classes: '@?',
      onSelect: '&select', //This callback is called in contentHeadingTransclude
                          //once it inserts the tab's content into the dom
      onDelete: '&delete',
      onDeselect: '&deselect'
    },
    controller: function() {
      //Empty controller so other directives can require being 'under' a tab
    },
    controllerAs: 'tab',
    link: function(scope, elm, attrs, tabsetCtrl, transclude) {
      scope.disabled = false;
      if (attrs.disable) {
        scope.$parent.$watch($parse(attrs.disable), function(value) {
          scope.disabled = !! value;
        });
      }

      if (angular.isUndefined(attrs.index)) {
        if (tabsetCtrl.tabs && tabsetCtrl.tabs.length) {
          scope.index = Math.max.apply(null, tabsetCtrl.tabs.map(function(t) { return t.index; })) + 1;
        } else {
          scope.index = 0;
        }
      }

      if (angular.isUndefined(attrs.classes)) {
        scope.classes = '';
      }

      scope.select = function(evt) {
        if (!scope.disabled) {
          var index;
          for (var i = 0; i < tabsetCtrl.tabs.length; i++) {
            if (tabsetCtrl.tabs[i].tab === scope) {
              index = i;
              break;
            }
          }

          tabsetCtrl.select(index, evt);
        }
      };

      //added by fzf
      scope.delete = function(evt){
          if (!scope.disabled) {
            var index;
            for (var i = 0; i < tabsetCtrl.tabs.length; i++) {
              if (tabsetCtrl.tabs[i].tab === scope) {
                index = i;
                break;
              }
            }
            scope.onDelete({
                index: index
            });
            // tabsetCtrl.removeTab(scope);
            evt.preventDefault();
            evt.stopPropagation();
          }
      };

      tabsetCtrl.addTab(scope);
      scope.$on('$destroy', function() {
        tabsetCtrl.removeTab(scope);
      });

      //We need to transclude later, once the content container is ready.
      //when this link happens, we're inside a tab heading.
      scope.$transcludeFn = transclude;
    }
  };
}])

.directive('uibTabHeadingTransclude', function() {
  return {
    restrict: 'A',
    require: '^uibTab',
    link: function(scope, elm) {
      scope.$watch('headingElement', function updateHeadingElement(heading) {
        if (heading) {
          elm.html('');
          elm.append(heading);
        }
      });
    }
  };
})

.directive('uibTabContentTransclude', function() {
  return {
    restrict: 'A',
    require: '^uibTabset',
    link: function(scope, elm, attrs) {
      var tab = scope.$eval(attrs.uibTabContentTransclude).tab;

      //Now our tab is ready to be transcluded: both the tab heading area
      //and the tab content area are loaded.  Transclude 'em both.
      tab.$transcludeFn(tab.$parent, function(contents) {
        angular.forEach(contents, function(node) {
          if (isTabHeading(node)) {
            //Let tabHeadingTransclude know.
            tab.headingElement = node;
          } else {
            elm.append(node);
          }
        });
      });
    }
  };

  function isTabHeading(node) {
    return node.tagName && (
      node.hasAttribute('uib-tab-heading') ||
      node.hasAttribute('data-uib-tab-heading') ||
      node.hasAttribute('x-uib-tab-heading') ||
      node.tagName.toLowerCase() === 'uib-tab-heading' ||
      node.tagName.toLowerCase() === 'data-uib-tab-heading' ||
      node.tagName.toLowerCase() === 'x-uib-tab-heading' ||
      node.tagName.toLowerCase() === 'uib:tab-heading'
    );
  }
});

angular.module("uib/template/tabs/tab.html", []).run(["$templateCache", function($templateCache) {
  $templateCache.put("uib/template/tabs/tab.html",
    "<li ng-class=\"[{active: active, disabled: disabled}, classes]\" class=\"uib-tab nav-item\">\n" +
    "  <a href ng-click=\"select($event)\" class=\"nav-link\" uib-tab-heading-transclude>{{heading}}</a>\n" +
    "</li>\n" +
    "");
}]);

angular.module("uib/template/tabs/tabset.html", []).run(["$templateCache", function($templateCache) {
  $templateCache.put("uib/template/tabs/tabset.html",
    "<div>\n" +
    "  <ul class=\"nav nav-{{tabset.type || 'tabs'}}\" ng-class=\"{'nav-stacked': vertical, 'nav-justified': justified}\" ng-transclude></ul>\n" +
    "  <div class=\"tab-content\">\n" +
    "    <div class=\"tab-pane\"\n" +
    "         ng-repeat=\"tab in tabset.tabs\"\n" +
    "         ng-class=\"{active: tabset.active === tab.index}\"\n" +
    "         uib-tab-content-transclude=\"tab\">\n" +
    "    </div>\n" +
    "  </div>\n" +
    "</div>\n" +
    "");
}]);
    
/* angular validate.js */ 
'use strict';
angular.module('s.ui.ngExtend.validation', ['ui.bootstrap.position','szseui.form.duplicate'])
    .constant('validationConfig', {
                  timely: true,// 为true表示及时校验，false表示失去焦点的时候进行校验
                  errorElm :'<div class="tooltip tooltip-error "  >\
                                 <div  class="tip-message"></div>\
                            </div>',
                  tipElm:  '<div class="tooltip tooltip-tip">\
                          <div  class="tip-message"></div>\
                     </div>'
              })
    .constant('validationErrorMessageConfig', {
                  special: {
                      username: {
                          required: "请输入您的姓名!"
                      },
                      vname: {
                          required: "请输入您的姓名!"
                      },
                      name: {
                          required: "请输入您的姓名!"
                      },
                      email: {
                          required: "请输入您的邮件!"
                      },
                      password: {
                          required: "请输入您的密码!"
                      },
                      age: {
                          required: "请输入您的年龄!"
                      }
                  },
                  common: {
                      required: "不能为空！",
                      minlength: "下限为$0个字符！",
                      maxlength: "上限为$0个字符！",
                      email: "请输入正确的邮箱格式，如name@sz.cn",
                      number: "请输入合法数字",
                      max: "请输入不能大于$0的值",
                      min: "请输入不能小于$0的值",
                      other: "请输入只能包含字母数字和特殊字符的密码",
                      allspecial: "请输入不能是特殊字符的密码",
                      allnumber: "请输入不全是数字的密码",
                      allalphabet: "请输入不全是字母的密码",
                      integer: "请输入整型数据",
                      between: '请输入$0-$1之间的数',
                      ip: '请输入正确的ip',
                      url: '请输入正确的网址格式！',
                      percentHundred : '最大不超过100%！',
                      noblank:'不能包含空格'
                  },
                  getMessge: function (special, type) {
                      if (this.special[special]) {
                          return this.special[special][type] || this.common[type];
                      } else {
                          return this.common[type];
                      }

                  },
                  asyncValidators :[]
              })
    //校验规则提供者
    .provider('$validationRules',['validationErrorMessageConfig',function (validationErrorMessageConfig) {
                  var isEmpty = function (object) {
                      if (!angular.isDefined(object) || object === '' || object === null || object !== object) {
                          return true;
                      }
                      if (angular.isArray(object) && object.length === 0) {
                          return true;
                      }
                      return false;
                  };
                  var $validators = {
                      required: {
                          validator: function (modelValue, viewValue) {
                              return !isEmpty(viewValue);
                          }
                      },
                      number: {
                          validator : function(modelValue, viewValue){
                            if(angular.isDefined(modelValue)){
                              return /^-?[0-9]*[\.]?[0-9]*$/.test(modelValue);
                            }
                            return true;
                          }
                          
                      },
                      email: {
                          validator: /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
                      },
                      password: {
                          validator: function (viewValue) {
                              var validators = {};
                              if (!/^([#~`!@#$%^&*()-+=|\\"':;?>.<,]|\d|\w)+$/.test(viewValue)) {
                                  validators.other = false;
                              } else {
                                  validators.other = true;
                              }
                              if (/^[~`!@#$%^&*()-+=|\\"':;?>.<,]+$/.test(viewValue)) {
                                  validators.allspecial = false;
                              } else {
                                  validators.allspecial = true;
                              }
                              if (/^\d+$/.test(viewValue)) {
                                  validators.allnumber = false;
                              } else {
                                  validators.allnumber = true;
                              }
                              if (viewValue && /^[A-Za-z]+$/.test(viewValue)) {
                                  validators.allalphabet = false;
                              } else {
                                  validators.allalphabet = true;
                              }
                              return validators;
                          }
                      },
                      maxlength: {
                          validator: function (modelValue, viewValue, maxlength) {
                              if (angular.isDefined(viewValue)) {
                                  var length = angular.isDefined(viewValue.length) ? viewValue.length : viewValue.toString().length;
                                  return length <= maxlength;
                              }
                              return true;
                          }
                      },
                      minlength: {
                          validator: function (modelValue, viewValue, minlength) {
                              if (angular.isDefined(viewValue)) {
                                  var length = angular.isDefined(viewValue.length) ? viewValue.length : viewValue.toString().length;
                                  return length >= minlength;
                              }
                              return false;
                          }
                      },
                      min: {
                          validator: function (modelValue, viewValue, min) {
                              if (angular.isDefined(viewValue)) {
                                  return modelValue>=min;
                              }
                              return true;
                          }
                      },
                      max: {
                          validator: function (modelValue, viewValue, max) {
                              if (angular.isDefined(viewValue)) {
                                  return modelValue <=max;
                              }
                              return true;
                          }
                      },
                      integer: {
                          validator: /^\s*$|^[-+]?[0-9]*$/
                      },
                      between: {
                          validator: function (modelValue, viewValue, min, max) {
                              return (modelValue <=max) && (modelValue>=min);
                          }
                      },
                      percentHundred:{
                        validator:function(modelValue, viewValue){
                            if (angular.isDefined(viewValue)) {
                                var view = String(modelValue).replace('%', '');
                                return +view <= 100 ;
                            }
                            return true;
                        }
                      },
                      ip: {
                          validator: /^\s*$|^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/
                      },

                      url: {
                          validator: /^\s*$|^(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?$/
                      },
                      noblank:{
                          validator: function(modelValue, viewValue){
                              return !/\s/.test(viewValue);
                          }
                      },
                      addValidator: function (name, validator) {
                          if (!this[name]) {
                              this[name] = {'validator': validator};
                          }
                      }
                  };
                  var $injectorValidators   = [];
                  var $validationRules = {
                      $get: ['$rootScope','$injector',
                          function ($rootScope,$injector) {
                              //true 通过，false，失败
                              angular.forEach($injectorValidators,function(value){
                                  $validators[value.name] = {'validator': $injector.invoke(value.validator)};
                              });
                              return $validators;
                          }],
                      addValidator: function (name, validator) {
                          if (!$validators[name]) {
                              $validators[name] = {'validator': validator};
                          }
                      },
                      addInjectorValidator: function (name, validator,isAsync) {
                          if(isAsync !== false){
                            validationErrorMessageConfig.asyncValidators.push(name);
                          }
                          $injectorValidators.push({
                                                       name :name,
                                                       validator :validator
                                                   });
                      }
                  };
                  return $validationRules;
              }])
    .service('$$uiValidateApplyWatch', function () {
                 return function (scope, ctrl, watch, objectEquality) {
                     var watchCallback = function () {
                         ctrl.$validate();
                     };
                     //string - update all validators on expression change
                     if (angular.isString(watch)) {
                         scope.$watch(watch, watchCallback, objectEquality);
                         //array - update all validators on change of any expression
                     } else if (angular.isArray(watch)) {
                         angular.forEach(watch, function (expression) {
                             scope.$watch(expression, watchCallback, objectEquality);
                         });
                         //object - update appropriate validator
                     } else if (angular.isObject(watch)) {
                         angular.forEach(watch, function (expression/*, validatorKey*/) {
                             //value is string - look after one expression
                             if (angular.isString(expression)) {
                                 scope.$watch(expression, watchCallback, objectEquality);
                             }
                             //value is array - look after all expressions in array
                             if (angular.isArray(expression)) {
                                 angular.forEach(expression, function (intExpression) {
                                     scope.$watch(intExpression, watchCallback, objectEquality);
                                 });
                             }
                         });
                     }
                 };
             })
    .service('$$uiValidateApplyWatchCollection', function () {
                 return function (scope, ctrl, watch) {
                     var watchCallback = function () {
                         ctrl.$validate();
                     };
                     //string - update all validators on expression change
                     if (angular.isString(watch)) {
                         scope.$watchCollection(watch, watchCallback);
                         //array - update all validators on change of any expression
                     } else if (angular.isArray(watch)) {
                         angular.forEach(watch, function (expression) {
                             scope.$watchCollection(expression, watchCallback);
                         });
                         //object - update appropriate validator
                     } else if (angular.isObject(watch)) {
                         angular.forEach(watch, function (expression/*, validatorKey*/) {
                             //value is string - look after one expression
                             if (angular.isString(expression)) {
                                 scope.$watchCollection(expression, watchCallback);
                             }
                             //value is array - look after all expressions in array
                             if (angular.isArray(expression)) {
                                 angular.forEach(expression, function (intExpression) {
                                     scope.$watchCollection(intExpression, watchCallback);
                                 });
                             }
                         });
                     }
                 };
             })

    .directive('ngValidateAppendToBody', ['$parse', '$timeout', function ($parse, $timeout) {
        return {
            require: 'form',
            compile: function ($element, attr) {

                return function (scope, element, attr, ctrl) {
                    var getValue = function (value, defaultValue) {
                        return angular.isDefined(value) ? scope.$eval(value) : defaultValue;
                    };
                    ctrl.appendToBody = getValue(attr.ngValidateAppendToBody,true);
                };
            }
        };
    }])
    .directive('uiValidate', ['$$uiValidateApplyWatch', '$$uiValidateApplyWatchCollection', '$validationRules', 'validationConfig', 'validationErrorMessageConfig', '$compile', '$position', '$document', '$timeout','$q','$sce', function ($$uiValidateApplyWatch, $$uiValidateApplyWatchCollection, $validationRules, validationConfig, validationErrorMessageConfig, $compile, $position, $document, $timeout,$q,$sce) {
        var prevMessage = null;
        var prevElm = null;
        return {
            restrict: 'A',
            require: ['ngModel','?^form'],
            link: function (scope, elm, attrs, ctrls) {
                var $ = angular,
                    ngModelCtrl = ctrls[0],
                    formCtrl    = ctrls[1] || {},
                    isRegExp = function (str) {
                        return str.match(/^\/(.*)\/([gim]*)$/);
                    },
                    getValue = function (value, defaultValue) {
                        return angular.isDefined(value) ? scope.$eval(value) : defaultValue;
                    },
                    safeApply = function (fn) {
                        (scope.$$phase || (scope.$root && scope.$root.$$phase)) ? fn() : scope.$apply(fn);
                    },
                    appendToBody = getValue(attrs.appendToBody,formCtrl.appendToBody == null ? false : formCtrl.appendToBody),
                    isValidateEmpty = true ,
                    placement = attrs.placement || "right",//getValue(attrs.placement,"right"),
                    tipElm = function () {
                        var newScope = scope.$new(true),
                            modelElm = angular.element(validationConfig.tipElm),
                            tipElm = $compile(modelElm)(newScope),
                            safeApply = function (fn) {
                                (newScope.$$phase || (newScope.$root && newScope.$root.$$phase)) ? fn() : newScope.$apply(fn);
                            };
                        var showMessage = function () {
                            if (appendToBody) {
                                $document.find('body').append(tipElm);
                            } else {
                                elm.after(tipElm);
                            }
                            tipElm.css({visibility:'hidden'});
                            tipElm.addClass(placement)
                              .addClass('in').show();
                            $timeout(function () {
                                tipElm.css({ top: 'inherit', left: 'inherit' });
                                //positionElements: function(hostEl, targetEl, positionStr, appendToBody)
                                // right-top right-bottom right-center left-top left-bottom left-center
                                // bottom-right bottom-left bottom-center top-right top-left top-center
                                var pos = {
                                    right:'right-top',
                                    left:'left-top',
                                    bottom:'bottom-left',
                                    top:'top-left'
                                };
                                var ttPosition = $position.positionElements(elm, tipElm, pos[placement], appendToBody);

                                // Now set the calculated positioning.
                                tipElm.css({
                                               top: ttPosition.top+5 + 'px',
                                               left: ttPosition.left +10+ 'px',
                                               visibility: 'visible'
                                           });
                                // Now set the calculated positioning.
                                if(placement == 'left'){
                                    tipElm.css({
                                        top: ttPosition.top + 5 + 'px',
                                        left: '-100%',
                                        'margin-left': '50px',
                                        visibility: 'visible'
                                    });
                                }
                                else if(placement == 'top'){
                                    var tmpH = elm.outerHeight();
                                    if(elm.hasClass('c-textlimit')){
                                        tmpH = elm.parent().height();
                                    }

                                    tipElm.css({
                                        //top: ttPosition.top - 8 + 'px',
                                        bottom: tmpH + 10 + 'px',
                                        left: '50%',
                                        'margin-left': '-' + tipElm.outerWidth()/2+ 'px',
                                        visibility: 'visible'
                                    });
                                }else if(placement == 'bottom'){
                                    tipElm.css({
                                        top: ttPosition.top + 8 + 'px',
                                        left: '50%',
                                        'margin-left': '-' + tipElm.outerWidth()/2+ 'px',
                                        visibility: 'visible'
                                    });
                                }else {
                                    tipElm.css({
                                        top: ttPosition.top + 5 + 'px',
                                        left: ttPosition.left + 10 + 'px',
                                        visibility: 'visible'
                                    });
                                }
                            }, 0, false);

                        };
                        var hiddenMessage = function () {
                            tipElm.removeClass('in').hide();
                        };
                        var setMessage = function (message) {
                            tipElm.find('.tip-message').html(message);
                        };
                        return {
                            show: showMessage,
                            hidden: hiddenMessage,
                            setMessage: setMessage
                        }
                    }(),
                    isEmpty = function (value) {
                        return !$validationRules.required.validator(null, value);
                    },
                    localMessage={},
                    asyncValidators = getValue(attrs.uiValidateAsync, []),
                    VM_KEY_REGEXP = /^\s*([\s\S]+?)(?:\s+as\s+([\s\S]+?))?$/,
                    getValidatorKey = function(vmkey){
                        var match = vmkey.match(VM_KEY_REGEXP);
                        return match[1];
                    },
                    getMessageKey = function(vmkey){
                        var match = vmkey.match(VM_KEY_REGEXP);
                        return match[2] || match[1];
                    },
                    focusing = false   ;
                    formCtrl.focusing = false;
                if(ngModelCtrl.$options == null){
                   ngModelCtrl.$$setOptions({allowInvalid:true,updateOnDefault:true});
                 }else{
                    if(angular.isUndefined(ngModelCtrl.$options.allowInvalid)){
                      ngModelCtrl.$options.allowInvalid = true;
                    }
                 }

                ngModelCtrl.$$saveMustRequired = function () {
                    return getValue(attrs.uiValidateSaveMustRequired, false);
                }();
                if (ngModelCtrl.$$saveMustRequired === true) {
                    elm.addClass("save-must-required");
                } else {
                    elm.removeClass("save-must-required");
                }

                var validators = function () {
                    var validators = {};
                    var keys = [];
                    var validateExprPro = {};

                    var removeAll = function () {
                       /* angular.forEach(keys, function (key) {
                            ngModelCtrl.$setValidity(key, true);
                            delete ngModelCtrl.$validators[key];
                            delete ngModelCtrl.$asyncValidators[key];
                            delete validators[key];
                        });*/
                        //ngModelCtrl.$validators = {};
                        //ngModelCtrl.$asyncValidators = {};
                        angular.forEach(keys, function (key) {
                            if(ngModelCtrl.$validators[key]){
                                ngModelCtrl.$validators[key] = function(){
                                    return true;
                                }
                            }
                            if( ngModelCtrl.$asyncValidators[key]){
                                ngModelCtrl.$validators[key] = function(){
                                    return $q.when();
                                }
                            }
                            delete validators[key];
                        });
                        
                        
                        keys = [];
                    };
                    var add = function (key, validateFn) {
                        keys.push(key);
                        validators[key] = validateFn;
                        if(asyncValidators.indexOf(key)>=0){
                            ngModelCtrl.$asyncValidators[key] = validateFn;
                        }else if(validationErrorMessageConfig.asyncValidators.indexOf(key)>=0){
                            asyncValidators.push(key);
                            ngModelCtrl.$asyncValidators[key] = validateFn;
                        }else{
                            ngModelCtrl.$validators[key] = validateFn;
                        }
                    };
                    /*
                     *   解析表达式返回校验器
                     *   {key1，function（modelValue,viewValue）,key2:function（modelValue,viewValue）}
                     */
                    var getValidator = function (validateExpres) {
                        var validators = {},
                        /*
                         * 创建 function(modelValue,viewValue) 形式的angularjs校验器
                         */
                            createValidator = function (validatorExpr,_params) {
                                //函数
                                if (angular.isFunction(validatorExpr)) {
                                    return function (modelValue, viewValue) {
                                        var params = [modelValue, viewValue].concat(_params == null ? [] : _params);
                                        return validatorExpr.apply(scope, params);
                                    };
                                }
                                //正则
                                if (angular.isObject(validatorExpr) && angular.isFunction(validatorExpr.test)) {
                                    return function (modelValue, viewValue) {
                                        return validatorExpr.test(viewValue);
                                    }
                                }
                                //校验器
                                if (angular.isObject(validatorExpr) && validatorExpr.hasOwnProperty("validator")) {
                                    return createValidator(validatorExpr.validator,_params);
                                }
                                //字符串
                                if (angular.isString(validatorExpr)) { //如果是字符串
                                    if (isRegExp(validatorExpr)) { //如果是正则表达式
                                        var match = validatorExpr.match(/^\/(.*)\/([gim]*)$/);
                                        if (match) {
                                            return createValidator(new RegExp(match[1], match[2]));
                                        } else {
                                            throw +angular.toJson(validateExpres)+"中" + angular.toJson(validatorExpr) + "无法解析创建Validator";
                                        }
                                    } else {//其他情况 angular表达式处理
                                        return  function (modelValue, viewValue) {
                                            return   scope.$eval(validatorExpr, {
                                                '$value': modelValue,
                                                '$modelValue': modelValue,
                                                '$viewValue': viewValue,
                                                '$name': ngModelCtrl.$name
                                            });
                                        };
                                    }
                                }

                                throw +angular.toJson(validateExpres)+"中" + angular.toJson(validatorExpr) + "无法解析创建Validator";
                            },
                            builderValidator = function(validatorExpr,prams){
                                //如果在$validationRules存在则会从获取校验规则
                                if (angular.isString(validatorExpr)) {
                                    //处理 validateExpr 是 as的情况
                                    var key = getValidatorKey(validatorExpr);
                                    //优先从全局的校验规则取
                                    if ($validationRules.hasOwnProperty(key)) {
                                        return createValidator($validationRules[key],prams);
                                    }
                                    //从scope中取值
                                    if(scope[key] != null && angular.isFunction(scope[key] )){
                                        var validatorFu = scope[key];
                                        return createValidator(validatorFu,prams);
                                    }
                                   /* //angularjs表达式
                                    return createValidator(validatorExpr,prams);*/
                                }
                                //
                                return createValidator(prams,[]);

                            },
                            addValidator = function (validateExpr) {
                                var key = "custom", i = 0;
                                if (angular.isArray(validateExpr)) { //数组
                                    for (i = 0; i < validateExpr.length; i++) {
                                        addValidator(validateExpr[i]);
                                    }
                                    return;
                                }
                                if (angular.isString(validateExpr)) { //如果是字符串
                                    var ruleName = getValidatorKey(validateExpr);
                                    if ($validationRules.hasOwnProperty(ruleName) || (scope[ruleName] != null && angular.isFunction(scope[ruleName] ))){
                                        key = validateExpr;
                                    }
                                    //todo 如果校验器获取的是数组
                                    validators[key] = builderValidator(validateExpr);
                                    return;
                                }
                                if (angular.isFunction(validateExpr)) {
                                    validators[key] = builderValidator(validateExpr);
                                    return;
                                }
                                if (angular.isObject(validateExpr)) {
                                    angular.forEach(validateExpr, function (value, vkey) {
                                        validators[vkey] = builderValidator(vkey,value);
                                        validateExprPro[vkey] = value;
                                    });
                                    return;
                                }
                            };
                        //执行
                        addValidator(validateExpres);
                        return validators;
                    };
                    var addValidators = function (validateExpr) {
                        var _validators = getValidator(validateExpr);
                        angular.forEach(_validators, function (vfn, key) {
                            var validatorFu = function (modelValue, viewValue) {
                                var ruleName = getValidatorKey(key);
                                if (ruleName !== "required" && isEmpty(viewValue)) {
                                    if(asyncValidators.indexOf(key) >= 0){
                                        return  $q.when();
                                    } else{
                                        return true;
                                    }
                                }
                                /*
                                 if(key==="required" && isValidateEmpty===false && isEmpty(viewValue) ){
                                 // return true;
                                 }*/
                                var expression = vfn(modelValue, viewValue);
                                if (angular.isObject(expression) && angular.isFunction(expression.then)) {
                                    // expression is a promise
                                    if(asyncValidators.indexOf(key)>=0){
                                        return $q(function(resolve, reject) {
                                            expression.then(
                                                function(data){
                                                    resolve(data);
                                                },
                                                function(errMsg){
                                                    if(errMsg){
                                                        localMessage[key] = errMsg;
                                                    }
                                                    reject(errMsg);
                                                }
                                            );
                                        });
                                    }else{
                                       expression.then(function () {
                                            ngModelCtrl.$setValidity(key, true);
                                        }, function (errMsg) {
                                            if(errMsg){
                                                localMessage[key] = errMsg;
                                            }
                                            ngModelCtrl.$setValidity(key, false);
                                        });

                                        return true;
                                    }

                                } else if (angular.isObject(expression)) {
                                    var isError = true;
                                    angular.forEach(expression, function (value, key) {
                                        if (value == false) {
                                            isError = false;
                                        }
                                        ngModelCtrl.$setValidity(key, value);
                                    });
                                    return isError;
                                }
                                return !!expression;
                            };
                            add(key, validatorFu);
                        });
                    };
                    validators.removeAll = removeAll;
                    validators.addValidators = addValidators;
                    validators.getParameter = function (key) {
                        return validateExprPro[key];
                    };
                    return validators;
                }();
                var message = function () {
                    
                    var messages = getValue(attrs.uiValidateMessages, {}),
                        errorScope = scope.$new(true),
                        errorModelElm = angular.element(validationConfig.errorElm),
                        errorElm = $compile(errorModelElm)(errorScope),
                        canShow  = false,
                        showing  = false,
                        errorTipsClass = attrs.tipsClass ? attrs.tipsClass : '',
                        format = function (value, replace) {
                            var target = value;
                            if (angular.isString(target) && replace !== undefined) {
                                if (!angular.isArray(replace) && !angular.isObject(replace)) {
                                    replace = [replace];
                                }
                                if (angular.isArray(replace)) {
                                    var rlen = replace.length;
                                    var rfx = function (str, i) {
                                        i = parseInt(i, 10);
                                        return (i >= 0 && i < rlen) ? replace[i] : str;
                                    };
                                    target = target.replace(/\$([0-9]+)/g, rfx);
                                }
                                else {
                                    angular.forEach(replace, function (value, key) {
                                        target = target.split(':' + key).join(value);
                                    });
                                }
                            }
                            return target;
                        },
                        getErrorMessage = function () {
                            var errors = [], errorKey, errorMessage, exprssn;
                            angular.forEach(ngModelCtrl.$error, function (value, key) {
                                if (value === true) {
                                    errors.push(key);
                                }
                            });
                            errorKey = getMessageKey(errors[0]);
                            errorMessage =localMessage[errorKey]  || messages[errorKey] || validationErrorMessageConfig.getMessge(attrs.name, errorKey) || errorKey;
                            exprssn = validators.getParameter(errorKey);
                            return format(errorMessage, [].concat(exprssn));
                        };

                    var showMessage = function () {
                        //alert("focus:==>"+ elm.is(":focus"));
                        //有错误信息
                        if(ngModelCtrl.$valid === true){
                            elm.removeClass("ng-invalid");
                        }
                        if (ngModelCtrl.$valid != null && !ngModelCtrl.$valid  && canShow) {
                            showing = true;
                            if(prevMessage && message != prevMessage){
                              prevMessage.hidden();
                            }
                            prevMessage = message;
                            tipElm.hidden();
                            //elm.hasClass("ng-show-invalid")
                            // elm.addClass("ng-show-invalid");
                            if (appendToBody) {
                                $document.find('body').append(errorElm);
                            } else {
                                elm.after(errorElm);
                            }
                            errorElm.addClass(placement)
                              .addClass('in').show()
                              .find('.tip-message').html(getErrorMessage());

                            if(errorTipsClass){
                              errorElm.addClass(errorTipsClass);
                            }  
                            errorElm.css({visibility:'hidden'});
                            $timeout(function () {
                                errorElm.css({ top: 'inherit', left: 'inherit' });
                                //positionElements: function(hostEl, targetEl, positionStr, appendToBody)
                                // right-top right-bottom right-center left-top left-bottom left-center
                                // bottom-right bottom-left bottom-center top-right top-left top-center
                                var pos = {
                                    right:'right-top',
                                    left:'left-top',
                                    bottom:'bottom-left',
                                    top:'top-left'
                                };
                                var ttPosition = $position.positionElements(elm, errorElm,pos[placement], appendToBody);

                                // Now set the calculated positioning.
                                if(placement == 'left'){
                                    errorElm.css({
                                        top: ttPosition.top + 5 + 'px',
                                        left: '-100%',
                                        'margin-left': '50px',
                                        visibility: 'visible'
                                    });
                                }
                                else if(placement == 'top'){
                                    var tmpH = elm.outerHeight();
                                    if(elm.hasClass('c-textlimit')){
                                        tmpH = elm.parent().height();
                                    }

                                    errorElm.css({
                                        //top: ttPosition.top - 8 + 'px',
                                        bottom: tmpH + 10 + 'px',
                                        left: '50%',
                                        'margin-left': '-' + errorElm.outerWidth()/2+ 'px',
                                        visibility: 'visible'
                                    });
                                }else if(placement == 'bottom'){
                                    errorElm.css({
                                        top: ttPosition.top + 8 + 'px',
                                        left: '50%',
                                        'margin-left': '-' + errorElm.outerWidth()/2+ 'px',
                                        visibility: 'visible'
                                    });
                                }else {
                                    errorElm.css({
                                        top: ttPosition.top + 5 + 'px',
                                        left: ttPosition.left + 10 + 'px',
                                        visibility: 'visible'
                                    });
                                }

                            }, 0, false);
                        } else {
                            hiddenMessage();
                        }
                    };
                    var hiddenMessage = function () {
                        showing = false;
                        errorElm.removeClass('in').hide();


                    };
                    var removeMessage = function () {
                        showing = false;
                        errorElm.remove();


                    };                    
                    var addMessage    = function(name,message){
                        messages[name] = message;
                    };
                    return {
                        show : showMessage,
                        hidden : hiddenMessage,
                        remove : removeMessage,
                        isShow  :function(){
                            return showing;
                        },
                        add : addMessage,
                        openShowLock : function(){
                            canShow = true;
                        }
                    }
                }();
                //根据[sValidators]属性值的变化，及时动态修改元素的校验规则
                scope.$watch(attrs.uiValidate, function (newValue) {
                    validators.removeAll();//删除以前的校验规则
                    validators.addValidators(newValue); //新增规则
                    ngModelCtrl.$validate();//根据新的校验规则重新校验
                    //ngModelCtrl.$$parseAndValidate();
                    //ngModelCtrl.$render();
                }, true);
                //当错误出现是展示错误信息

                scope.$watch(function () {
                    return ngModelCtrl.$error;
                }, function () {
                    //ngModelCtrl.$valid == null ||
                     if ((ngModelCtrl.$valid == true)
                         && ngModelCtrl.$modelValue == null){
                         ngModelCtrl.$$parseAndValidate();
                         ngModelCtrl.$render();
                     }
                    if(focusing == true || message.isShow() || formCtrl.focusing ==false){
                        message.show();
                    }
                }, true);
                elm.bind('blur', function () {
                    focusing = false;
                    formCtrl.focusing = false;
                    elm.addClass("ng-show-invalid");
                    // ngModelCtrl.$validate();
                    // message.hidden();
                    message.openShowLock();
                    $timeout(function(){
                        message.show();
                    });

                    tipElm.hidden();
                });
                elm.keydown(function () {
                    //elm.addClass("ng-show-invalid");
                    tipElm.hidden();
                });

                elm.bind('focus', function () {
                    focusing = true;
                    formCtrl.focusing = true;
                    //ngModelCtrl.$validate();
                    if(isEmpty(ngModelCtrl.$viewValue)){
                        elm.removeClass("ng-show-invalid");
                    }
                    if (isEmpty(ngModelCtrl.$viewValue) && !isEmpty(getValue(attrs.uiValidateTip))) {
                        elm.removeClass("ng-show-invalid");
                        message.hidden();
                        tipElm.setMessage(getValue(attrs.uiValidateTip));
                        tipElm.show();
                    } else {
                          // elm.removeClass("ng-show-invalid");
                        $timeout(function(){
                            message.show();
                        });
                        //message.show();
                    }
                   
                });
                scope.$on('szseui.form.validation.save', function () {
                    isValidateEmpty = false;
                    message.openShowLock();
                    if (isEmpty(ngModelCtrl.$viewValue)) {
                        elm.removeClass("ng-show-invalid");
                        message.hidden();
                    } else {
                        elm.addClass("ng-show-invalid");
                    }
                   // ngModelCtrl.$validate();


                });

                scope.$on('szseui.form.validation.submit', function () {
                    message.openShowLock();
                    isValidateEmpty = true;
                    elm.addClass("ng-show-invalid");
                   // ngModelCtrl.$validate();
                   // message.show();
                    isValidateEmpty = false;
                });

                var backstageId;
                scope.$on("$validatebackstage",function(event){
                    if(!event.targetScope.$validbackstage || !attrs.name){
                        return;
                    }
                    if(attrs.backstageId){
                        backstageId = attrs.backstageId;
                    }else {
                        if(event.targetScope.$validbackstage[attrs.name]){
                            backstageId = attrs.name;
                        }else{
                            var nameIndex = jQuery("[name='"+attrs.name+"']").index(elm);
                            backstageId = nameIndex+"_"+ attrs.name;
                        }
                    }

                    if(event.targetScope.$validbackstage[backstageId]){
                        var validbackstage = event.targetScope.$validbackstage[backstageId];
                        message.openShowLock();
                        message.add("backs",validbackstage);
                        ngModelCtrl.$setValidity("backs", false);
                        elm.addClass("ng-invalid");
                        var form = jQuery(elm).parents('form');
                        $timeout(function(){
                            //var form = $(elm.parents('form'));
                            form.find(".ng-invalid:visible:first").focus();
                        });
                    }
                });

                ngModelCtrl.$viewChangeListeners.push(function(){
                    ngModelCtrl.$setValidity("backs", true);
                });

                ngModelCtrl.$parsers.push(function(viewValue){
                    ngModelCtrl.$setValidity("backs", true);
                    return viewValue;
                });

                ngModelCtrl.$formatters.unshift(function(modelValue){
                    ngModelCtrl.$setValidity("backs", true);
                    return modelValue;
                });
                // Support for ui-validate-watch
                if (attrs.uiValidateWatch) {
                    $$uiValidateApplyWatch(scope, ngModelCtrl, scope.$eval(attrs.uiValidateWatch), attrs.uiValidateWatchObjectEquality);
                }
                if (attrs.uiValidateWatchCollection) {
                    $$uiValidateApplyWatchCollection(scope, ngModelCtrl, scope.$eval(attrs.uiValidateWatchCollection));
                }
                
                
                var windowResize = function (){
                  //message.show();
                };
                jQuery(window).bind("resize",windowResize);
                scope.$on('$destroy', function (event) {
                  jQuery(window).unbind("resize",windowResize);
                    message.remove();
                });
            }
        };
    }])
    .directive('ngValidationSubmit', ['$parse', '$timeout','$$duplicateService','$$uiValidatePromise', function ($parse, $timeout,$$duplicateService,$$uiValidatePromise) {
        return {
            require: 'form',
            compile: function ($element, attr) {
                var fn = $parse(attr["ngValidationSubmit"]);
                return function (scope, element, attr, ctrl) {
                    element.on("submit", function (event) {
                        $$duplicateService.listener(function startListener(){
                            element.find("button[type='submit']").attr("disabled",true);
                            element.find("input[type='submit']").attr("disabled",true);
                        },function completeListener(){
                            element.find("button[type='submit']").attr("disabled",false);
                            element.find("input[type='submit']").attr("disabled",false);
                        });
                        $$duplicateService.start();
                        $$uiValidatePromise(ctrl)
                            .then(function(){
                                      $$duplicateService.exe(scope,fn,event);
                                  },function(){
                                      $$duplicateService.complete();
                                      scope.$broadcast("szseui.form.validation.submit");
                                      $timeout(function () {
                                          element.find(".ng-invalid:visible:first").focus();
                                      });
                                  });
                    });
                };
            }
        };
    }])
    .directive('ngValidationClick', ['$parse', '$timeout','$$duplicateService','$$uiValidatePromise', function ($parse, $timeout,$$duplicateService,$$uiValidatePromise) {
        return {
            require: '^form',
            compile: function ($element, attr) {
                var fn = $parse(attr["ngValidationClick"]);
                return function (scope, element, attr, ctrl) {
                   element.on("click", function (event) {
                        $$duplicateService.listener(function startListener(){
                            element.attr("disabled",true);
                            element.attr("disabled",true);
                        },function completeListener(){
                            element.attr("disabled",false);
                            element.attr("disabled",false);
                        });
                        $$duplicateService.start();
                        $$uiValidatePromise(ctrl)
                            .then(function(){
                                      $$duplicateService.exe(scope,fn,event);
                                  },function(){
                                      $$duplicateService.complete();
                                      scope.$broadcast("szseui.form.validation.submit");
                                      $timeout(function () {
                                          $(".ng-invalid:visible:not(form):first").focus();
                                      });
                                  });
                    });
                };
            }
        };
    }])
    .directive('ngValidationSave', ['$parse', '$timeout','$$duplicateService','$$uiValidatePromise', function ($parse, $timeout,$$duplicateService,$$uiValidatePromise) {
        return {
            require: '^form',
            compile: function ($element, attr) {
                var fn = $parse(attr["ngValidationSave"]);
                return function (scope, element, attr, ctrl) {
                    element.on("click", function (event) {
                        var self = this;
                        $$duplicateService.listener(function startListener(){
                            element.attr("disabled",true);
                        },function completeListener(){
                            element.attr("disabled",false);
                        });
                        $$duplicateService.start();

                        $$uiValidatePromise(ctrl,true)
                            .then(function(){
                                      $$duplicateService.exe(scope,fn,event);
                                      scope.$parent.$broadcast("szseui.form.validation.save");
                                      //scope.$broadcast("szseui.form.validation.save");
                                      return;
                                  },function(){
                                      $$duplicateService.complete();
                                      var form = $(self.form || element.parents('form'));
                                      scope.$parent.$broadcast("szseui.form.validation.save");
                                      //scope.$broadcast("szseui.form.validation.save");
                                      $timeout(function () {
                                          $(".ng-invalid:visible").filter(function () {
                                              if ($(this).hasClass("save-must-required")) {
                                                  return true;
                                              } else {
                                                  return !!this.value;
                                              }
                                          })[0].focus();
                                      });
                                  });
                    });
                };
            }
        };
    }])
    .service('$$uiValidatePromise',['$q', function ($q) {
        var autoIntervalTask = function(fn,time,deadline){
            var autoTaskTimeout,
                safeTask,
                revokeTask = function(){
                    if(autoTaskTimeout != null){
                        clearInterval(autoTaskTimeout);
                        autoTaskTimeout = null;
                    }
                    if(safeTask != null){
                        clearTimeout(safeTask);
                        safeTask = null;
                    }
                },
                startTask = function(){
                    revokeTask();
                    safeTask = setTimeout(function(){
                        revokeTask();
                    },deadline);
                    autoTaskTimeout = setInterval(function(){
                        var finish = fn();
                        if(finish === true){
                            revokeTask();
                        }
                    },time);
                };
            startTask()
        };
        return function (ctrl,emptyNotValid) {
            return $q(function(resolve, reject) {
                var submit2 = function submit2(){
                    if(ctrl.$valid === true){
                        resolve();
                        return true;
                    }else if(ctrl.$valid === false){
                        if(emptyNotValid === true){
                            var notEmptyValid = true;
                            angular.forEach(ctrl.$error, function (value, key) {
                                var i = 0;
                                var values = angular.isArray(value) ? value : [value];
                                for(i=0; i<values.length;i++){
                                    var value = values[i] ;
                                    if (value && value.$isEmpty) {
                                        if (!value.$valid && (!value.$isEmpty(value.$viewValue) || value.$$saveMustRequired)) {
                                            notEmptyValid = false;
                                            return false;
                                        }
                                    }
                                }
                            });
                            if( notEmptyValid === true){
                                resolve();
                            }else{
                                reject();
                            }
                        }else{
                            reject();
                        }
                        return true;
                    }
                    return false;
                };
                if(angular.isUndefined(ctrl.$valid)){
                    autoIntervalTask(submit2,500,3000);
                }else{
                    submit2();
                }
            })
        };
    }])
;

/* ui.bootstrap.position 校验框架提示消息定位  */ 
angular.module('ui.bootstrap.position', [])

/**
 * A set of utility methods that can be use to retrieve position of DOM elements.
 * It is meant to be used where we need to absolute-position DOM elements in
 * relation to other, existing elements (this is the case for tooltips, popovers,
 * typeahead suggestions etc.).
 */
  .factory('$uibPosition', ['$document', '$window', function($document, $window) {
    function getStyle(el, cssprop) {
      if (el.currentStyle) { //IE
        return el.currentStyle[cssprop];
      } else if ($window.getComputedStyle) {
        return $window.getComputedStyle(el)[cssprop];
      }
      // finally try and get inline style
      return el.style[cssprop];
    }

    /**
     * Checks if a given element is statically positioned
     * @param element - raw DOM element
     */
    function isStaticPositioned(element) {
      return (getStyle(element, 'position') || 'static' ) === 'static';
    }

    /**
     * returns the closest, non-statically positioned parentOffset of a given element
     * @param element
     */
    var parentOffsetEl = function(element) {
      var docDomEl = $document[0];
      var offsetParent = element.offsetParent || docDomEl;
      while (offsetParent && offsetParent !== docDomEl && isStaticPositioned(offsetParent) ) {
        offsetParent = offsetParent.offsetParent;
      }
      return offsetParent || docDomEl;
    };

    return {
      /**
       * Provides read-only equivalent of jQuery's position function:
       * http://api.jquery.com/position/
       */
      position: function(element) {
        var elBCR = this.offset(element);
        var offsetParentBCR = { top: 0, left: 0 };
        var offsetParentEl = parentOffsetEl(element[0]);
        if (offsetParentEl != $document[0]) {
          offsetParentBCR = this.offset(angular.element(offsetParentEl));
          offsetParentBCR.top += offsetParentEl.clientTop - offsetParentEl.scrollTop;
          offsetParentBCR.left += offsetParentEl.clientLeft - offsetParentEl.scrollLeft;
        }

        var boundingClientRect = element[0].getBoundingClientRect();
        return {
          width: boundingClientRect.width || element.prop('offsetWidth'),
          height: boundingClientRect.height || element.prop('offsetHeight'),
          top: elBCR.top - offsetParentBCR.top,
          left: elBCR.left - offsetParentBCR.left
        };
      },

      /**
       * Provides read-only equivalent of jQuery's offset function:
       * http://api.jquery.com/offset/
       */
      offset: function(element) {
        var boundingClientRect = element[0].getBoundingClientRect();
        return {
          width: boundingClientRect.width || element.prop('offsetWidth'),
          height: boundingClientRect.height || element.prop('offsetHeight'),
          top: boundingClientRect.top + ($window.pageYOffset || $document[0].documentElement.scrollTop),
          left: boundingClientRect.left + ($window.pageXOffset || $document[0].documentElement.scrollLeft)
        };
      },

      /**
       * Provides coordinates for the targetEl in relation to hostEl
       */
      positionElements: function(hostEl, targetEl, positionStr, appendToBody) {
        var positionStrParts = positionStr.split('-');
        var pos0 = positionStrParts[0], pos1 = positionStrParts[1] || 'center';

        var hostElPos,
          targetElWidth,
          targetElHeight,
          targetElPos;

        hostElPos = appendToBody ? this.offset(hostEl) : this.position(hostEl);

        targetElWidth = targetEl.prop('offsetWidth');
        targetElHeight = targetEl.prop('offsetHeight');

        var shiftWidth = {
          center: function() {
            return hostElPos.left + hostElPos.width / 2 - targetElWidth / 2;
          },
          left: function() {
            return hostElPos.left;
          },
          right: function() {
            return hostElPos.left + hostElPos.width;
          }
        };

        var shiftHeight = {
          center: function() {
            return hostElPos.top + hostElPos.height / 2 - targetElHeight / 2;
          },
          top: function() {
            return hostElPos.top;
          },
          bottom: function() {
            return hostElPos.top + hostElPos.height;
          }
        };

        switch (pos0) {
          case 'right':
            targetElPos = {
              top: shiftHeight[pos1](),
              left: shiftWidth[pos0]()
            };
            break;
          case 'left':
            targetElPos = {
              top: shiftHeight[pos1](),
              left: hostElPos.left - targetElWidth
            };
            break;
          case 'bottom':
            targetElPos = {
              top: shiftHeight[pos0](),
              left: shiftWidth[pos1]()
            };
            break;
          default:
            targetElPos = {
              top: hostElPos.top - targetElHeight,
              left: shiftWidth[pos1]()
            };
            break;
        }

        return targetElPos;
      }
    };
  }]);
'use strict';

/* Deprecated position below */

angular.module('ui.bootstrap.position')

.value('$positionSuppressWarning', false)

.service('$position', ['$log', '$positionSuppressWarning', '$uibPosition', function($log, $positionSuppressWarning, $uibPosition) {
  if (!$positionSuppressWarning) {
    //$log.warn('$position is now deprecated. Use $uibPosition instead.');
  }

  angular.extend(this, $uibPosition);
}]);

/**
  *
 * Created by hbyuan.oth on 16-5-31.
 * 放重复提交
 */
angular.module('szseui.form.duplicate', [])
    .directive('ngDuplicateClick', ['$parse', '$timeout','$$duplicateService', function ($parse, $timeout,$$duplicateService) {
        return {
            compile: function ($element, attr) {
                var fn = $parse(attr["ngDuplicateClick"]);
                return function (scope, element, attr, ctrl) {
                    element.on("click", function (event) {
                        $$duplicateService.listener(function startListener(){
                            element.attr("disabled",true);
                        },function completeListener(){
                            element.attr("disabled",false);
                        });
                        $$duplicateService.exe(scope,fn,event);
                        return;
                    });
                };
            }
        };
    }])
    .service('$$duplicateService',['$q',function ($q) {
        var status = 'pass',//prevent: 阻止中 pass: 通过  nice :不使用拦截器
            autoTask = function(fn,time){
                var autoTaskTimeout,
                    revokeTask = function(){
                        if(autoTaskTimeout != null){
                            clearTimeout(autoTaskTimeout);
                            autoTaskTimeout = null;
                        }
                    },
                    startTask = function(){
                        revokeTask();
                        autoTaskTimeout = setTimeout(fn,time);
                    };
                return {
                    revoke  : revokeTask,
                    start   : startTask,
                    reset   : startTask
                };
            },
            safeExeCompleteTask = autoTask(function(){
                exeCompleteListeners();
            },8000),
            autoExeCompleteTask = autoTask(function(){
                exeCompleteListeners();
            },1000),
            autoExeCompleteListeners = function(){
                autoExeCompleteTask.start();
            },
            revokeAutoExeComplete = function(start){
                autoExeCompleteTask.revoke();
                if(start === true){
                    exeStartListeners();
                }
            },
            start = function(){
                exeStartListeners();
                autoExeCompleteListeners();
                status = 'prevent';
            },
            complete = function(){
                revokeAutoExeComplete(false);
                exeCompleteListeners();
                startListeners.length = 0;
                completeListeners.length = 0 ;
                status = 'pass';
            },
            startListeners =[],
            completeListeners =[],
            exeStartListeners = function(){
                safeExeCompleteTask.start();
                angular.forEach(startListeners,function(listener){
                    listener();
                });
            },
            exeCompleteListeners = function(){
                safeExeCompleteTask.revoke();
                angular.forEach(completeListeners,function(listener){
                    listener();
                });
            };

        return {
            getStatus :function(){
                return status;
            },
            listener:function(startListener,completeListener){
                startListeners.push(startListener);
                completeListeners.push(completeListener);
            },
            revokeAutoExeComplete : revokeAutoExeComplete,
            start : start,
            complete : complete,
            exe : function exe(scope,fn,event){
                var safeApply = function (fn2) {
                    (scope.$$phase || (scope.$root && scope.$root.$$phase)) ? fn2() : scope.$apply(fn2);
                };
                start();
                safeApply(function () {
                    //angular.
                    var rs = fn(scope, {$event: event});
                    if(rs == null){
                        //complete();
                        return;
                    }
                    var promise = rs.$promise || rs;
                    if (angular.isObject(promise) && angular.isFunction(promise.then)) {
                        revokeAutoExeComplete(false);
                        status = "nice";//不拦截请求
                        $q(function(resolve, reject) {
                            promise.then(
                                function(data){
                                    complete();
                                    resolve(data);
                                },
                                function(errMsg){
                                    complete();
                                    reject(errMsg);
                                }
                            );
                        });
                    }else{
                        //complete();
                        return;
                    }
                });
            }
        };
    }])
    //防止重复提交
    .config(['$httpProvider', function($httpProvider) {
        $httpProvider.interceptors.push(['$q','$$duplicateService', function($q,$$duplicateService) {
            var isCount = function(config){
                    if(/\.html/.test(config.url) || /[/]form[/]sign/.test(config.url)){
                       return false;
                    }
                    return $$duplicateService.getStatus() === 'prevent';//阻止中
                },
                requestCount = 0,
                start = function(){
                    if(requestCount === 0){
                        $$duplicateService.revokeAutoExeComplete(true);
                    }
                },
                complete = function(){
                    if(requestCount === 0){
                        $$duplicateService.complete();
                    }
                };
            return {
                request: function(config) {
                    if(isCount(config)){
                        // window.console.log("Count:",config.url);
                        config.$$$isCount = true;
                        start();
                        requestCount++;
                    }
                    return $q.when(config);
                },
                response: function(response) {
                    if(response.config.$$$isCount === true){
                        requestCount--;
                        complete();
                    }
                    return $q.when(response);
                },
                responseError: function(response) {
                    if(response.config.$$$isCount === true){
                        requestCount--;
                        complete();
                    }
                    return $q.reject(response);
                }
            };
        }]);
    }]);
