
/* kindeditor javascript AngularJS */

angular.module('s.ui.libs.kindeditor', [])

//KindEdite控件
/*source HTML代码 
preview 预览 
undo 后退 
redo 前进 
cut 剪切 
copy 复制 
paste 粘贴 
plainpaste 粘贴为无格式文本 
wordpaste 从Word粘贴 
selectall 全选 
justifyleft 左对齐 
justifycenter 居中 
justifyright 右对齐 
justifyfull 两端对齐 
insertorderedlist 编号 
insertunorderedlist 项目符号 
indent 增加缩进 
outdent 减少缩进 
subscript 下标 
superscript 上标 
formatblock 段落 
fontname 字体 
fontsize 文字大小 
forecolor 文字颜色 
hilitecolor 文字背景 
bold 粗体 
italic 斜体 
underline 下划线 
strikethrough 删除线 
removeformat 删除格式 
image 图片 
flash Flash 
media 视音频 
table 表格 
hr 插入横线 
emoticons 插入表情 
link 超级链接 
unlink 取消超级链接 
fullscreen 全屏显示 
about 关于 
print 打印 
code 插入程序代码 
map Google地图 
baidumap 百度地图 
lineheight 行距 
clearhtml 清理HTML代码 
pagebreak 插入分页符 
quickformat 一键排版 
insertfile 插入文件 
template 插入模板 
anchor 插入锚点 */
.constant('kindediteConfig',{
        uploadJson : '../file/uploadkindfile',      
        items : [
                'source', '|', 'undo', 'redo', '|', 'preview', 'print', 'template', 'code', 'cut', 'copy', 'paste',
                'plainpaste', 'wordpaste', '|', 'justifyleft', 'justifycenter', 'justifyright',
                'justifyfull', 'insertorderedlist', 'insertunorderedlist', 'indent', 'outdent', 'subscript',
                'superscript', 'clearhtml', 'quickformat', 'selectall', '|', 'fullscreen', '|',
                'formatblock', 'fontname', 'fontsize', '|', 'forecolor', 'hilitecolor', 'bold',
                'italic', 'underline', 'strikethrough', 'lineheight', 'removeformat', '|', 'image', 'multiimage',
                'flash', 'media', 'insertfile', 'table', 'hr', 'emoticons', 'baidumap', 'pagebreak',
                'anchor', 'link', 'unlink', '|', 'about'
        ],
        allowFileManager : false,
        resizeType:1
})
    
.directive('kindeditor',['$parse','kindediteConfig','$timeout',function($parse,kindediteConfig,$timeout){
    return{
        restrict: 'EA',
        //templateUrl: '/common/js/lib/kindeditor/kindedite.html',
        template:'<textarea id="content1" name="infoContent1" style="width:100%;height:220px;" />',
        scope:{
                isreadonly:'=',
                afterChange:'&'
            },
        require: 'ngModel',
        link:function($scope,$element,$attrs,ngModel){                      
            var ele=$element.find('textarea');
            var isfocus=false;
            var iscreate=false;
            KindEditor.remove(ele); 
            $scope.$on('$destroy',function(){
                KindEditor.remove(ele);
            });
                        
            var editor= KindEditor.create(ele, {
                uploadJson:kindediteConfig.uploadJson,
                items:kindediteConfig.items,
                afterFocus:function(){
                    isfocus=true;
                },
                afterBlur:function(){
                    isfocus=false;
                },
                afterCreate:function(){
                    this.readonly(!!$scope.isreadonly);
                    
                    $scope.$watch(function(){
                        return $scope.isreadonly;
                    },function(newValue,oldValue){
                        if(newValue&&editor){
                            editor.readonly(!!newValue);
                            $element.find(".ke-toolbar").css({"display":"none"});
                        }else{
                            editor.readonly(!!newValue);
                            $element.find(".ke-toolbar").css({"display":"block"});
                        }
                    });
                    if($scope.afterChange){
                        $scope.afterChange({textlength:this.count('text')});
                    }
                },
                afterChange:function(val){
                    if(isfocus&&!!editor){
                        $scope.$apply(function(){
                            ngModel.$setViewValue(editor.html());
                        });
                    }
                    if($scope.afterChange){
                        $timeout(function(){
                            $scope.afterChange({textlength:editor.count('text')});
                        });
                    }
                }
            });
                        
            $scope.$watch(function(){
                return ngModel.$modelValue;
            },function(newValue,oldValue){
                if(!isfocus){
                    editor.html(newValue);
                }
            });
        }
    }
}]);
