//页面统一配置
var config = {
    template: { // --------------------------模板
        trendTemStr: $('#trendTemplate').html(), //行情详细数据
        newTemStr: $('#newDataTem').html(), //行情详细数据
    },
    minuteUrl: domain.marketweb + 'ssjjhq/getTimeData?', //分时url
    kUrl: domain.marketweb + 'ssjjhq/getHistoryData?', //k线url
    // minuteUrl: 'json/minute.json', //分时url 指数
    // minuteUrl: 'json/minute2.json', //分时url   证券
    // kUrl: 'json/history.json', //k线url
    charts: {},
    code: '399001',
    code1: '399006',
    code2: '399330',
    tabIndex: 0,
    tabInfoObj: null,
    changeTopInfo:true,
    chartTabIndex:0
}

window.initial = function() {
    initElements();
    switchTabs();
    exponentTab();
    setChartData(true);
    topBindEvent();

    mui('body').on("tap", "#errorBox", function() {
        // location.reload();
        if(config.charts.minuteChart && config.charts.dayChart && config.charts.weekChart && config.charts.monthChart){
            setChartData(false);
        }else{
            setChartData(true);
        }
       
    });

    mui('body').on("tap", ".noDataShow", function() {
        // location.reload();
        if(config.charts.minuteChart && config.charts.dayChart && config.charts.weekChart && config.charts.monthChart){
            setChartData(false);
        }else{
            setChartData(true);
        }
    });

    if (mui.os.ios && (document.body.clientHeight < 768)) {
        document.querySelector('header').style.height = '1.97333rem';
        document.querySelector('header').style.paddingTop = '0.93333rem';
        document.querySelector('#inputTag').style.height = '0.864864rem';
        document.querySelector('#searchLog').style.height = '0.864864rem';
    }else if(mui.os.ios && (document.body.clientHeight > 768)){
        document.querySelector('header').style.height = ' 2.88rem'; 
        document.querySelector('header').style.paddingTop = '2rem'; 
    }else if(mui.os.android){
        document.querySelector('header').style.height = 'auto';
        document.querySelector('header').style.paddingTop = '0.5rem';
        document.querySelector('form').style.position = 'static';
    }
};

function chartHight() {
    var windH = $(window).height();
    var haderH = $("header").outerHeight();
    var detailH = $(".trend-detail-wrap").outerHeight();
    var tabH = $(".pic-tabs").outerHeight(true);
    var highStr = windH - haderH - detailH - tabH;
    if(highStr < 280){
        $("body").css("height","100%");
        // $("body").css("padding-bottom","29px");
        $("body").css("overflow","scroll");
        highStr = 280;
    }
    $(".tabs-content").height(highStr);
    // $(".index-chart").height(highStr + tabH);
}


//初始化dom元素
function initElements() {
    config.elements = {
        trendWrap: $('.trend-wrap'), //行情容器
        trendPic: $('.pic-chart', '.trend-wrap'), //行情图形
        minuteWrap: $('#minutely'), //分时图
        dayWrap: $('#daily'), //日线
        weekWrap: $('#weekly'), //周线
        monthWrap: $('#monthly'), //月线
        trendTabs: $('.pic-tabs', '.trend-wrap'), //行情tabs
        newInfoWrap: $('.new-info'), //行情详细信息容器,
        newInfoTab: $('.new-info', ".exponent-panel"), //行情详细信息容器,
        trendDetailWrap: $('.detail-info'), //行情详细信息容器,
        detailContent: null,
        clickflag: true
    }
}

//获取行情图
function setChartData(flag, initCode) {

    var loadingPlugin = window.Loading(config.elements.trendPic);

    //开始加载
    if (loadingPlugin) {
        loadingPlugin.start();
    }
    var sCode = initCode ? initCode : config.code;

    $.when(ajaxRequest({
            // url: 'pcInfo/source/json/min.json',
            url: config.minuteUrl + setRequestParam('minute', config.code),
            type: 'GET',
            // data: setRequestParam('minute'),
            tag: "100",
            loadingPlugin: null
        }),
        ajaxRequest({
            // url: 'pcInfo/source/json/min.json',
            url: config.minuteUrl + setRequestParam('minute', config.code1),
            type: 'GET',
            // data: setRequestParam('minute'),
            tag: "1005",
            loadingPlugin: null
        }),
        ajaxRequest({
            // url: 'pcInfo/source/json/min.json',
            url: config.minuteUrl + setRequestParam('minute', config.code2),
            type: 'GET',
            // data: setRequestParam('minute'),
            tag: "1006",
            loadingPlugin: null
        }),
        ajaxRequest({
            // url: 'pcInfo/source/json/day.json',
            url: config.kUrl + setRequestParam('day', sCode),
            type: 'GET',
            tag: "200",
            // data: setRequestParam('day'),
            loadingPlugin: null
        }),
        ajaxRequest({
            // url: 'pcInfo/source/json/month.json',
            url: config.kUrl + setRequestParam('week', sCode),
            type: 'GET',
            // data: setRequestParam('week'),
            tag: "300",
            loadingPlugin: null
        }),
        ajaxRequest({
            // url: 'pcInfo/source/json/year.json',
            url: config.kUrl + setRequestParam('month', sCode),
            type: 'GET',
            // data: setRequestParam('month'),
            tag: "400",
            loadingPlugin: null
        })).done(function(minData, minData1, minData2, dayData, weekData, monthData) {
        //结束加载
        if (loadingPlugin) {
            loadingPlugin.stop();
        }

        if (minData && dayData && weekData && monthData) {
            if (minData.code != 0 || minData1.code != 0 || minData2.code != 0 || dayData.code != 0 || weekData.code != 0 || monthData.code != 0) {
                chartNotData(true);
                return;
            }
        }
        if (!minData || !minData1 || !minData2 || !dayData || !weekData || !monthData) {
            chartNotData(true);
            return;
        }

        chartNotData(false);
        // console.log("start",minData, minData1, minData2, dayData, weekData, monthData);
        initDetailData(minData.data, minData1.data, minData2.data);
        
        if (initCode == config.code1) {
            minChart(minData1, flag);
        } else if (initCode == config.code2) {
            minChart(minData2, flag);
        } else {
            minChart(minData, flag);
        }
        KlineChart(config.elements.dayWrap, dayData, "dayChart", flag);
        KlineChart(config.elements.weekWrap, weekData, "weekChart", flag);
        KlineChart(config.elements.monthWrap, monthData, "monthChart", flag);        
        // switchTabsInfo(1);
        config.elements.clickflag = true;

    }).fail(function(data) {
        //结束加载
        if (loadingPlugin) {
            loadingPlugin.stop();
        }
        szse.ajaxErrorTip(data);
        chartNotData(true);
    })
}

function chartNotData(flag){
    if(flag){
        noDataShow();        
        document.getElementById("chart-notdata").style.display = "block";
        if (!szse.hasWeb()) {
            document.getElementById("chart-notdata").innerHTML = '<div id="errorBox"><div class="error"><div class="errorImg"></div><div class="slogan"><p>无网络连接<br/>点击屏幕重新加载</p></div></div></div>';
        } else {
            szse.noData("chart-notdata");
        }
    }else{
        document.getElementById("chart-notdata").style.display = "none";
    }
}


function minChart(data, flag) {
    // console.log(data.data);
    buildBasicInfo(data.data);
    buildUpdateTime(data.datetime, $('.mainquery-container'));
    chartHight();
    var chartData = {
        data: data,
        grid: {
            index: [
                ['7%', 0, '48%', 0],
                ['65%', 0, '5%', 0]
            ]
        }
    };

    if (flag) {
        //实例化证券分时图
        var chart = new s.ui.controls.mLineChart(config.elements.minuteWrap, chartData);
        config.charts.minuteChart = chart;
    } else  {
        config.charts.minuteChart.updateOption(chartData);
    }
}

function KlineChart(ele, data, chartName, flag) {

    chartHight();

    var chartData = {
        data: data,
        grid: [
            ['7%', 0, '48%', 0],
            ['65%', 0, '5%', 0]
        ]
    };

    if (flag) {
        //实例化证券日线图
        var chart = new s.ui.controls.kLineChart(ele, chartData);
        config.charts[chartName] = chart;
    } else {
        config.charts[chartName].updateOption(chartData);
    }
    config.charts[chartName].toolTipCallback = toolTipCallback;
}

function noDataShow() {
    var noDataObJ = {
        amount: null,
        close: null,
        code: null,
        delta: null,
        deltaPercent: null,
        high: null,
        low: null,
        marketTime: null,
        name: null,
        now: null,
        open: null,
        volume: null
    };
    initDetailData(noDataObJ, noDataObJ, noDataObJ);
    buildBasicInfo(noDataObJ);
    chartHight();
}
//渲染更新时间
function buildUpdateTime(time, container) {
    time = time || '';
    var html = '<span class="update-time">' + time + '</span>';

    container.find('.update-time').remove();
    container.append($(html));
}
//设置请求数据
function setRequestParam(flag, code) {
    var data = {};
    var str;
    switch (flag) {
        case 'minute':
            data = {
                marketId: 1,
                code: code
            };
            break;
        case 'day':
            data = {
                cycleType: 32,
                marketId: 1,
                code: code
            };
            break;
        case 'week':
            data = {
                cycleType: 33,
                marketId: 1,
                code: code
            };
            break;
        case 'month':
            data = {
                cycleType: 34,
                marketId: 1,
                code: code
            };
            break;

    }
    var cycleTypeStr = data.cycleType ? "cycleType=" + data.cycleType + "&" : "";
    str = cycleTypeStr + "marketId=" + data.marketId + "&" + "code=" + data.code
    return str;
}
//渲染行情详细信息
function buildBasicInfo(obj) {
    var template = _.template(config.template.trendTemStr);
    // obj = formatterData(obj);
    var html = template(obj);
    config.elements.detailContent = html;
    config.elements.trendDetailWrap.empty().append(html);
}

function formatterData(obj) {
    var dataObj = obj;

    var reg = /^\-/;
    titleContent(dataObj.name, dataObj.code);

    dataObj.newIsDown = reg.test(dataObj.deltaPercent); //false 涨   true 跌
    dataObj.openIsDown = +dataObj.open < +dataObj.close ? true : false;
    dataObj.highIsDown = +dataObj.high < +dataObj.close ? true : false;
    dataObj.lowIsDown = +dataObj.low < +dataObj.close ? true : false;

    calcuUnit(dataObj); //计算成交量、成交额单位    
    obj.deltaPercent = (Math.abs(parseFloat(obj.deltaPercent)) || Math.abs(parseFloat(obj.deltaPercent))==0) ? Math.abs(parseFloat(obj.deltaPercent)) : null;
    obj.delta = (Math.abs(parseFloat(obj.delta)) || Math.abs(parseFloat(obj.delta))==0) ? Math.abs(parseFloat(obj.delta)) : null;    
    return dataObj;
}

//设置头部信息
function initDetailData(data, data1, data2) {    
    config.tabInfoObj = {
        sData: formatterData(data),
        cData: formatterData(data1),
        zData: formatterData(data2)
    };
    initTopData(config.tabInfoObj);

}
//点击图表显示对应数据 在头部
function toolTipCallback(data) {
    var newData = config.tabInfoObj;
    switch (config.tabIndex) {
        case 0:
            unitData(data, newData.sData);
            break;
        case 1:
            unitData(data, newData.cData);
            break;
        case 2:
            unitData(data, newData.zData);
            break;
    }
    if(config.changeTopInfo){
        initTopData(newData);
    }
}

function initTopData(data) {
    var newTemplate = _.template(config.template.newTemStr);
    var newHtml = newTemplate(data);
    console.log("tab",data);
    config.elements.newInfoWrap.empty().html(newHtml);
    var divWidth = config.elements.newInfoWrap.find("div.mui-col-xs-4").eq(0).outerWidth();
    var tabAction = (config.tabIndex + 1) * divWidth - divWidth / 2;
    $(".tab-active").css('left', tabAction - 10 + 'px');
}


function unitData(nData, oData) {
    $.each(nData, function(nk, nv) {
        $.each(oData, function(ok, ov) {
            if (nk == ok) {
                oData[ok] = nData[nk];
            }
        });
    });
}

//计算成交量、成交额单位
function calcuUnit(obj) {
    var hundredMillion = 100000000;
    var tenThousand = 10000;

    if (obj.volume / hundredMillion >= 1) { //成交量
        obj.volume = (obj.volume / hundredMillion).toFixed(2); //以亿为单位
        obj.volumeUnit = '亿手';
    } else if (obj.volume / tenThousand >= 1) {
        obj.volume = (obj.volume / tenThousand).toFixed(2); //以万为单位
        obj.volumeUnit = '万手';
    } else {
        obj.volumeUnit = '手';
    }

    if (obj.amount / hundredMillion >= 1) { //成交额
        obj.amount = (obj.amount / hundredMillion).toFixed(2); //以亿为单位
        obj.amountUnit = '亿元';
    } else if (obj.amount / tenThousand >= 1) {
        obj.amount = (obj.amount / tenThousand).toFixed(2); //以万为单位
        obj.amountUnit = '万元';
    } else {
        obj.amountUnit = '元';
    }
}

//成交概况、行情tabs切换	
function switchTabs() {
    config.elements.trendTabs.delegate('>li', 'click', function(e) { //行情日线tab切换
        var index = $(this).index();
        if (!(config.elements.clickflag)) {
            return false;
        }
        if (index == 0) {
            config.elements.trendDetailWrap.html(config.elements.detailContent);
            switchTabsInfo(1);
        } else {
            // config.changeTopInfo = true;
            if (e) {
                switchTabsInfo(1);
            } else {
                switchTabsInfo(index);
            }
        }
        config.chartTabIndex = index;
        $(this).addClass('active').siblings('li').removeClass('active');
        $('.tab-panel').find('.MA-wrap li .value').text('--');
        $('.tab-panel').removeClass('active').eq(index).addClass('active');
    });
}

//指数切换
function exponentTab() {
    config.elements.newInfoWrap.delegate(".mui-col-xs-4", 'click', function(e) {
        var index = $(this).index();
        var thisWidth = $(this).outerWidth();
        var hasChart = false;
        config.tabIndex = index;
        $(this).addClass('active').siblings('.mui-col-xs-4').removeClass('active');
        $('.tab-panel').find('.MA-wrap li .value').text('--');
        if(config.charts.minuteChart && config.charts.dayChart && config.charts.weekChart && config.charts.monthChart){
            hasChart = false;
        }else{
            hasChart = true;
        }

        switch (index) {
            case 0:
                setChartData(hasChart);
                break;
            case 1:
                setChartData(hasChart, config.code1);
                break;
            case 2:
                setChartData(hasChart, config.code2);
                break;
        }
        initTopData(config.tabInfoObj);
    })
}

function switchTabsInfo(index) {
    var data, dataLen, chartData;
    switch (index) {
        case 1:
            config.charts.dayChart.thisLastData();
            break;
        case 2:
            config.charts.weekChart.thisLastData();
            break;
        case 3:
            config.charts.monthChart.thisLastData();
            break;
    }
}

function titleContent(name, code) {
    $(".title-text p").text(name);
    $(".title-text span").text(code);
}

function topBindEvent() {
    // 返回
    mui('body').on('tap', '#bar', function() {
        if (!domain.storageFlag) {
            //浏览器打开方式
            mui.openWindow({
                'url': 'search.html'
            });
        } else {
            szse.nativeOpenHtml(1, 'search.html');
        }
        return false;
    });
    // mui('nav').on('tap', '#sideMenu', function() {
    //     szse.openSilde();
    // });

    mui('nav').on('tap', '#leftBack', function() {
        szse.close();
    });
}

