//页面统一配置
var config = {
    template: { // --------------------------模板
        trendTemStr: $('#trendTemplate').html(), //行情详细数据
    },
    minuteUrl: domain.marketweb + 'ssjjhq/getTimeData?', //分时url
    kUrl: domain.marketweb + 'ssjjhq/getHistoryData?', //k线url
    charts: {},
    code: '399001'
}

window.initial = function() {
    initElements();
    refreshMaket(true);
};

function getCode() {
    config.code = "399001";
}

//初始化dom元素
function initElements() {
    config.elements = {
        trendWrap: $('.trend-wrap'), //行情容器
        trendPic: $('.pic-chart', '.trend-wrap'), //行情图形
        minuteWrap: $('#minutely'), //分时图
        dayWrap: $('#daily'), //日线
        weekWrap: $('#weekly'), //周线
        monthWrap: $('#monthly'), //月线
        trendTabs: $('.pic-tabs', '.trend-wrap'), //行情tabs
        trendDetailWrap: $('.detail-info'), //行情详细信息容器,
        detailContent: null,
        clickflag: false,
        isStorage:false,
        noWifiHtml:'<div id="errorBox"><div class="error"><div class="errorImg"></div><div class="slogan"><p>无网络连接</p></div></div></div>'
    }
}

//刷新数据
function refreshMaket(flag){
    var stockData;
    var stckCode = szse.getStockCode();
    var falg = falg?falg:false;
    var loadingPlugin = window.Loading(config.elements.trendPic);
    //开始加载
    if (loadingPlugin) {
        loadingPlugin.start();
    }
    if(stckCode == "0"){
        stockData = szse.getStockData();
        succseRefresh(stockData,loadingPlugin,flag);
    }else{
        errorRefresh(stckCode,loadingPlugin);
    }
}

function succseRefresh (data,loadingPlugin,flag){
    if(data && data != ""){
        var minData = JSON.parse(data);
        //结束加载
       if (loadingPlugin) {
           loadingPlugin.stop();
       }
       minChart(minData, flag);
    }
}

function errorRefresh(data,loadingPlugin){
    //结束加载
    if (loadingPlugin) {
        loadingPlugin.stop();
    }
    szse.ajaxErrorTip(data);
    if(!config.elements.isStorage){
        if (!szse.hasWeb()) {
            document.getElementById("trend-wrap").innerHTML = config.elements.noWifiHtml;
        } else {
            szse.noData("trend-wrap");
        }
    }
}


function minChart(data, flag) {
    config.elements.isStorage = true;
    buildBasicInfo(data.data);
    buildUpdateTime(data.datetime, $('.mainquery-container'));
    var chartData = {
        data: data,
        grid: {
            index: [
                ['10%', 0, '10%', 0],
                // ['65%', 0, '5%', 0]
            ]
        }
    };

    if (flag) {
        //实例化证券分时图
        var chart = new s.ui.controls.mLineChart(config.elements.minuteWrap, chartData);

        config.charts.minuteChart = chart;
    } else {
        config.charts.minuteChart.updateOption(chartData);
    }
}

//改变行情触发tooltip 设置
window.longTapMarket = function(flag){
    if(flag){
        config.charts.minuteChart.getInstance(true);
    }else{
        config.charts.minuteChart.getInstance(false);
    }
}

//渲染更新时间
function buildUpdateTime(time, container) {
    time = time || '';
    var html = '<span class="update-time">' + time + '</span>';

    container.find('.update-time').remove();
    container.append($(html));
}

//设置请求数据
function setRequestParam(flag) {
    var data = {};
    var str;
    switch (flag) {
        case 'minute':
            data = {
                marketId: 1,
                code: config.code
            };
            break;
        case 'day':
            data = {
                cycleType: 32,
                marketId: 1,
                code: config.code
            };
            break;
        case 'week':
            data = {
                cycleType: 33,
                marketId: 1,
                code: config.code
            };
            break;
        case 'month':
            data = {
                cycleType: 34,
                marketId: 1,
                code: config.code
            };
            break;

    }
    var cycleTypeStr = data.cycleType ? "cycleType=" + data.cycleType + "&" : "";
    str = cycleTypeStr + "marketId=" + data.marketId + "&" + "code=" + data.code
    return str;
}

//渲染行情详细信息
function buildBasicInfo(obj) {
    var template = _.template(config.template.trendTemStr);
    var reg = /^\-/;
    obj.newIsDown = reg.test(obj.deltaPercent); //false 涨   true 跌
    obj.openIsDown = +obj.open < +obj.close ? true : false;
    obj.highIsDown = +obj.high < +obj.close ? true : false;
    obj.lowIsDown = +obj.low < +obj.close ? true : false;

    calcuUnit(obj); //计算成交量、成交额单位

    obj.deltaPercent = Math.abs(parseFloat(obj.deltaPercent)) ? Math.abs(parseFloat(obj.deltaPercent)) : null;
    obj.delta = Math.abs(parseFloat(obj.delta)) ? Math.abs(parseFloat(obj.delta)) : null;

    var html = template(obj);
    config.elements.detailContent = html;
    config.elements.trendDetailWrap.empty().append(html);
}
//计算成交量、成交额单位
function calcuUnit(obj) {
    var hundredMillion = 100000000;
    var tenThousand = 10000;

    if (obj.volume / hundredMillion >= 1) { //成交量
        obj.volume = (obj.volume / hundredMillion).toFixed(2); //以亿为单位
        obj.volumeUnit = '亿手';
    } else if (obj.volume / tenThousand >= 1) {
        obj.volume = (obj.volume / tenThousand).toFixed(2); //以万为单位
        obj.volumeUnit = '万手';
    } else {
        obj.volumeUnit = '手';
    }

    if (obj.amount / hundredMillion >= 1) { //成交额
        obj.amount = (obj.amount / hundredMillion).toFixed(2); //以亿为单位
        obj.amountUnit = '亿元';
    } else if (obj.amount / tenThousand >= 1) {
        obj.amount = (obj.amount / tenThousand).toFixed(2); //以万为单位
        obj.amountUnit = '万元';
    } else {
        obj.amountUnit = '元';
    }
}
