import NewList from '../template/newPublicList.art';
import NODATA from '../../../../webApp/common/source/components/noData/noData.art';
import RUNTIME from 'art-template/lib/runtime';
import '../../../../webApp/common/source/components/noData/noData.scss';

"use strict"

//构建主页对象
var Main = function () {
    this.searchUrl = domain.discweb + "announcement/annList"; //查询基金公告历史URL
    this.openDetailUrl = domain.discweb + "announcement/bulletin_detail/"; //获取正文连接
    this.deceleration = mui.os.ios ? 0.003 : 0.0009;
    this.pageNum = 1;
    // this.id = window.location.pathname.substring(window.location.pathname.lastIndexOf('module/')+7,window.location.pathname.lastIndexOf('_'));
    // switch (this.id) { 
    //     case '240':
    //         this.code = 'bondinfoNotice_disc';
    //         break;
    //     case '230':
    //         this.code = 'fundinfoNotice_disc';
    //         break;  
    //     case '220':
    //         this.code = 'listedNotice_disc';
    //         break;
    // }
}

// export default Main
window.mainDisc = new Main();

// 用于标记用户是否选择时间筛选
var flag = true,
    cacheFlag = null,
    dateObj = {
        startDate: '',
        endDate: ''
    };

/**
 * 日期筛选传递参数函数，该函数为native调用函数
 * @param  {String} startDate       起始时间
 * @param  {String} endDate         结束时间
 * @param  {String} type            筛选范围类型 全部 all 本周 week 本月 month 自定义 custom
 */
window.getQueryDate = function(startDate,endDate,type) {
    if (startDate && endDate) {
        dateObj.startDate = startDate;
        dateObj.endDate = endDate;
    } else {
        dateObj.startDate = '';
        dateObj.endDate = '';
    };
    flag = false;
    cacheFlag = szse.judgeCache('disc' + mainDisc.tag);
    mainDisc.pageNum = 1;
    var $iconFilter = document.getElementById('header').getElementsByClassName('mui-icon-filter')[0];
    $iconFilter.classList.remove('week');
    $iconFilter.classList.remove('month');
    $iconFilter.classList.remove('custom');
    if (type != 'all') {
        $iconFilter.classList.add(type);
    }
    
    if (mui.os.android) {
        if (!cacheFlag) { // 判断是否有缓存
            szse.load(true);
        } else {
            szse.load(false);
            mainDisc.render(szse.getStorage('disc' + mainDisc.tag)); // 渲染缓存
        }
    }
    mainDisc.getData();
    mainDisc.hasScroll(); //启动页面滚动
    mainDisc.refresh(); //刷新控件
};

//init函数
Main.prototype.init = function (params, tag) {
    this.channelCode = params;
    this.tag = tag;
    this.storageFalg = szse.judgeCache('disc' + this.tag);
    // art-template日期格式注册  
    RUNTIME.dateFormat = function (date, format) {
        var format = szse.formatDate(date, format);
        format = format.split("00:00:00")[0];
        return format;
    };

    if (!this.storageFalg) { // 判断是否有缓存
        szse.load(true);
    } else {
        szse.load(false);
        this.render(szse.getStorage('disc' + this.tag)); // 渲染缓存
    }

    this.getData(); 
    this.hasScroll(); //启动页面滚动
    this.refresh(); //刷新控件
    this.liEvent();
};

//启动页面滚动
Main.prototype.hasScroll = function () {
    var _this = this;
    mui('.mui-scroll-wrapper').scroll({
        bounce: false,
        indicators: false, //是否显示滚动条
        deceleration: _this.deceleration
    });
};

//上拉下拉数据
Main.prototype.refreshData = function (refreshEvent) {
    if (refreshEvent == "up") {
        this.pageNum++;
    } else {
        this.pageNum = 1;
    }
    this.getData(); 
};

// 下拉上拉刷新
Main.prototype.refresh = function () {
    var self = this;

    mui.init({
        pullRefresh: {
            container: '#pullrefresh', // 刷新容器
            down: {
                callback: pulldownRefresh, // 必选，刷新函数
                auto: false, // 可选,默认false.首次加载自动下拉刷新一次
            },
            up: {
                callback: pullupRefresh, // 必选，刷新函数
                height: 100, // 可选.默认50.触发上拉加载拖动距离
                auto: false, // 可选,默认false.自动上拉加载一次
                contentrefresh: "正在加载...", // 可选，正在加载状态时，上拉加载控件上显示的标题内容
                contentnomore: '没有更多数据了' // 可选，请求完毕若没有更多数据时显示的提醒内容
            }
        }
    });

    // 下拉刷新具体业务实现
    function pulldownRefresh() {
        var text = document.getElementsByClassName("mui-pull-caption");
        if (szse.hasWeb()) {
            setTimeout(function () {
                text[0].innerHTML = '刷新成功';
            }, 950); 
        };
        setTimeout(function () {
            // 更新数据
            self.refreshData("down");
            // 关闭下拉刷新雪花图
            mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
            // 重打开上拉加载
            // mui('#pullrefresh').pullRefresh().endPullupToRefresh(false);
        }, 1900);
    };

    // 上拉加载具体业务实现 
    function pullupRefresh() {
        var _this = this;
        setTimeout(function () {
            // 更新数据
            self.refreshData("up");
            // 关闭上拉加载雪花图	
            _this.endPullupToRefresh(false);
        }, 3000);
    };

};

//获取数据
Main.prototype.getData = function () {
    var self = this;
    var dataJson = {
        channelCode: [self.channelCode],
        pageSize: 20,
        pageNum: self.pageNum,
        seDate: [dateObj.startDate, dateObj.endDate]
    };

    szse.ajax({
        url: self.searchUrl,
        contentType: "json",
        type: "POST",
        data: dataJson,
        tag: self.tag,
        success: function (data) {
            //取消loading页面
            szse.load(false); 
            szse.error(false);
            if (data) { 
                data.showCode = self.tag;
                self.substrAndConvert(data); 
                if (self.pageNum == 1) {
                    szse.setStorage('disc' + self.self, data);
                }
                if (self.pageNum == 1 && !flag) {
                    mui('#main')[0].style.transform = 'translate3d(0px, 0px, 0px)'; 
                }
                if (self.pageNum == 1 && data.data.length == 0) {
                    mui('.mui-table-view')[0].innerHTML = NODATA();
                    return;
                } else if (self.pageNum > 1 && data.data.length == 0) { //判断是否是第一页，如果不是第一页 并且返回数据是空 则弹出自动消失提示框
                    szse.toast('暂无更多数据！');
                    return;
                } else {  
                    self.render(data); 
                }
            }
        }, 
        error: function (data) {
            // 取消loading页面
            szse.load(false);
            szse.ajaxErrorTip(data);
            if (!self.storageFalg) {
                if (self.pageNum == 1 && !szse.hasWeb()) {
                    szse.error(true);
                    mui("body").on('tap', '#errorBox', function () {
                        // window.location.reload();
                        self.init(self.channelCode,self.tag);
                    });
                } else if (self.pageNum == 1) {
                    szse.noData('main');
                };
            }
        }
    })
};

// 渲染
Main.prototype.render = function (data) {
    if (this.pageNum <= 1) {
        document.getElementById("content").getElementsByClassName("mui-table-view")[0].innerHTML = NewList(data);
    } else {
        var oldHtml = document.getElementById("content").getElementsByClassName("mui-table-view")[0].innerHTML;
        var newHtml = oldHtml + NewList(data);
        document.getElementById("content").getElementsByClassName("mui-table-view")[0].innerHTML = newHtml;
    }
}

// 绑定事件
Main.prototype.liEvent = function () {
    mui(".mui-table-view").on("tap", ".mui-table-view-cell a", function () {
        var fileUrl = this.getAttribute("fileUrl");
        szse.nativeOpenDoc(domain.downloadUrl + fileUrl);// 打开附件 
    });
};

/**
 * 
 * @param {*} data 
 * 对请求回来的数据进行切割转换，附件大小显示格式(k、B、G)，附件类型(doc,pdf等)小写转大写，文章标题切割
 */
Main.prototype.substrAndConvert = function (data) {
    return data.data.forEach(function (value, index, arr) {
        data.data[index]['publishYears'] = value.publishTime.substr(0, value.publishTime.indexOf(' '));
        data.data[index]['publishTimeDivision'] = value.publishTime.substr((value.publishTime.indexOf(' ') + 1), 5);
        if (value.attachSize >= 1024 && value.attachSize < 1048576) {
            data.data[index]['convertedToMB'] = (value.attachSize / 1024).toFixed(2);
        } else if (value.attachSize >= 1048576) {
            data.data[index]['convertedToG'] = (value.attachSize / 1048576).toFixed(2);
        }
        if (value.attachFormat) {
            data.data[index]['attachToUpperCase'] = value.attachFormat.slice(0, 3).toUpperCase();
        }
        if ((value.title.indexOf(':') == -1) && (value.title.indexOf('：') == -1)) {
            return;
        } else {
            data.data[index]['colonBeforeIsNum'] = value.title.substr(0, (value.title.indexOf(':') == -1) ? value.title.indexOf('：') : value.title.indexOf(':'));
            data.data[index]['colonAfterIsNum'] = value.title.substr((value.title.indexOf(':') == -1) ? (value.title.indexOf('：') + 1) : (value.title.indexOf(':') + 1));
            if (/[0-9]/.test(data.data[index]['colonBeforeIsNum']) && /[0-9]/.test(data.data[index]['colonAfterIsNum'])) {
                return;
            } else {
                data.data[index]['secTitle'] = data.data[index]['colonBeforeIsNum'];
                data.data[index]['titleText'] = data.data[index]['colonAfterIsNum'];
            }
        }
    });
};