import HOME_PAGE from "../template/search/homePage.art";
import SUGGEST from "../template/search/suggest.art";//联想搜索模板
import SEARCH from "../template/search/search.art";//搜索主体上拉下拉
import SEARCH_ITEM from "../template/search/searchItem.art";//搜索列
import RUNTIME from 'art-template/lib/runtime';
import NODATA from "../template/search/noData.art";
import NOWEB from "../template/search/noWeb.art";
import LOADING from "../template/search/loading.art";
import '../scss/search.scss';

"use strict";

//首页对象类
var HomePageClass = {
    createNew: function() {
        var homePage = {};

        //初始化函数
        homePage.init = function(data) {
            mui('#main')[0].setAttribute('name', 'homePage');
            homePage.render(data);
            homePage.bindEvent();
        };

        homePage.render = function(data) {
            MainClass.Search.showElm(false);
            MainClass.Suggest.showElm(false);
            MainClass.HomePage.showElm(true);

            if(!document.getElementById('inputTag').activeElement){
                setTimeout(function(){
                    console.log(document.getElementById('inputTag')); 
                },2000)
            }

            document.getElementById('main').innerHTML = HOME_PAGE(data);
        };

        homePage.bindEvent = function() {
            mui('#homePage').on('tap', '.items', function(e) {
                var tag = e.target.innerText;
                document.getElementById('inputTag').value = tag;
                document.getElementById('clear').style.display = 'block';
                document.getElementById('speedBtn').style.display = 'none';
                MainClass.Search.fetch(tag,true);
                MainClass.Search.updataHistory(tag);
            });

            mui('#homePage').on('tap', '#clean', function() { //清除记录按钮
                MainClass.data.history = '';
                homePage.init(MainClass.data);
            });

            if (mui.os.ios && (document.body.clientHeight < 768)) {
                mui('header')[0].style.height = '1.97333rem';
                mui('header')[0].style.paddingTop = '0.93333rem';
                mui('#main')[0].style.marginTop = '1.97333rem';
                // mui('#main')[0].style.height = '14.66667rem';
                mui('#sug')[0].style.marginTop = '1.97333rem';
                // mui('#sug')[0].style.height = '14.66667rem';
                mui('#cbody')[0].style.marginTop = '1.97333rem';
                // mui('#cbody')[0].style.height = '14.66667rem';
                mui('#searchBar input')[0].style.height = '0.85333rem';
            }
        };
        homePage.showElm = function(flag){
            var str;
            flag ? str = "block" : str = "none";
            document.getElementById('main').style.display = str;
        };
        return homePage;
    }
};

//联想搜索对象类
var SuggestClass = {
    createNew: function() {
        var suggest = {};

        //初始化函数
        suggest.init = function(params) {
            MainClass.Search.showElm(false);
            MainClass.HomePage.showElm(false);
            MainClass.Suggest.showElm(true);
            mui('#main')[0].setAttribute('name', 'suggest');
            document.getElementById('sug').innerHTML = LOADING({});
            suggest.fetch(params);
        };

        suggest.fetch = function(params) {
            //取消上次请求
            szse.cancelHttp('70002');
            szse.ajax({
                // url: 'source/js/search/suggest.json',
                // type: "GET",
                url: domain.cmsweb + '/api/search/suggest',
                type: "POST",
                contentType: "form",
                data: {
                    'keyword': params,
                    'size': '20',
                    'json': 'true'
                },
                tag: '70002',
                success: function(data) {
                    suggest.render({ 'data': data.data, 'tag': params });
                },
                error: function(xhr, type, errorThrown) {
                    suggest.render({ 'data': [], 'tag': params });
                    console.warn('数据获取失败\n' + '接口：' + xhr.responseURL + '\n类型：' + type + '\n详情：' + errorThrown);
                }
            });
        };

        suggest.render = function(data) {
            document.getElementById('sug').innerHTML = SUGGEST(data);
            suggest.bindEvent(data.tag);
        };

        suggest.bindEvent = function(params) {
            mui('#suggestList').on('tap', '.suggest', function() {
                var tag = this.getAttribute('value');
                document.getElementById('inputTag').value = tag;
                document.getElementById('sug').innerHTML = '';
                MainClass.Search.fetch(tag,true);
                MainClass.Search.updataHistory(tag);
            });

            mui('#suggestList').on('tap', '#moreSearch', function() {
                if(mui('section').length > 0){
                    if(MainClass.SearchBar.oldValue == params){
                        MainClass.Suggest.showElm(false);
                        MainClass.SearchBar.showBlur();
                        MainClass.Search.showElm(true);
                    }else{
                        MainClass.Search.fetch(params,true);
                        MainClass.Search.updataHistory(params);
                    }; 
                }else{
                    MainClass.Search.fetch(params,true);
                    MainClass.Search.updataHistory(params);
                }

               
            });
        };
        suggest.showElm = function(flag){
            var str;
            flag ? str = "block" : str = "none";
            document.getElementById('sug').style.display = str;
        };
        return suggest;
    }
};

//搜索结果对象类
var SearchClass = {
    createNew: function() {
        var search = {
            page: 1,
            totalSize: null
        };

        //初始化函数
        search.init = function(data) {
            mui('#main')[0].setAttribute('name', 'search');
            search.params = data;
            search.render();
            search.refresh();
            search.bindEvents();
        };
        search.showElm = function(flag){
            var str;
            flag ? str = "block" : str = "none";
            document.getElementById('cbody').style.display = str;
            if(!flag){
                search.showTips(false);
            }
        };
        search.updataHistory = function(params) {
            var tag = MainClass.data.history.data ? MainClass.data.history.data : [],
                l = tag.length;

            while (l--) {
                if (tag[l].title == params) {
                    tag.splice(l, 1);
                    break;
                }
            };

            tag.unshift({ title: params });

            MainClass.data.history = { 'data': tag };
        };

        search.fetch = function(params,flag) {
            
            if(flag){
                MainClass.Suggest.showElm(false);
                MainClass.Search.showElm(true);
                MainClass.HomePage.showElm(false);
                MainClass.SearchBar.showBlur();
                search.params = params;
                search.page = 1;
                search.totalSize = null;
                document.getElementById('content').innerHTML = '';
                mui('#searchList').pullRefresh().refresh(true);
            }

            if(search.page == 1){
                search.showTips(true,3);
            }

            //取消上次请求
            // szse.cancelHttp('70002');
            // szse.cancelHttp('70003');
            mui.ajax({
                url: domain.cmsweb + '/api/search/content',
                type: "POST",
                contentType: "application/x-www-form-urlencoded", 
                data: { 
                    'range': 'title',
                    'keyword': params, 
                    'currentPage': search.page,
                    'pageSize': '20',
                    'json': 'true', 
                    'orderby': 'score',
                    'channelCode':['announcement','bondinfoNotice_disc','fundinfoNotice_disc','listedNotice_disc']
                },
                timeout: 10000, //超时时间设置为10秒；
                success: function(data) {
                    if (data.code == 0) {
                        search.totalSize = Math.ceil(data.totalSize / 20); //计算总页数
                        //上拉加载注册
                        if (data.data.length == 0) {
                            if(search.page == 1){
                                search.showTips(true,1);
                            }
                        }else{
                            search.renderChild(data);
                        }
                    } else {
                        if(search.page == 1){
                            search.showTips(true,1);
                        }
                        console.warn(data.code + '---' + data.message);
                    }
                },
                error: function(xhr, type, errorThrown) {
                    if (szse.hasWeb()) {
                        if(search.page == 1){
                            search.showTips(true,1);
                        }else{
                            szse.ajaxErrorTip(xhr);
                        }
                    } else {
                        if(search.page == 1){
                            search.showTips(true,2);
                        }else{
                            szse.ajaxErrorTip(xhr);
                        }
                    }
                    console.warn('数据获取失败\n' + '接口：' + xhr.responseURL + '\n类型：' + type + '\n详情：' + errorThrown);
                }
            }); 
        };

        search.render = function(params) {
            //art时间格式注册
            RUNTIME.dateFormat = function(date, format) {
                var format = szse.formatDate(date, format);
                return format;
            };
            document.getElementById('cbody').innerHTML = SEARCH({});
            if (mui.os.ios && (document.body.clientHeight < 768)) {
                mui('#searchList')[0].style.top = '1.97333rem';
            }
        };

        search.showTips = function(flag,tipsNum){
            if(flag){
                if(tipsNum){
                    document.getElementById('error').style.display = 'block';
                    switch (tipsNum){
                        case 1:
                            document.getElementById('error').innerHTML = NODATA({});
                        break;
                        case 2:
                            document.getElementById('error').innerHTML = NOWEB({});
                        break;
                        case 3:
                            document.getElementById('error').innerHTML = LOADING({});
                        break;
                    }
                }
            }else{
                document.getElementById('error').style.display = 'none';
            }
        }
        search.renderChild = function(data) {
            search.showTips(false);
            var newNode = document.createElement("section");
            newNode.innerHTML = SEARCH_ITEM(data);
            document.getElementById('content').appendChild(newNode);
        };

        search.refresh = function() { // 上拉加载注册
            mui.init({
                pullRefresh: {
                    container: '#searchList', //刷新容器,
                    up: {
                        callback: pullupRefresh, //必选，刷新函数
                        height: 100, //可选.默认50.触发上拉加载拖动距离
                        auto: false, //可选,默认false.自动上拉加载一次
                        contentrefresh: "正在加载...", //可选，正在加载状态时，上拉加载控件上显示的标题内容
                        contentnomore: '没有更多数据了' //可选，请求完毕若没有更多数据时显示的提醒内容
                    }
                }
            });

            function pullupRefresh() {
                var _this = this;
                setTimeout(function() {
                    if (search.page++ >= search.totalSize) {
                        //判断最末页 - 禁用上拉加载
                        _this.endPullupToRefresh(true); //参数为true代表没有更多数据了。
                    } else {
                        search.fetch(search.params);
                        _this.endPullupToRefresh(false);
                    }
                }, 1000);
            };
        };

        search.bindEvents = function() { //事件注册
            mui('#cbody').on('tap', '.searchItem', function(e) {
                var tag = this.getAttribute('doctype').toLowerCase();
                var doctitle = this.childNodes[0].nextSibling.innerText;
                var docpuburl = this.getAttribute('docpuburl');
                var docpubjsonurl = this.getAttribute('docpubjsonurl');
                var chnlcode = this.getAttribute('chnlcode');
                if (mui.os.android) {
                    // 用于记录用户从哪进入详情页
                    window.localStorage.setItem('from','disclosureSearch'); 
                }
                switch (tag) {
                    case 'json':
                        try {
                            szse.nativeOpenHtml(4, docpubjsonurl, '详情', chnlcode, docpuburl);
                        } catch (err) {
                            szse.toast('此功能需要真机打开');
                        }
                        break;
                    case 'xml':
                        szse.toast('xml暂时不做处理');
                        break;
                    case 'link':
                        try {
                            szse.nativeOpenHtml(4, '', '', '', docpuburl);
                        } catch (err) {
                            szse.toast('此功能需要真机打开');
                        }
                        break;
                    default:
                        try {
                            szse.nativeOpenDoc(docpuburl);
                        } catch (err) {
                            szse.toast('此功能需要真机打开');
                        }
                        break;
                };
            });
            mui('#error').on('tap', '#noData', function() {
                var value = document.getElementById('inputTag').value;
                var text = document.getElementById('noData').getElementsByTagName('p')[0].innerText;
                if(text != "暂无数据" && text != "正在加载..."){
                    if(value){
                        MainClass.Search.fetch(value,true);
                        MainClass.Search.updataHistory(value);
                    }else{
                        location.reload();
                    }
                }
            });
        };

        return search;
    }
};

//搜索栏对象类
var SearchBarClass = {
    createNew: function() {
        var searchBar = {
            timer: null
        };
        // var micFalg = true;

        //初始化函数
        searchBar.barInit = function() {
            searchBar.clear();
            searchBar.speed();
            searchBar.inputBox();
            searchBar.callback();
            searchBar.enter(); 
            // searchBar.hasSpeech();
        };

        searchBar.clear = function() { //删除按钮
            mui('#bar').on('tap', '#clear', function() {

                document.getElementById('inputTag').value = '';
                document.getElementById('clear').style.display = 'none';
                document.getElementById('speedBtn').style.display = 'block';
                MainClass.HomePage.init(MainClass.data);
            });
        };

        searchBar.speed = function() { // 语音搜索
            mui('#bar').on('tap', '#speedBtn', function() {
                var self = this;
                var inputDom = document.getElementById('inputTag');
                         
                // 每次点击语音输入按钮都要重置getSpeech回调函数，因为所有的语音输入回调函数都是该函数，不覆盖可能会导致执行的代码块不正确
                window.getSpeech = function(str){
                    // 如果语音录入取得为空，则退出函数
                    if(!str) {
                        return;
                    };
                    inputDom.value = str; 
                    self.style.display = 'none';
                    document.getElementById('clear').style.display = 'block';
                    MainClass.Search.fetch(inputDom.value,true);
                    MainClass.Search.updataHistory(inputDom.value);      
                };
                // 调用原生语音输入方法
                if (mui.os.ios) {
                    // 调用原生语音输入方法
                    native.util.showSpeechSearch()
                } else {
                    android.showSpeechSearch()
                };
            });
        };

        searchBar.inputBox = function() { //输入框
            // flag为实现针对中文输入时，获取真实输入值而不是键盘输入变化
            var flag = true;
            mui('#searchBar').on('compositionstart', 'input', function() {
                flag = false;
            });
            mui('#searchBar').on('compositionend', 'input', function() {
                flag = true;
            });
            mui('#inputTag')[0].onfocus = function(){
                var value = document.getElementById('inputTag').value;
                MainClass.SearchBar['oldValue'] = value;
                if(value){
                    MainClass.Suggest.init(value);
                }
            };
            mui('#searchBar').on('input', '#inputTag', function() {
                if (searchBar.timer) {
                    clearTimeout(searchBar.timer);
                };
                searchBar.timer = setTimeout(function() { //联想输入延迟
                    if (flag) {
                        var value = document.getElementById('inputTag').value;
                        if (value) {
                            mui('#speedBtn')[0].style.display = 'none';
                            mui('#clear')[0].style.display = 'block';
                            MainClass.Suggest.init(value);
                        } else {
                            mui('#clear')[0].style.display = 'none';
                            mui('#speedBtn')[0].style.display = 'block';
                            MainClass.HomePage.init(MainClass.data);
                        }
                    }
                }, 250);
            });
        };

        searchBar.callback = function() { //返回
            mui('nav').on('tap', '#backBtn', function() {
                // szse.close();
                history.back();
            });
        };

        searchBar.enter = function() { //回车事件注册
            var form = document.getElementsByTagName("form")[0];
            form.onsubmit = function(e) {
                e.preventDefault();
                var value = document.getElementById('inputTag').value;
                setTimeout(function() {
                    if (value) {
                        if(mui('section').length > 0){
                            if(MainClass.SearchBar.oldValue == value){
                                MainClass.Suggest.showElm(false);
                                MainClass.SearchBar.showBlur();
                                MainClass.Search.showElm(true);
                            }else{
                                MainClass.Search.fetch(value,true);
                                MainClass.Search.updataHistory(value);
                            }
                        }else{
                            MainClass.Search.fetch(value,true);
                            MainClass.Search.updataHistory(value);
                        }
                    } else {
                        szse.toast('请输入搜索内容');
                    };
                }, 300)
            };
        };

        searchBar.showBlur = function(flag){//获取焦点显示 联想页面
           mui('#inputTag')[0].blur();
        };

        return searchBar;
    }
};

// 页面入口
window.initial = function() {
    //页面主体类
    window.MainClass = {
        HomePage: HomePageClass.createNew(), //定义主页类接口
        Suggest: SuggestClass.createNew(), //定义联想类接口
        Search: SearchClass.createNew(), //定义搜索类接口
        SearchBar: SearchBarClass.createNew(),//定义搜索框接口
        data: { //类公有数据
            $hotword: szse.getStorage('hotword'),
            get hotword() {
                return this.$hotword
            },
            set hotword(params) {
                this.$hotword = params;
                szse.setStorage('hotword', params); //设置缓存
            },
            $history: szse.getStorage('searchHistory'),
            get history() {
                return this.$history
            },
            set history(params) {
                this.$history = params;
                szse.setStorage('searchHistory', params); //设置缓存
            }
        },
        createNew: function() {
            var main = SearchBarClass.createNew(); //继承SearchBarClass

            //初始化函数
            main.init = function() {
                main.barInit();

                MainClass.HomePage.init(MainClass.data);
                MainClass.Search.init();
                main.fetch();

                //收起键盘注册
                mui('body').on('touchstart', '#main', function() {
                    document.getElementById("inputTag").blur();
                    szse.hideInputMethod();
                });
            };

            //数据获取
            main.fetch = function() {
                szse.ajax({
                    // url: 'source/js/search/hotword.json',
                    url: domain.cmsweb + '/index/hot/index.json',
                    contentType: "json",
                    type: "GET",
                    tag: 70001,
                    success: function(data) {
                        if (data.code == 0) {
                            MainClass.data.hotword = data;
                            MainClass.HomePage.init(MainClass.data);
                        } else {
                            console.warn('数据获取失败\n' + '详情：' + data.message);
                        }
                    },
                    error: function(xhr, type, errorThrown) {
                        console.warn('数据获取失败\n' + '接口：' + xhr.responseURL + '\n类型：' + type + '\n详情：' + errorThrown);
                    }
                });
            };

            return main;
        }
    };

    var main = MainClass.createNew();
    main.init();
};

// 物理返回键，该函数由安卓调用
window.historyBackFun = function(){
    $('#backBtn').click();
};